/*|------------------------------------------------------------------------------------------

 MAGELLAN X-Window Driver 				Version 3.11 07.03.97

 Logitech Inc.
 6505 Kaiser Drive
 Fremont, CA 94555-3615

 Volker Senft:

 Main:   (510) 795-8500
 Direct: (510) 713-4055
 Sales:  (800) 231-7717
 Fax:    (510) 505-0979

 27.06.95 VS  Datei erstellt
 21.09.95 VS  Status Fenster fuer IBM/CATIA unterdrueckt
 23.10.95 VS  DCD Problem bei SUN SunOS 5.4 behoben
 17.11.95 VS  Anzeige der Applikations-Empfindlichkeit
 14.12.95 VS  DSR/DCD Problem bei IBM RS6000/P43 behoben
 12.01.96 VS  Kill-Problem bei SUN/IBM behoben --> Startup
 18.01.96 VS  Status Display Flag Abfrage, Button Mapping fuer Gross- und Kleinschreibung
 18.01.96 VS  XON/XOFF fuer IBM eingefuehrt
 26.02.96 VS  Option -graphics eingefuehrt
 26.02.96 VS  XON/XOFF fuer IBM entfernt und DSR/DCD Behandlung rueckgaengig gemacht
 26.02.96 VS  IBM Hinweis fuer einen zweiten Adapter, IBM-9-25-25-9-Magellan
 29.02.96 VS  Externe lineare Skalierung eingefuehrt, BMW
 02.04.96 VS  Startup Ausgabe mit -startup
 03.04.96 VS  SDRC/I-DEAS Unterstuetzung
 16.04.96 VS  Dual Modus fuer Events Version 1.0 und Version 2.0/3.0, AUDI
 16.04.96 VS  Startup Directory Problem behoben
 25.04.96 VS  IBM Buffer Groesse aenderbar mit -ibmtty
 14.05.96 VS  Abbruch auf SGI, falls der sball/magellan Treiber aktiv ist 
 11.06.96 VS  Pro/Engineer Absturzproblem verbessert
 22.07.96 VS  EDS/Unigraphics Schnittstelle geoeffnet			3.09
 26.07.96 VS  Turbo Space Mouse Interface eingefuehrt
 26.07.96 VS  XON/XOFF Handshake bei IBM eingefuehrt
 26.07.96 VS  Receive Trigger Level bei IBM eingefuehrt
 26.07.96 VS  3D Wuerfel Graphik
 20.08.96 VS  Dialbox Mode fuer Daimler Benz eingefuehrt	
 11.10.96 VS  Compress Data fuer IBM Puffer Problem eingefuehrt		3.10
 25.11.96 VS  Fehler mit Taste <4> und <*> im dialmode behoben
 25.11.96 VS  chmod und tty check eingefuehrt
 07.03.97 VS  Fehler mit Keysym/Keycode und Shift/Alt/Ctrl behoben	3.11
------------------------------------------------------------------------------------------|*/ 
#include <stdio.h>
#include <time.h>

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <X11/keysym.h>

#include <unistd.h> 
#include <ctype.h> 
#include <termio.h> 
#include <termios.h> 
#include <fcntl.h> 
#include <stdlib.h> 
#include <unistd.h> 
#include <string.h> 
#include <math.h>
#include <signal.h>
#include <poll.h>
#include <pwd.h>

#include <sys/types.h> 
#include <sys/ipc.h> 
#include <sys/sem.h> 
#include <sys/stat.h> 
#include <sys/param.h>

#ifdef SGI
#include <stropts.h>
#endif

#ifdef HP
#include <X11/XHPlib.h>
#include <sys/termiox.h>
#include <sys/modem.h>
#endif

#ifdef IBM
#include <sys/rs.h>
#endif


#define YES  0
#define NO   1

float MagellanXWindowVersion = 3.11;

#define IBMBUFFERSIZE	8192

enum _CommandMessages_ { NoCommandMessage, 
                         CommandMessageApplicationWindowAlternate,
                         CommandMessageApplicationSensitivityAlternate,
			 CommandMessageStatusWindow = 17733, 
                         CommandMessageStatusData,
			 CommandMessageApplicationWindow = 27695, 
                         CommandMessageApplicationSensitivity };

#define XHigh32( Value )	(((Value)>>16)&0x0000FFFF)
#define XLow32( Value )		((Value)&0x0000FFFF)

union _MagellanTypeConversion_ {
 float Float;
 short Short[ 2 ];
};
typedef union _MagellanTypeConversion_ MagellanTypeConversion;

struct _MagellanStatusData_ {
 short Mode;
 short Compress;
 short SensTra, SensRot;
 short NullRadius;
 short Keyboard;
 MagellanTypeConversion ApplicationSensitivity;
};
typedef struct _MagellanStatusData_ MagellanStatusData;

#define Pi	3.14159265358979

typedef double	real;		/* Gleitkomma Zahl */

#define FRAMEROTm	3	/* m x n Rotations Frame */
#define FRAMEROTn	3
#define FRAMETRA	3


struct _MathFrame_ {
 real	MathRotation[FRAMEROTm][FRAMEROTn];
 real	MathTranslation[FRAMETRA];
};
typedef struct _MathFrame_ MathFrame;

struct _MathPoint_ {
 real	MathTranslation[FRAMETRA];
};
typedef	struct _MathPoint_ MathPoint;

#define MathPointX(Frame)	((Frame).MathTranslation[0])
#define MathPointY(Frame)	((Frame).MathTranslation[1])
#define MathPointZ(Frame)	((Frame).MathTranslation[2])

#define PLANEPOINTS		4

struct _MathPlane_ {
 MathPoint *PlanePoints[ PLANEPOINTS ];
 XColor *PlaneColor;
};
typedef struct _MathPlane_ MathPlane;

struct _MathVideo_ {
 real VideoRatio;
 real VideoMaxX, VideoMaxY;
 real VideoFocus;
};
typedef struct _MathVideo_ MathVideo;

/*|------------|*/
/*| Prototypes |*/
/*|------------|*/

#ifdef SGI 
#define ParameterCheck
#endif

#ifdef IBM 
#define ParameterCheck
#endif

int MagellanCompressDataNonLinear(
#ifdef ParameterCheck
int *,
int *,
int *,
int 
#endif 
);

void MagellanDebugBuffer(
#ifdef ParameterCheck
char *,
char *
#endif
);

char *MagellanHostComputer(
#ifdef ParameterCheck
void
#endif
);

char *LangString(
#ifdef ParameterCheck
int
#endif
);

char *XWindowString( 
#ifdef ParameterCheck 
Window 
#endif
);

int MagellanKeyboardEvent( 
#ifdef ParameterCheck 
Display *, char *,
Window MagellanWindow
#endif 
);

int MagellanDataEvent( 
#ifdef ParameterCheck 
Display *, char *,
Window MagellanWindow
#endif 
);

int MagellanOpen( 
#ifdef ParameterCheck 
char *, int 
#endif 
);

int MagellanClose( 
#ifdef ParameterCheck 
int 
#endif 
);

int MagellanRead( 
#ifdef ParameterCheck 
int, char *, int 
#endif 
);

int MagellanInitialize( 
#ifdef ParameterCheck 
int 
#endif 
);

int MagellanExist( 
#ifdef ParameterCheck 
void 
#endif 
);

char *MagellanVersion( 
#ifdef ParameterCheck 
int 
#endif 
);

int MagellanTransmit(
#ifdef ParameterCheck
int, char * 
#endif
);

int MagellanTransmitReceive( 
#ifdef ParameterCheck 
int, char *, char * 
#endif 
);

int MagellanSearchChoice( 
#ifdef ParameterCheck 
char *[] 
#endif 
);

char **MagellanCreateFileMenu( 
#ifdef ParameterCheck 
void 
#endif 
);

int MagellanNibble( 
#ifdef ParameterCheck 
int 
#endif 
);

int MagellanNibble6( 
#ifdef ParameterCheck 
int 
#endif 
);

int MagellanDevInput( 
#ifdef ParameterCheck 
char *SerialDevice,
char *DevInputCommand
#endif 
);

int MagellanProcessTTY( 
#ifdef ParameterCheck 
char *SerialDevice
#endif 
);

void MagellanProcessID( 
#ifdef ParameterCheck 
char *Program
#endif 
);

void MagellanDemonstration(
#ifdef ParameterCheck
Display *display, char *argv[], int argc
#endif
);

int MagellanSetWindow(
#ifdef ParameterCheck
Display *display, Window window
#endif
);

int MagellanErrorHandler(
#ifdef ParameterCheck
Display *display,
XErrorEvent *Error
#endif
);

void MagellanWait(
#ifdef ParameterCheck
clock_t WaitTime
#endif
);

int ApplicationChoice( 
#ifdef ParameterCheck 
int 
#endif 
);

int MagellanStatusDisplayChoice(
#ifdef ParameterCheck
int
#endif
);

int FileExist( 
#ifdef ParameterCheck 
char * 
#endif 
);

int FileExistRead( 
#ifdef ParameterCheck 
char * 
#endif 
);

char *FileConfig( 
#ifdef ParameterCheck 
char * 
#endif 
);

char *FileConfigDirectory(
#ifdef ParameterCheck
char *,
char *
#endif
);


int ConfigFileCreate( 
#ifdef ParameterCheck 
char *,
char *argv[]
#endif 
);

int KeyboardFileCreate(
#ifdef ParameterCheck
char *,
char *
#endif
);

char *ConfigReadLine(
#ifdef ParameterCheck
 char *Buffer,
 int BufferLength,
 FILE *Handle
#endif
);

int ConfigRead(
#ifdef ParameterCheck
 char *FileName
#endif
);
 

int ConfigWrite( 
#ifdef ParameterCheck 
char * 
#endif 
);

int ConfigSearch( 
#ifdef ParameterCheck 
char *, char *[] 
#endif 
);

char *ProgramName(
#ifdef ParameterCheck
char *FileName
#endif
);

void ParseArg( 
#ifdef ParameterCheck 
Display *display, char *[], int, int, int
#endif 
);

int MenuChoice( 
#ifdef ParameterCheck 
char *[], char * 
#endif 
);

int MenuInput( 
#ifdef ParameterCheck 
void 
#endif 
);

void PrintMenuTexte(
#ifdef ParameterCheck
char *Texte[]
#endif
);

int WindowKeyboard(
#ifdef ParameterCheck
Display *display, Window window, int keytype, KeySym key
#endif
);

KeySym XStringToKeysymTable(
#ifdef ParameterCheck
char *string
#endif
);

int SyntaxParser( 
#ifdef ParameterCheck
char *string,
char *parameter
#endif
);

int ButtonParser(
#ifdef ParameterCheck
Display *display,
Window window,
char *parserstring,
int action
#endif
);

int StringWindowKeyboard(
#ifdef ParameterCheck
Display *display,
Window window,
char *string
#endif
);

void FileKeyboardButtonStrings(
#ifdef ParameterCheck
char *FileName
#endif
);

char *FileKeyboard(
#ifdef ParameterCheck
char *FileName
#endif
);

char *FileKeyboardDirectory(
#ifdef ParameterCheck
char *FileName,
char *FileDirectory
#endif
); 
 
void NonLinearTranslation(
#ifdef ParameterCheck
int *v1, int *v2, int *v3
#endif
);

void NonLinearRotation(
#ifdef ParameterCheck
int *v1, int *v2, int *v3
#endif
);

char *XFontName(
#ifdef ParameterCheck
Display *display
#endif
);

char *XFontNameStatus(
#ifdef ParameterCheck
Display *display
#endif
);

void XSetColor(
#ifdef ParameterCheck
Display *display,
GC gc,
XColor *color
#endif
);

void XSetBackColor(
#ifdef ParameterCheck
Display *display,
GC gc,
XColor *color
#endif
);

void XDisplayButton(
#ifdef ParameterCheck
Display *display,
Window win,
GC gc,
int state,
XColor *fc,
XColor *bc,
int x,
int y,
int width,
int height,
XFontStruct *fn,
char *text
#endif
);

void XDisplayLevel(
#ifdef ParameterCheck
Display *display,
Window win,
GC gc,
double state,
XColor *tc,
XColor *fc,
XColor *bc,
int x,
int y,
int width,
int height,
XFontStruct *fn,
char *text
#endif
);

void MagellanStatusDisplay(
#ifdef ParameterCheck
Display *display,
Window win,
GC gc,
XFontStruct *fontname,
MagellanStatusData *data,
int update
#endif
);

void MagellanStatusPanel(
#ifdef ParameterCheck
Display *display,
Window window,
int argc,
char *argv[],
MagellanStatusData *data
#endif
);

void MagellanSetStatus(
#ifdef ParameterCheck
Display *display,
Window window,
MagellanStatusData *data,
Atom MagellanCommandEvent,
Window MagellanWindow
#endif
);

char *StringHex(
#ifdef ParameterCheck
long value,
int length
#endif
);

void XDebugClientMessage(
#ifdef ParameterCheck
Display *display,
XEvent *event,
char *message
#endif
);

short ReadColorValue(
#ifdef ParameterCheck
char *StringIn,
char **StringOut
#endif
);

void ReadColor(
#ifdef ParameterCheck
char *String,
XColor *Color
#endif
);

int MagellanSensitivityStep(
#ifdef ParameterCheck
double sensitivity
#endif
);

void MagellanTimerSignal(
#ifdef ParameterCheck
int sig
#endif
);

void MagellanDemonstrationCube( 
#ifdef ParameterCheck
Display *display,
char *argv[],
int argc
#endif
);

int DisplayCube( 
#ifdef ParameterCheck
Display *display,
Window window,
GC gc,
MathFrame *Frame,
MathVideo *Video
#endif
);

int DisplayPlane( 
#ifdef ParameterCheck
Display *display,
Window window,
GC gc,
MathPlane *Plane,
MathFrame *Frame,
MathVideo *Video 
#endif
);

void Math2DCoordinate(
#ifdef ParameterCheck
MathPoint *PointIn,
MathPoint *PointOut,
MathVideo *Parameter 
#endif
);

void Math2DTransformation( 
#ifdef ParameterCheck
MathPoint *PointIn,
MathPoint *PointOut,
real Focus 
#endif
);

void MathVectorProduct(
#ifdef ParameterCheck
MathPoint *Point1,
MathPoint *Point2,
MathPoint *Product 
#endif
);

real MathVectorScalar(
#ifdef ParameterCheck
MathPoint *Point1,
MathPoint *Point2 
#endif
);

void MathVectorSubtraction(
#ifdef ParameterCheck
MathPoint *Point1,
MathPoint *Point2,
MathPoint *Vector 
#endif
);

void MathFrameTransformation( 
#ifdef ParameterCheck
MathFrame *Frame,
MathPoint *PointIn,
MathPoint *PointOut 
#endif
);

void MathFrameMultiplication(
#ifdef ParameterCheck
MathFrame *FrameA,
MathFrame *FrameB,
MathFrame *FrameAB 
#endif
);

void MathFrameRotation(
#ifdef ParameterCheck
MathFrame *Frame,
real Roll,
real Pitch,
real Yaw
#endif
);

void MathFrameTranslation(
#ifdef ParameterCheck
MathFrame *Frame,
real X,
real Y,
real Z 
#endif
);

int ShellFile(
#ifdef ParameterCheck
char *, char *, char *
#endif
);

int IBMttyBufferSize(
#ifdef ParameterCheck
char *, int 
#endif
);

int IsWindowProEngineer(
#ifdef ParameterCheck
unsigned char * 
#endif
);

void MoveFinishProEngineer(
#ifdef ParameterCheck
Display *,
Window
#endif
);

int MagellanEnableString(
#ifdef ParameterCheck
Display *,
Window,
char *
#endif
);

void MagellanInterfaceEnable(
#ifdef ParameterCheck
void
#endif
);

char *StringRemoveSpace(
#ifdef ParameterCheck
char *
#endif
);



extern char *MagellanMode;
extern char *MagellanSensitivity;
extern char *MagellanNullRadius;
extern char MagellanNibbleTable[];
extern short MagellanNibbleTable6[];

#define MAGELLANCONFIG "MagellanConfig"
#define MAGELLANKEYBOARD "MagellanKeyboard"

char *ConfigFilePtr = NULL;
int ConfigFileExist;
char GlobalConfig[128], LocalConfig[128];

char *KeyboardFilePtr = NULL;
int KeyboardFileExist;
char GlobalKeyboard[128], LocalKeyboard[128];


/*|--------------------|*/
/*| Public Definitions |*/
/*|--------------------|*/

#ifndef TRUE
#define TRUE	(1==1)
#endif

#ifndef FALSE
#define FALSE	(1==0)
#endif

#define MakeColor(R,G,B) { 0,R*256,G*256,B*256,DoRed|DoGreen|DoBlue, 0 }

XColor RED 		= MakeColor( 255,0,0 );
XColor AQUAMARINE 	= MakeColor( 112,219,147 );
XColor VIOLET		= MakeColor( 159,95,159 );
XColor CADETBLUE	= MakeColor( 95,159,159 );
XColor CORNFLOWER	= MakeColor( 66,66,111 );
XColor CYAN		= MakeColor( 0,255,255 );
XColor MAROON		= MakeColor( 142,35,107 );
XColor MEDIUM		= MakeColor( 50,204,153 );

XColor GREEN	 	= MakeColor( 0,255,0 );
XColor BLUE		= MakeColor( 0,0,255 );
XColor STEELBLUE	= MakeColor( 143,143,188 );
XColor LIGHTGRAY	= MakeColor( 168,168,168 );
XColor BLACK		= MakeColor( 0,0,0 );
XColor WHITE		= MakeColor( 255,255,255 );

XColor BROWN		= MakeColor(0,255,255);
XColor YELLOW		= MakeColor(255,255,0);
XColor LIGHTRED		= MakeColor(255,0,0);
XColor LIGHTMAGENTA	= MakeColor(191,0,191);
XColor LIGHTBLUE	= MakeColor(0,0,191);


enum _Syntax_ { BUTTON=1, BEEP=2, DISABLE=4, ENABLE=8, MAPPING=16,
		SINGLEKEY=32, SINGLEKEYPRESS=64, SINGLEKEYRELEASE=128, 
		STRING=256, SYNTAXUNKNOWN=512 };

int _TRUE_ = TRUE;
int _FALSE_ = FALSE;

int XDriverDebug = FALSE;

extern double MagellanExternalScalingTranslation;
extern double MagellanExternalScalingRotation;
extern double MagellanExternalScalingTranslationX;
extern double MagellanExternalScalingTranslationY;
extern double MagellanExternalScalingTranslationZ;
extern double MagellanExternalScalingRotationA;
extern double MagellanExternalScalingRotationB;
extern double MagellanExternalScalingRotationC;
extern int MagellanExternalScalingPrint;

/*|-------------------------------------------------------|*/
/*| Language extensions for the Magellan X Window  Driver |*/
/*|-------------------------------------------------------|*/

enum _languages_ { GERMAN, ENGLISH, FRENCH, SPAIN, LANGUAGES };
int Language = ENGLISH;

enum _devicenames_ { SPACEMOUSE, MAGELLAN };
int DeviceName = MAGELLAN;

enum _customerlocations_ { EUROPE, AMERICA, ASIA, AFRICA, AUSTRALIA };
int CustomerLocation = EUROPE;

enum _strings_ { LANG_VERSION1, LANG_VERSION2, LANG_DEVICENAME, LANG_COPYRIGHT,
 LANG_VERSION3, LANG_MENUCHOICE, LANG_YOURCHOICE, LANG_ABORT, LANG_ILLEGAL,
 LANG_USECONFIG, LANG_USERECONFIG, LANG_NAMETOLONG, LANG_LANGUAGETITLE,
 LANG_CONTINENTTITLE, LANG_APPLICATIONTITLE, LANG_MAGELLANFILE,
 LANG_FILEMENUTITLE, LANG_PLEASEWAIT, LANG_MAGELLANNOTFOUND, 
 LANG_MAGELLANFOUND, LANG_CANTOPENFILE, LANG_USAGE, LANG_KILLPROCESS, LANG_ANOTHERPROCESS,
 LANG_NIBBLEERROR, LANG_RECEIVEOVERFLOW, LANG_DISPLAYERROR, LANG_DISPLAY,
 LANG_DRIVERWINDOW, LANG_SENDWINDOW, LANG_BUTTONPRESS, LANG_BUTTONRELEASE,
 LANG_ILLEGALMAPPING, LANG_ILLEGALSYMBOL, LANG_MODECHANGE, 
 LANG_SENSITIVITYCHANGE, LANG_NULLRADIUSCHANGE, LANG_NONLINEAR, 
 LANG_SGIAPPERROR, LANG_NOFONT, 
 LANG_MODEDEFAULT, LANG_SENSTRANDEFAULT, LANG_SENSROTDEFAULT, LANG_NULLRADIUSDEFAULT,
 LANG_ERRORLINE, LANG_SETTINGSorDEFAULT, LANG_DONTOVERWRITE, 
 LANG_TRANSLATIONON, LANG_TRANSLATIONOFF, LANG_ROTATIONON, LANG_ROTATIONOFF,
 LANG_DOMINANTON, LANG_DOMINANTOFF,
 LANG_SENSITIVITYTRANS, LANG_SENSITIVITYROT, LANG_NULLRADIUS, LANG_APPLICATIONSENSITIVITY,
 LANG_STATUSDISPLAY, LANG_IBMNOTE, LANG_EXTSCALING, LANG_NOSERIALPORT,
 LANG_WARNINGSERIALDEVICE,
 LANG_AUTHOR };



 char ShellStartup[] = "#!/bin/sh\n\n\
# Startup the Magellan/SPACE MOUSE xdriver\n\
/usr/magellan/xdriver &\n\
# Get the process number of the Magellan/SPACE MOUSE xdriver\n\
MagellanDriver=`ps -edf | grep $$ | grep xdriver | awk '{print $2}'`\n\n\
# Startup your application\n\n\
#Get the process numbers of the Magellan/SPACE MOUSE drivers\n\
MagellanSubDrivers=`ps -edf | grep $MagellanDriver | grep xdriver | awk '{print $2}'`\n\
# Kill the Magellan/SPACE MOUSE xdriver\n\
kill -9 $MagellanSubDrivers\n";

 char CShellStartup[] = "#!/bin/csh -f\n\n\
# Startup the Magellan/SPACE MOUSE xdriver\n\
/usr/magellan/xdriver &\n\
# Get the process number of the Magellan/SPACE MOUSE xdriver\n\
set MagellanDriver=`ps -edf | grep $$ | grep xdriver | awk '{print $2}'`\n\n\
# Startup your application\n\n\
#Get the process numbers of the Magellan/SPACE MOUSE drivers\n\
set MagellanSubDrivers=`ps -edf | grep $MagellanDriver | grep xdriver | awk '{print $2}'`\n\
# Kill the Magellan/SPACE MOUSE xdriver\n\
kill -9 $MagellanSubDrivers\n";

 char KShellStartup[] = "#!/bin/ksh\n\n\
# Startup the Magellan/SPACE MOUSE xdriver\n\
/usr/magellan/xdriver &\n\
# Get the process number of the Magellan/SPACE MOUSE xdriver\n\
MagellanDriver=`ps -edf | grep $$ | grep xdriver | awk '{print $2}'`\n\n\
# Startup your application\n\n\
#Get the process numbers of the Magellan/SPACE MOUSE drivers\n\
MagellanSubDrivers=`ps -edf | grep $MagellanDriver | grep xdriver | awk '{print $2}'`\n\
# Kill the Magellan/SPACE MOUSE xdriver\n\
kill -9 $MagellanSubDrivers \n";

 char UsrMagellanXDriver[] = "/usr/magellan/xdriver";
 char TERMStartup[] = "xterm -T \"%s\" -iconic -e %s \n";

 char *WARNINGSERIALDEVICE[LANGUAGES] = {
  "Warnung! Die serielle Schnittstelle wird von einem anderen Programm benutzt.",
  "Warning! The serial interface is used by another program.",
  "Avertissement! L'interface s\351rie est utilis\351 par un autre programme.",
  "Advertencia! El interface serial es utilizado del otro programa."
};

 char *NOSERIALPORT[LANGUAGES] = {
  "Keine serielle Schnittstelle ist verf\374gbar.\nBitte pr\374fen Sie die Einstellungen der seriellen Schnittstelle:",
  "No serial port is available. Please check the configurations of the serial port:",
  "Pas d'interface s\351rie est disponible. S.v.p. examinez les configurations d'interface s\351rie.",
  "Interface serie no es disponibile. Por favor examina las configuraciones del interface serial." };

 char *EXTSCALING[LANGUAGES] = {
  "Skalierung Translation = %6.4lf*(%6.4lf,%6.4lf,%6.4lf)\n              Rotation = %6.4lf*(%6.4lf,%6.4lf,%6.4lf) \n",
  "Scaling translation = %6.4lf*(%6.4lf,%6.4lf,%6.4lf)\n           rotation = %6.4lf*(%6.4lf,%6.4lf,%6.4lf) \n",
  "Graduation translation = %6.4lf*(%6.4lf,%6.4lf,%6.4lf)\n              rotation = %6.4lf*(%6.4lf,%6.4lf,%6.4lf) \n",
  "Graduaci\363n translaci\363n = %6.4lf*(%6.4lf,%6.4lf,%6.4lf)\n              rotaci\363n = %6.4lf*(%6.4lf,%6.4lf,%6.4lf) \n"  };

 char *IBMNOTE[LANGUAGES] = {
  "\nHINWEIS!\nEntfernen Sie nicht den 25pol-zu-9pol Adapter an der %s!\nVerwenden Sie einen zweiten 9pol-zu-25pol Adapter zur Workstation!\n\n",
  "\nNOTE!\nDo not remove the 25pol-to-9pol adapter on the %s!\nUse a second 9pol-to-25pol adapter for the workstation!\n\n",
  "Ne pas enlever l'adapteur 25p\364le-\340-9p\364le de la %s!\nUtilisez un autre adapteur 9p\364le-\340-25p\364le pour la station de travail!\n\n",
  "No deactiva el 25pol-a-9-pol adaptor de la %s!\nEnplea un otro 9pol-a-25pol adaptor para la workstation!\n\n" };

 char *STATUSDISPLAY[LANGUAGES] = {
  "Wollen Sie ein Fenster f\374r den aktuellen Status der %s?",
  "Would you like a window containing the current state of the %s?",
  "Voulez-vous une fen\352tre pour l'\351tat actuel de la %s?",
  "\277Quiere Vd. una ventana par el status presente de la %s?" }; 

 char *APPLICATIONSENSITIVITY[LANGUAGES] = {
  "Empfindlichkeit der Anwendung",
  "application sensitivity",
  "Sensibilit\351 d'application",
  "Sensibilitad aplicai\363n" };

 char *NULLRADIUS[LANGUAGES] = {
  "Null Radius",
  "Null Radius",
  "Rayon-z\351ro",
  "Cero radio" };

 char *SENSITIVITYROT[LANGUAGES] = {
  "Empfindlichkeit Rotation",
  "Sensitivity Rotation",
  "Sensibilit\351 de la Rotation",
  "Sensibilitad Rotaci\363n" };

 char *SENSITIVITYTRANS[LANGUAGES] = {
  "Empfindlichkeit Translation",
  "Sensitivity Translation",
  "Sensibilit\351 de la Translation",
  "Sensibilitad Translaci\363n" };
  
 char *TRANSLATIONON[LANGUAGES] = {
  "Translation AN",
  "Translation ON",
  "Translation activ\351e",
  "Translaci\363n actif" };

 char *TRANSLATIONOFF[LANGUAGES] = {
  "Translation AUS",
  "Translation OFF",
  "Translation d\351sactiv\351e",
  "Translaci\363n deactif" };

 char *ROTATIONON[LANGUAGES] = {
  "Rotation AN",
  "Rotation ON",
  "Rotation activ\351e",
  "Rotatci\363n actif" };

 char *ROTATIONOFF[LANGUAGES] = {
  "Rotation AUS",
  "Rotation OFF",
  "Rotation d\351sactiv\351e",
  "Rotatci\363n deactif" };

 char *DOMINANTON[LANGUAGES] = {
  "Dominant AN",
  "Dominant ON",
  "Dominant activ\351e",
  "Dominate actif" };

 char *DOMINANTOFF[LANGUAGES] = {
  "Dominant AUS",
  "Dominant OFF",
  "Dominant d\351sactive",
  "Dominate deactif" };

  
 char *DONTOVERWRITE[LANGUAGES] = {
  "Die Konfigurationsdatei f\374r die Tasten wird nicht \374berschrieben.",
  "Configuration file for the keys will not be superscribed.",
  "Le fichier de la configuration des touches n'est pas re\351crit.",
  "Las data de la configuraci\363n para las teclas no estan carnbiado." };
 
 char *SETTINGSorDEFAULT[LANGUAGES] = {
  "Wollen Sie eine Voreinstellung f\374r die Konfiguration des Treibers w\344hlen?",
  "Would you like to choose the default configuration of your driver?",
  "D\351sirez-vous pr\351r\351gler la configuration du driver?",
  "\277Desea V. una pr\351orientaci\363n para la configuraci\363n del impulsador?" };

 char *ERRORLINE[LANGUAGES] = {
  "Fehler in Zeile",
  "Error in line",
  "Erreur en ligne",
  "Error en fila" };

 char *SENSTRANDEFAULT[LANGUAGES] = {
  "Welche Empfindlichkeit in den Translationen soll als Voreinstellung verwendet werden?",
  "What level of sensitivity in translation should be used as a default?",
  "Quelle sensibilit\351 doit \352tre pr\351r\351gl\351e dans les translations?",
  "\277Qu\351 sensibilitad debe de emplear en la translaciones como preorientaci\363n?" };

 char *SENSROTDEFAULT[LANGUAGES] = {
  "Welche Empfindlichkeit in den Rotationen soll als Voreinstellung verwendet werden?",
  "What level of sensitivity in rotation should be used as a default?",
  "Quelle sensibilit\351 doit \352tre pr\351r\351gl\351e dans les rotations?",
  "\277Qu\351 sensibilitad debe de emplear en las rotaciones como preorientaci\363n?" };

 char *NULLRADIUSDEFAULT[LANGUAGES] = {
  "Welcher Wert f\374r den Null Radius soll als Voreinstellung verwendet werden?",
  "What value should be set for the zero radius?",
  "Quel rayon-z\351ro doit \352tre pr\351r\351gl\351?",
  "\277Qu\351 sensibilitad debe de emplear en el cero radio como preorientaci\363n?" };

 char *MODEDEFAULT[LANGUAGES] = {
  "Welcher Mode soll als Voreinstellung verwendet werden?",
  "Which mode should be used as a default?",
  "Quel mode doit \352tre pr\351r\351gl\351?",
  "\277Qu\351 modo debe de emplear como preorientaci\363n?" };

 char *NOFONT[LANGUAGES] = { 
 "Es kann kein Font geladen werden",
 "Can't load a font",
 "Un font ne peut pas \352tre charg\351.",
 "Fondo no puede cargado" };


char *SGIAPPERROR[LANGUAGES] = {
 "Die ausgew\344hlte Anwendung wird durch diesen Treiber auf einer Silicon \nGraphics Workstation nicht unterst\374tzt. Benutzen Sie den sball Treiber.\n\n",
 "The selected application doesn't support this driver on\na Silicon Graphics Workstation. Use the sball driver.\n\n",
 "L'application s\351lectionn\351e ne travaille pas avec ce driver sur une station de travail de Silicon Graphics. Utilisez le sball driver.",
 "Applicaci\363n elegida no apoya el impulsador en Silicon Graphics workstation. Usa le sball impulsador"};

char *NONLINEAR[LANGUAGES] = {
 "Soll eine nichtlineare Funktion f\374r die Translation und Rotation verwendet werden?",
 "Should a non linear function be used for translation and rotation?",
 "Est-ce qu'une fonction non lin\351airedevrait \352tre utills\351e pour une translation et une rotation?",
 "\241Usa funci\363n linear!" };

char *MODECHANGE[LANGUAGES] = {
 "Soll der Translation-, Rotation- und der Dominant-Mode \344nderbar sein?",
 "Should the translation, rotation and dominant mode be adjustable?",
 "Tanslation, rotation et mode dominant \340 changer?",
 "\277Translaci\363n, rotaci\363n y modo dominate cambiable?" };

char *SENSITIVITYCHANGE[LANGUAGES] = {
 "Soll die Empfindlichkeit f\374r Translation und Rotation \344nderbar sein?",
 "Should the sensitivity for the translation and rotation be changed?",
 "Est-ce qu'll faut changer la sensibilit\351 pour la translation et pour la rotation?",
 "\277Sensibilitad cambiable?" };

char *NULLRADIUSCHANGE[LANGUAGES] = {
 "Soll der Wert f\374r den Null-Radius \344nderbar sein?",
 "Should the angle of the zero-radius be changed?",
 "Rayon-z\351ro \340 changer?",
 "\277Cero radio cambiable?" };

char *ILLEGALSYMBOL[LANGUAGES] = {
 "Ung\374ltiges Symbol im Tastentext",
 "Invalid symbol in key text",
 "Symbole non valable pour le texte de la touche",
 "S\355mbolo inv\341lido en la tecla" };

char *ILLEGALMAPPING[LANGUAGES] = {
 "Ung\374ltiger Tastentext f\374r die Taste ",
 "Invalid key text for key ",
 "Texte non valable pour la touche",
 "Inval\355do texto de tecla para la tecla" };

char *BUTTONPRESS[LANGUAGES] = {
 "Taste gedr\374\143kt",
 "Key pressed",
 "Touche press\351e",
 "Tecla deprimido" };

char *BUTTONRELEASE[LANGUAGES] = {
 "Taste freigegeben",
 "Key released",
 "Touche d\351bloqu\351e",
 "Tecla dejado libre" };

char *SENDWINDOW[LANGUAGES] = {
 "Schicke die Ereignisse an das Fenster",
 "Send the events to the window",
 "Envoyez les \351v\351nements \340 la fen\352tre",
 "\241Envia sucesos en la ventana!" };

char *DISPLAY[LANGUAGES] = {
 "Bildschirm",
 "Display",
 "Ecran",
 "Pantalla" };

char *DRIVERWINDOW[LANGUAGES] = {
 "Treiber Fenster",
 "Driver window",
 "Fen\352tre du driver",
 "Ventanta impulsador" };

char *DISPLAYERROR[LANGUAGES] = {
 "Variable nicht gefunden",
 "Variable not found",
 "Variable pas trouv\351e",
 "Variabile no encontrado" };

char *RECEIVEOVERFLOW[LANGUAGES] = {
 "Empfangspuffer ist voll",
 "Receive buffer is full",
 "Amortisseur de r\351ception est plein",
 "Intermedio de recepci\363n pleno" };

char *NIBBLEERROR[LANGUAGES] = {
 " bit [Nibble] Fehler",
 " bit [nibble] error",
 " bit [nibble] erreur ",
 " bit [nibble] error " };

char *KILLPROCESS[LANGUAGES] = {
 "F\374r einen Neustart muss der Prozess [%d] beendet werden",
 "For a restart you must kill the process [%d]",
 "Pour red\351marrer vous devez finir le proc\351d\351 [%d]",
 "Termina proceso [%d]" };

char *ANOTHERPROCESS[LANGUAGES] = {
 "Der Treiber wird beendet.",
 "The driver terminates.",
 "Le driver termine",
 "Impulsador termina" };

char *USAGE[LANGUAGES] = {
"Folgende Parameter sind erlaubt:\n -new   Die Konfigurationsdatei wird neu angelegt.\n -test  Alle Daten werden in einem eigenen Fenster angezeigt.\n",
"Following parameters are allowed:\n -new   Create a new configuration file\n -test  Show data.\n",
 "Les param\350tres suivants sont permis:\n -new   le fichier de configuration sera \351tabli nouvellement.\n -test  Toutes donn\351es sont indiqu\351es dans une fen\352tre propre.\n",
 "Parametros siguentes son permitidos:\n -new   Datas de la configuraci\363n son instalada nuevamente.\n -test  Todos datas son indicado en una ventana proprio.\n" };

char *CANTOPENFILE[LANGUAGES] = {
  "Kann die Datei nicht er\366ffnen",
  "Can't open the file",
  "Fichier impossible \340 ouvrir",
  "No es possibile de instaler las datas" };

char *MAGELLANFOUND[LANGUAGES] = {
  "gefunden an",
  "found on",
  "trouv\351 dans",
  "encontrado" };

char *MAGELLANNOTFOUND[LANGUAGES] = {
  "nicht gefunden an",
  "not found on",
  "pas trouv\351 dans",
  "no encontrado" };

char *PLEASEWAIT[LANGUAGES] = {
  "Bitte warten ...",
  "Please wait ...",
  "Attendez s.v.p. ...",
  "Attende p. f. ..." };

char *LANGUAGETITLE[LANGUAGES] = {
  "Welche Sprache wollen Sie verwenden?",
  "Which language do you want to use?",
  "Quel langage voulez-vous employer?",
  "\277Qu\351 idioma desea utilisar?" };

char *COPYRIGHT[LANGUAGES] = {
  "Copyright (C) 1984, 1995 LOGI GmbH  Alle Rechte reserviert",
  "Copyright (C) 1984, 1995 Logitech Inc. All rights reserved",
  "Copyright (C) 1984, 1995 Logitech Inc. Tous droits r\351serv\351s",
  "Copyright (C) 1984, 1995 Logitech Inc. Todos los derechos reservista " };

char *MENUCHOICE[LANGUAGES] = {
  "Ihre Wahl bitte (0=Abbruch)",
  "Your choice please (0=abort)",
  "Votre choix s.v.p. (0=arr\352t)",
  "\241Su opci\363n por favor! (0=derribo)" };

char *YOURCHOICE[LANGUAGES] = {
 "Ihre Wahl",
 "Your choice",
 "Votre choix",
 "Su opci\363n" };

char *ABORT[LANGUAGES] = {
 "Abbruch",
 "abort",
 "arr\352t",
 "derribo" };

char *ILLEGAL[LANGUAGES] = {
 "Ihre Wahl ist nicht zul\344ssig",
 "Your choice is illegal",
 "Votre choix n'est pas valable",
 "Su opci\363n es invalido" };

char *USECONFIG[LANGUAGES] = {
 "Benutze die Konfiguration aus",
 "Use the configuration from the file",
 "Appliquez la configuration de fichier",
 "\241Utilisa la configuraci\363n de las datas!" };

char *USERECONFIG[LANGUAGES] = {
 "F\374r eine Neukonfigurierung starten Sie Treiber mit ",
 "For a new configuration, run the the driver with ",
 "Pour une nouvelle configuration commencez le driver avec",
 "Para una configuraci\363n nueva aplica el impulsador con" };

char *NAMETOLONG[LANGUAGES] = {
 "FEHLER: Dateiname ist zu lang ",
 "ERROR: Name too long ",
 "Erreur: nom trop long",
 "Error: nombre muy largo" };

char *CONTINENTTITLE[LANGUAGES] = {
 "Auf welchem Kontinent sind Sie angesiedelt?",
 "On which continent do you live?",
 "De quel continent venez-vous?",
 "\277Qu\351 continente viene V.?" };

char *APPLICATIONTITLE[LANGUAGES] = {
 "Welche Applikation wollen Sie verwenden?",
 "Which application are you using?",
 "Quelle application voulez-vous utiliser?",
 "\277Qu\351 aplicai\363n desea utilisar?" };

char *MAGELLANFILE[LANGUAGES] = {
 "Automatisch suchen",
 "Automatic search",
 "Recherche automatique",
 "Busca autom\341tico" };

char *FILEMENUTITLE[LANGUAGES] = {
 "An welcher seriellen Schnittstelle ist das Ger\344t angeschlossen?",
 "On which serial port is the device connected?",
 "A quelle interface en s\351rie l'appareil est-il branch\351?",
 "\277Qu\351 interface serial es unido con el aparato?" };



char LanguageBuffer[ 132 ];	/*| temporary language buffer |*/

char *LangString( String )
int String;
{
 switch( String )
  {
   case LANG_AUTHOR : return "Dipl. Ing. Dipl. Inform. (FH) Volker Senft";
    
   case LANG_VERSION1 : return "LOGITECH (R) ";
   case LANG_VERSION2 : return " X Window Driver";

   case LANG_VERSION3 : 
    sprintf( LanguageBuffer,"Version %4.2f", MagellanXWindowVersion );
    return LanguageBuffer;

   case LANG_DEVICENAME : 
    return DeviceName == MAGELLAN ? "MAGELLAN" : "SPACE MOUSE";
    
   case LANG_COPYRIGHT : return COPYRIGHT[ Language ];
   case LANG_MENUCHOICE : return MENUCHOICE[ Language ];
   case LANG_YOURCHOICE : return YOURCHOICE[ Language ];
   case LANG_ABORT : return ABORT[ Language ];
   case LANG_ILLEGAL : return ILLEGAL[ Language ];
   case LANG_NAMETOLONG : return NAMETOLONG[ Language ];
   case LANG_LANGUAGETITLE : return LANGUAGETITLE[ Language ];
   case LANG_CONTINENTTITLE : return CONTINENTTITLE[ Language ];
   case LANG_APPLICATIONTITLE : return APPLICATIONTITLE[ Language ];
   case LANG_MAGELLANFILE : return MAGELLANFILE[ Language ];
   case LANG_FILEMENUTITLE : return FILEMENUTITLE[ Language ];
   case LANG_PLEASEWAIT : return PLEASEWAIT[ Language ];
   case LANG_MAGELLANNOTFOUND : return MAGELLANNOTFOUND[ Language ];
   case LANG_MAGELLANFOUND : return MAGELLANFOUND[ Language ];
   case LANG_USAGE : return USAGE[ Language ];
   case LANG_KILLPROCESS : return KILLPROCESS[ Language ];
   case LANG_ANOTHERPROCESS : return ANOTHERPROCESS[ Language ]; 
   case LANG_USECONFIG : return USECONFIG[ Language ];
   case LANG_USERECONFIG : return USERECONFIG[ Language ];
   case LANG_NIBBLEERROR : return NIBBLEERROR[ Language ];
   case LANG_RECEIVEOVERFLOW : return RECEIVEOVERFLOW[ Language ];
   case LANG_DISPLAYERROR : return DISPLAYERROR[ Language ];
   case LANG_DISPLAY : return DISPLAY[ Language ];
   case LANG_DRIVERWINDOW : return DRIVERWINDOW[ Language ];
   case LANG_SENDWINDOW : return SENDWINDOW[ Language ];
   case LANG_BUTTONPRESS : return BUTTONPRESS[ Language ];
   case LANG_BUTTONRELEASE : return BUTTONRELEASE[ Language ];
   case LANG_ILLEGALMAPPING : return ILLEGALMAPPING[ Language ];
   case LANG_ILLEGALSYMBOL : return ILLEGALSYMBOL[ Language ];
   case LANG_MODECHANGE : return MODECHANGE[ Language ];
   case LANG_SENSITIVITYCHANGE : return SENSITIVITYCHANGE[ Language ];
   case LANG_NULLRADIUSCHANGE : return NULLRADIUSCHANGE[ Language ];
   case LANG_NONLINEAR : return NONLINEAR[ Language ];
   case LANG_SGIAPPERROR : return SGIAPPERROR[ Language ];
   case LANG_NOFONT : return NOFONT[ Language ];
   case LANG_MODEDEFAULT : return MODEDEFAULT[ Language ];
   case LANG_SENSTRANDEFAULT : return SENSTRANDEFAULT[ Language ];
   case LANG_SENSROTDEFAULT : return SENSROTDEFAULT[ Language ];
   case LANG_NULLRADIUSDEFAULT : return NULLRADIUSDEFAULT[ Language ];
   case LANG_ERRORLINE : return ERRORLINE[ Language ];
   case LANG_CANTOPENFILE : return CANTOPENFILE[ Language ];
   case LANG_SETTINGSorDEFAULT : return SETTINGSorDEFAULT[ Language ];
   case LANG_DONTOVERWRITE : return DONTOVERWRITE[ Language ];
   case LANG_TRANSLATIONON : return TRANSLATIONON[ Language ];
   case LANG_TRANSLATIONOFF : return TRANSLATIONOFF[ Language ];
   case LANG_ROTATIONON : return ROTATIONON[ Language  ];
   case LANG_ROTATIONOFF : return ROTATIONOFF[ Language ];
   case LANG_DOMINANTON : return DOMINANTON[ Language ];
   case LANG_DOMINANTOFF : return DOMINANTOFF[ Language ];
   case LANG_SENSITIVITYTRANS : return SENSITIVITYTRANS[ Language ];
   case LANG_SENSITIVITYROT : return SENSITIVITYROT[ Language ];
   case LANG_NULLRADIUS : return NULLRADIUS[ Language ];
   case LANG_APPLICATIONSENSITIVITY : return APPLICATIONSENSITIVITY[ Language ];
   case LANG_STATUSDISPLAY : return STATUSDISPLAY[ Language ];
   case LANG_IBMNOTE : return IBMNOTE[ Language ];
   case LANG_EXTSCALING : return EXTSCALING[ Language ];
   case LANG_NOSERIALPORT : return NOSERIALPORT[ Language ];
   case LANG_WARNINGSERIALDEVICE : return WARNINGSERIALDEVICE[ Language ];
  };
 return "Internal Error ... ";
}

/*|-----------------|*/
/*| File Procedures |*/
/*|-----------------|*/
#ifdef IBM
int IBMttyBufferSize( char *TTYName, int BufferSize )
{
int TTYHandle;

 TTYHandle = open( TTYName, O_RDWR | O_NONBLOCK );
 if ( TTYHandle < 0 )
  {
   return FALSE;
  }
 else
  {
   if ( ioctl( TTYHandle, TXSETIHOG, &BufferSize ) )
    {
     return FALSE;
    }
   else
    {
     printf("IBM TTY: Changed the %s buffer size to %d. \n", TTYName, BufferSize );
    };
  };
 close( TTYHandle );
 return TRUE;
}
#endif

int ShellFile( Directory, FileName, FileText )
char *Directory;
char *FileName;
char *FileText;
{
FILE *fo;
char File[128];
int loop;

 strcpy( File, Directory );
 for ( loop=strlen(File); loop>=0; --loop )
  if ( File[loop] != '/' )
   File[loop] = '\000';
  else
   break;
 strcat( File, FileName );

 fo = fopen( File, "wt" );
 if ( fo == NULL )
  return FALSE;

 fputs( FileText, fo );
 fclose( fo );
 chmod( File, S_IWOTH | S_IXOTH | S_IROTH |
	      S_IWGRP | S_IXGRP | S_IRGRP |
	      S_IWUSR | S_IXUSR | S_IRUSR );
 return TRUE;
}

char Program[ 128 ];

char *ProgramName( FileName )
char *FileName;
{
char *ptr;

 memset( Program, 0x00, sizeof(Program) );
 ptr = FileName;

 while ( *FileName != '\000' )
  {
   if ( *FileName == '/' ) ptr = FileName + 1;
   if ( *FileName == '~' ) ptr = FileName + 1;
   if ( *FileName == '.' ) ptr = FileName + 1;
   ++FileName;
  };

 strcpy( Program, ptr );
 return Program;
}

int FileExistRead( FileName )
char *FileName;
{
int FileHandle;

 FileHandle = open( FileName, O_RDONLY | O_NDELAY );
 if ( FileHandle >= 0 )
  {
   close( FileHandle );
   return TRUE;
  };
 return FALSE;
}

int FileExist( FileName )
char *FileName;
{
int FileHandle;

 FileHandle = open( FileName, O_RDWR | O_NDELAY );
 if ( FileHandle >= 0 )
  {
   close( FileHandle );
   return TRUE;
  };
 return FALSE;
}

char FileConfigName[ 128 ];

char *FileConfig( FileName )
char *FileName;
{
 if ( strlen(FileName) > sizeof(FileConfigName)-8 )
  {
   printf("%s (%d>%d).", LangString(LANG_NAMETOLONG), strlen(FileName),
    sizeof(FileConfigName)-8 );
   exit( -1 );
  };
 sprintf( FileConfigName, "%s.cfg", FileName );
 return FileConfigName;
}

char *FileConfigDirectory( FileName, Directory )
char *FileName;
char *Directory;
{
int length;

 if ( (int)strlen(FileName) > (int)(sizeof(FileConfigName)-8-strlen(Directory)) )
  {
   printf("%s (%d>%d).", LangString(LANG_NAMETOLONG), strlen(FileName),
    sizeof(FileConfigName)-8-strlen(Directory) );
   exit( -1 );
  };
 for ( length=(int)strlen(FileName)-1; length>=0; --length )
  {
   if ( !isalnum(FileName[length]) )
    {
     strcpy( FileName, &FileName[length+1] );
     break;
    };
  };
 sprintf( FileConfigName, "%s/%s.cfg", Directory, FileName );
 return FileConfigName; 
}

char FileKeyboardName[ 128 ];

char *FileKeyboard( FileName )
char *FileName;
{
 if ( strlen(FileName) > sizeof(FileConfigName)-8 )
  {
   printf("%s (%d>%d).", LangString(LANG_NAMETOLONG), strlen(FileName),
    sizeof(FileConfigName)-8 );
   exit( -1 );
  };
 sprintf( FileKeyboardName, "%s.kbd", FileName );
 return FileKeyboardName;
}

char *FileKeyboardDirectory( FileName, Directory )
char *FileName;
char *Directory;
{
int length;

 if ( strlen(FileName) > sizeof(FileConfigName)-8-strlen(Directory) )
  {
   printf("%s (%d>%d).", LangString(LANG_NAMETOLONG), strlen(FileName),
    sizeof(FileConfigName)-8-strlen(Directory) );
   exit( -1 );
  };
 for ( length=(int)strlen(FileName)-1; length>=0; --length )
  {
   if ( !isalnum(FileName[length]) )
    {
     strcpy( FileName, &FileName[length+1] );
     break;
    };
  };
 sprintf( FileConfigName, "%s/%s.kbd", Directory, FileName );
 return FileConfigName; 
}

char *FileKeyboardButton[9];

void FileKeyboardButtonStrings( FileName )
char *FileName;
{
char buffer[ 2048 ];
FILE *FileHandle;
int index;

 memset( FileKeyboardButton, 0x00, sizeof(FileKeyboardButton) );
 FileHandle = fopen( FileName, "rt" );
 if ( FileHandle != NULL )
  {
   for ( index=1; index<=9; ++index )
    {
     memset( buffer, 0x00, sizeof(buffer) );
     fgets( buffer, sizeof(buffer), FileHandle );

     while ( ((int)strlen( buffer ) > 1) && 
	     (buffer[ strlen(buffer)-1 ] == '\n') )
      buffer[ strlen(buffer)-1 ] = '\000';

     FileKeyboardButton[ index-1 ] = (char *) malloc( strlen(buffer) + 32 );
     if ( FileKeyboardButton[ index-1 ] != NULL )
      {
       strcpy( FileKeyboardButton[ index-1 ], buffer );
       ButtonParser( (Display *)NULL, (Window)NULL,
		     FileKeyboardButton[index-1], FALSE);
       switch( index )
	{
	 case 1:
	 case 2:
	 case 3:
	 case 4:
	 case 5:
	 case 6:
	 case 7:
	 case 8:
	  if ( buffer[0] != '0'+index )
	   {
	    printf("%s %c [%s]\n", LangString( LANG_ILLEGALMAPPING ),
		      index+'0', buffer );
	    exit( -1 );
	   };
          break;

	 case 9: 
	  if ( (buffer[0]!='9') && (buffer[0]!='*') )
	   {
	    printf("%s %c [%s]\n", LangString( LANG_ILLEGALMAPPING ),
		       '*', buffer );
	    exit( -1 );
	   };
          break;

	};
      };

    };
   fclose( FileHandle );
  };
}


/*|------------------------------------------------|*/
/*| Applications for the Magellan X Windows Driver |*/
/*|------------------------------------------------|*/

char *ApplicationMenu[] = { 
 "CADDS5 Version 5.2 ... ", 
 "Pro/Engineer ... Version 15 ", 
 "Pro/Engineer Version 16",
 "Pro/Engineer Version 17 ...",
 "CATIA Version 4.0 ... 4.15", 
 "CATIA Version 4.16 ...",
 "I-DEAS Version 4.0 ...", 
 "SIMPACK Version 6.009 ...",
 "UniGraphics ... Version 11.0", 
 "UniGraphics Version 11.1 ...", 
 "SolidDesigner ...", 
 "X Window Driver Version 2.0/3.0", 
 "X Window Driver Version 1.0",
 "X Window Driver Dual Version", NULL };

enum _applications_ { 
 CADDS5, 
 PROENGINEER_15, 
 PROENGINEER_16, 
 PROENGINEER_17,
 CATIA_400, 
 CATIA_416,
 IDEAS, 
 SIMPACK,
 UNIGRAPHICS, 
 UNIGRAPHICS_11, 
 SOLIDDESIGNER, 
 NEWVERSION, 
 OLDVERSION, 
 DUALVERSION,
 UNKNOWN };

#define PROENGINEER_16_SAVE	UNKNOWN+1

int Application = UNKNOWN;

int ApplicationChoice( application )
int application;
{
#ifdef SGI
 switch( application )
  {
   case PROENGINEER_15:
   case SOLIDDESIGNER: 
    printf("%s\n", LangString( LANG_SGIAPPERROR ) );
    exit( -1 );
  };
#endif

 switch( application )
  {
   case SIMPACK :
   case DUALVERSION :
   case CADDS5 :
   case PROENGINEER_17 :
   case PROENGINEER_16 :
   case IDEAS : 
   case NEWVERSION : return NEWVERSION;

   case PROENGINEER_15 :
   case CATIA_400 :
   case CATIA_416 :
   case UNIGRAPHICS :
   case UNIGRAPHICS_11 :
   case SOLIDDESIGNER :
   case OLDVERSION : return OLDVERSION;

   default : return OLDVERSION;
  };
}

int MagellanStatusDisplayFlag = NO;

int MagellanStatusDisplayChoice( application )
int application;
{
 switch( application )
  {
   case NEWVERSION :
    return TRUE;

   case SIMPACK :
   case PROENGINEER_16 :
   case PROENGINEER_17 :
   case IDEAS :

   case DUALVERSION :
   case CADDS5 :
   case PROENGINEER_15 :
   case CATIA_400 :
   case CATIA_416 :
   case UNIGRAPHICS :
   case UNIGRAPHICS_11 :
   case SOLIDDESIGNER :
    return FALSE;

   default :
    return TRUE;
  };
}


/*|-------------|*/
/*| Menu choice |*/
/*|-------------|*/
char *LanguageMenu[] = { "Deutsch", "English", "Fran\347ais", "Espa\361ol", NULL };

char *ContinentMenuDeutsch[] = 
 { "Europa", "Amerika", "Asien", "Afrika", "Australien", NULL };
char *ContinentMenuEnglish[] =
 { "Europe", "America", "Asia", "Afrika", "Australia", NULL };
char *ContinentMenuFrance[] =
 { "EUROPE", "ETATS UNIS", "ASIE", "AFRIQUE", "AUSTRALIA", NULL };
char *ContinentMenuSpain[] =
 { "Europe", "America", "Asia", "Africa", "Australia", NULL };
char **ContinentMenu[LANGUAGES] = {
 ContinentMenuDeutsch, ContinentMenuEnglish, 
 ContinentMenuFrance,  ContinentMenuSpain };

char *YesNoMenuDeutsch[] = { "Ja", "Nein", NULL };
char *YesNoMenuEnglish[] = { "Yes", "No", NULL };
char *YesNoMenuFrance[] =  { "oui", "non", NULL };
char *YesNoMenuSpain[] =   { "s\355", "no", NULL };
char **YesNoMenu[LANGUAGES] = {
 YesNoMenuDeutsch, YesNoMenuEnglish, YesNoMenuFrance, YesNoMenuSpain };

char *MagellanModeMenuDeutsch[] =
 { "Translation, Rotation", "Translation, Rotation und Dominant Mode",
   "Translation", "Translation und Dominant Mode", 
   "Rotation", "Rotation und Dominant Mode", NULL };
char *MagellanModeMenuEnglish[] =
 { "translation, rotation", "translation, rotation and dominant mode",
   "translation", "translation and dominant mode",
   "rotation", "rotation and dominant mode", NULL };
char *MagellanModeMenuFrance[] =
 { "translation, rotation", "translation, rotation et mode dominant",
   "translation", "translation et mode dominant", "rotation",
   "rotation et mode dominant", NULL };
char *MagellanModeMenuSpain[] =
 { "translaci\363n rotaci\363n", "translaci\363n, rotaci\363n y modo dominate",
   "translaci\363n", "translaci\363n y modo dominate", "rotatci\363n",
   "rotaci\363n y modo dominate ", NULL };
char **MagellanModeMenu[LANGUAGES] = {
 MagellanModeMenuDeutsch, MagellanModeMenuEnglish, MagellanModeMenuFrance,
 MagellanModeMenuSpain };
int MagellanModeDefaultTable[] = { 3, 7, 2, 6, 1, 5 };

char *MagellanSensTranMenu[] =
 { "1", "2", "3", "4", "5", "6", "7", "8", NULL };
char *MagellanSensRotMenu[] =
 { "1", "2", "3", "4", "5", "6", "7", "8", NULL };

char *MagellanNullRadiusMenu[] =
 {"1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16",NULL };

int MenuInput()
{
char ch,Buffer[32];
int index;

 memset( Buffer, 0x00, sizeof(Buffer) );
 index = 0;
 do
  {
   ch = getchar();
   if ( (ch>='0') && (ch<='9') )
    Buffer[index++] = ch;
   else
    {
     if ( (ch=='\n') || (ch=='\r') )
      {
       Buffer[index] = '\000';
       if ( index > 0 )
        break;
       else
	return -1;
      };
    };
   if ( index >= sizeof(Buffer) )
    {
     index = sizeof(Buffer)-1;
    };
  } while( _TRUE_  );

 return atoi( Buffer );
}

int MenuChoice( Titles, MenuTitle )
char *Titles[];
char *MenuTitle;
{
int TitleCount, TitleNumber, loop;

 for ( TitleCount=0; Titles[TitleCount]!=NULL; ++TitleCount )
  ;
 if ( TitleCount == 0 )
  return FALSE;

 do
  {
   printf("\n\n%s\n\n", MenuTitle );

   for ( loop=0; loop<TitleCount; ++loop )
    printf(" %d) %s \n", loop+1, Titles[loop] );

   printf("\n%s (1..%d)? ", LangString(LANG_MENUCHOICE), TitleCount );

   TitleNumber = MenuInput();

   if ( TitleNumber == 0 )
    {
     printf("%s\n", LangString(LANG_ABORT) );
     return FALSE;
    };

   if ( (TitleNumber>0) && (TitleNumber<=TitleCount) )
    {
     printf("%s %d) %s \n\n", LangString(LANG_YOURCHOICE),
      TitleNumber, Titles[TitleNumber-1] );
     break;
    };

   printf("%s\n\n", LangString(LANG_ILLEGAL) ); 
  } while ( _TRUE_ );

 return TitleNumber;
}

void PrintMenuTexte( Texte )
char *Texte[];
{
int loop;

 loop = 0;
 while ( Texte[ loop ] != NULL )
  {
   printf("%s\n", Texte[ loop++ ] );
  };
 printf("\n");
}


void MathFrameTranslation( Frame, X, Y, Z )
MathFrame *Frame;
real X;
real Y;
real Z;
{
 Frame->MathTranslation[0] = X;
 Frame->MathTranslation[1] = Y;
 Frame->MathTranslation[2] = Z;
}

void MathFrameRotation( Frame, Pitch, Yaw, Roll )
MathFrame *Frame;
real Pitch;
real Yaw;
real Roll;
{
real sa,ca, sb,cb, sc,cc;
real sacc, casc, sasc, cacc;

 sc = (real) sin(Pitch); cc = (real) cos(Pitch);
 sb = (real) sin(Yaw);   cb = (real) cos(Yaw);
 sa = (real) sin(Roll);	 ca = (real) cos(Roll);

 Frame->MathRotation[0][0] = ca*cb;
 Frame->MathRotation[1][0] =-sa*cb;
 Frame->MathRotation[2][0] = -sb;

 sacc = sa*cc;
 casc = ca*sc;
 sasc = sa*sc;
 cacc = ca*cc;

 Frame->MathRotation[0][1] = sacc - casc*sb;
 Frame->MathRotation[1][1] = cacc + sasc*sb;
 Frame->MathRotation[2][1] = -cb*sc;

 Frame->MathRotation[0][2] = sasc + cacc*sb;
 Frame->MathRotation[1][2] = casc - sacc*sb;
 Frame->MathRotation[2][2] = cb*cc;
}

void MathFrameMultiplication( FrameA, FrameB, FrameAB )
MathFrame *FrameA;
MathFrame *FrameB;
MathFrame *FrameAB;
{
MathFrame FrameResult;
int m,n,k;

 for ( m=0; m<FRAMEROTm; ++m )
  for ( n=0; n<FRAMEROTn; ++n )
	{
	 FrameResult.MathRotation[m][n] = (real) 0.0;
	 for ( k=0; k<FRAMEROTn; ++k )
	  FrameResult.MathRotation[m][n] += FrameA->MathRotation[m][k] *
						 FrameB->MathRotation[k][n];
	};
 for ( m=0; m<FRAMETRA; ++m )
  FrameResult.MathTranslation[m] = FrameA->MathTranslation[m] +
					FrameB->MathTranslation[m];
 memcpy( FrameAB, &FrameResult, sizeof( FrameResult ) );
}

void MathFrameTransformation( Frame, PointIn, PointOut )
MathFrame *Frame;
MathPoint *PointIn;
MathPoint *PointOut;
{
MathPoint PointResult;
int m,n;

 for ( m=0; m<FRAMEROTm; ++m )
  {
	PointResult.MathTranslation[m] = Frame->MathTranslation[m];
   for ( n=0; n<FRAMEROTn; ++n )
	 PointResult.MathTranslation[m] += Frame->MathRotation[m][n] * PointIn->MathTranslation[n];
  };
 memcpy( PointOut, &PointResult, sizeof( PointResult ) );
}

void MathVectorSubtraction( Point1, Point2, Vector )
MathPoint *Point1;
MathPoint *Point2;
MathPoint *Vector;
{
 Vector->MathTranslation[0] = Point1->MathTranslation[0] - Point2->MathTranslation[0];
 Vector->MathTranslation[1] = Point1->MathTranslation[1] - Point2->MathTranslation[1];
 Vector->MathTranslation[2] = Point1->MathTranslation[2] - Point2->MathTranslation[2];
}

real MathVectorScalar( Point1, Point2 )
MathPoint *Point1;
MathPoint *Point2;
{
 return Point1->MathTranslation[0]*Point2->MathTranslation[0] +
	Point1->MathTranslation[1]*Point2->MathTranslation[1] +
	Point1->MathTranslation[2]*Point2->MathTranslation[2];
}

void MathVectorProduct( Point1, Point2, Product )
MathPoint *Point1;
MathPoint *Point2;
MathPoint *Product;
{
MathPoint ProductResult;

 ProductResult.MathTranslation[0] = Point1->MathTranslation[1] *
				    Point2->MathTranslation[2] -
				    Point1->MathTranslation[2] *
				    Point2->MathTranslation[1];
 ProductResult.MathTranslation[1] = Point1->MathTranslation[2] *
				    Point2->MathTranslation[0] -
				    Point1->MathTranslation[0] *
				    Point2->MathTranslation[2];
 ProductResult.MathTranslation[2] = Point1->MathTranslation[0] *
				    Point2->MathTranslation[1] -
				    Point1->MathTranslation[1] *
				    Point2->MathTranslation[0];
 memcpy( Product, &ProductResult, sizeof( ProductResult ) );
}

void Math2DTransformation( PointIn, PointOut, Focus )
MathPoint *PointIn;
MathPoint *PointOut;
real Focus;
{
 PointOut->MathTranslation[0] = Focus * PointIn->MathTranslation[0] / PointIn->MathTranslation[2];
 PointOut->MathTranslation[1] = Focus * PointIn->MathTranslation[1] / PointIn->MathTranslation[2];
 PointOut->MathTranslation[2] = (real) 0.0;
}

void Math2DCoordinate( PointIn, PointOut, Parameter )
MathPoint *PointIn;
MathPoint *PointOut;
MathVideo *Parameter;
{
 PointOut->MathTranslation[0] = PointIn->MathTranslation[0] *
				Parameter->VideoMaxX * Parameter->VideoRatio +
				Parameter->VideoMaxX/2;
 PointOut->MathTranslation[1] =-PointIn->MathTranslation[1] *
				Parameter->VideoMaxY +
				Parameter->VideoMaxY/2;
 PointOut->MathTranslation[2] = 0.0;
}

#define CubeSize		1.0

MathPoint P1 = { {  CubeSize, -CubeSize,  CubeSize } };
MathPoint P2 = { {  CubeSize, -CubeSize, -CubeSize } };
MathPoint P3 = { {  CubeSize,  CubeSize, -CubeSize } };
MathPoint P4 = { {  CubeSize,  CubeSize,  CubeSize } };
MathPoint P5 = { { -CubeSize, -CubeSize,  CubeSize } };
MathPoint P6 = { { -CubeSize, -CubeSize, -CubeSize } };
MathPoint P7 = { { -CubeSize,  CubeSize, -CubeSize } };
MathPoint P8 = { { -CubeSize,  CubeSize,  CubeSize } };

MathPlane Pl1 = { { &P4, &P3, &P2, &P1 }, &BROWN };
MathPlane Pl2 = { { &P8, &P4, &P1, &P5 }, &YELLOW };
MathPlane Pl3 = { { &P8, &P5, &P6, &P7 }, &GREEN };
MathPlane Pl4 = { { &P7, &P6, &P2, &P3 }, &LIGHTRED };
MathPlane Pl5 = { { &P8, &P7, &P3, &P4 }, &LIGHTMAGENTA };
MathPlane Pl6 = { { &P6, &P5, &P1, &P2 }, &LIGHTBLUE };

#define FRAMEWIDE 400                   /* width of client area */
#define FRAMEHIGH 300                  /* height of client area */

#define WIDE	FRAMEWIDE
#define HIGH	FRAMEHIGH

#define MagellanRotationCubeScaling	2048.0
#define MagellanTranslationCubeScaling	1024.0
#define NearPosition			-2.0

MathVideo XWindowVideo = { 8.3/12.3, FRAMEWIDE, FRAMEHIGH, 1.5 };

int CurrentFrameWide = FRAMEWIDE;
int CurrentFrameHigh = FRAMEHIGH;

int DisplayPlane( display, window, gc, Plane, Frame, Video )
Display *display;
Window window;
GC gc;
MathPlane *Plane;
MathFrame *Frame;
MathVideo *Video;
{
MathPoint Point3D[ PLANEPOINTS ];
MathPoint Point2D[ PLANEPOINTS ];
MathPoint Vector1, Vector2, VectorX;
int loop;
XPoint Shape[PLANEPOINTS];
int InsideCounter;

 InsideCounter = 0;
 for ( loop=0; loop<PLANEPOINTS; ++loop )
  {
   MathFrameTransformation( Frame, Plane->PlanePoints[loop], &Point3D[loop] );
   Math2DTransformation( &Point3D[loop], &Point2D[loop], Video->VideoFocus );
  };
 MathVectorSubtraction( Plane->PlanePoints[3], Plane->PlanePoints[0], &Vector1 );
 MathVectorSubtraction( Plane->PlanePoints[1], Plane->PlanePoints[0], &Vector2 );

 MathVectorSubtraction( &Point2D[3], &Point2D[0], &Vector1 );
 MathVectorSubtraction( &Point2D[1], &Point2D[0], &Vector2 );

 MathVectorProduct( &Vector1, &Vector2, &VectorX );
 if ( VectorX.MathTranslation[2] > (real) 0.0 )
  {
   for ( loop=0; loop<PLANEPOINTS; ++loop )
    {
     Math2DCoordinate( &Point2D[loop], &Point2D[loop], Video );
     Shape[loop].x = (int) Point2D[loop].MathTranslation[0];
     Shape[loop].y = (int) Point2D[loop].MathTranslation[1];
     if ( (Shape[loop].x>0) && (Shape[loop].x<CurrentFrameWide) &&
          (Shape[loop].y>0) && (Shape[loop].y<CurrentFrameHigh) )
      ++InsideCounter;
    };

   XSetColor( display, gc, Plane->PlaneColor );
   XFillPolygon( display, window, gc, Shape, PLANEPOINTS, Nonconvex, CoordModeOrigin );
  };
 return InsideCounter;
}

int DisplayCube( display, window, gc, Frame, Video )
Display *display;
Window window;
GC gc;
MathFrame *Frame;
MathVideo *Video;
{
 return 
  DisplayPlane( display, window, gc, &Pl1, Frame, Video ) +
  DisplayPlane( display, window, gc, &Pl2, Frame, Video ) +
  DisplayPlane( display, window, gc, &Pl3, Frame, Video ) +
  DisplayPlane( display, window, gc, &Pl4, Frame, Video ) +
  DisplayPlane( display, window, gc, &Pl5, Frame, Video ) +
  DisplayPlane( display, window, gc, &Pl6, Frame, Video );
}

pid_t MagellanChildProcessCube;

void MagellanDemonstrationCube( display, argv, argc )
Display *display;
char *argv[];
int argc;
{
Window ForegroundWindow;
unsigned int screen,width,height;
XEvent event;
KeySym keysym;
GC ForegroundGC;
XGCValues XValuesForegroundGC;
char *windowtext, windowversion[128], string[128], keyboardstring[ 48 ];
XTextProperty windowname;
char *FontName;
Font fontname;
Atom InternAtomNew, InternAtomOld, WMDeleteWindow, WMProtocols;
MathFrame MagellanTransformation, FrameTransRot;
Pixmap BackgroundWindow;
int Inside;
double MagellanScaling = 1.0;
XSetWindowAttributes WindowAttribute;

 MagellanChildProcessCube = fork();
 if ( MagellanChildProcessCube == 0 )
  {
   XSetErrorHandler( MagellanErrorHandler );  

   display = XOpenDisplay( NULL );
   screen = DefaultScreen( display );
   width = DisplayWidth( display, screen );
   height = DisplayHeight( display, screen );

   ForegroundWindow = XCreateSimpleWindow( display, RootWindow(display,screen), 0,0,
 		                     CurrentFrameWide, CurrentFrameHigh, 20,
		                     BlackPixel(display,screen),
				     WhitePixel(display,screen) );

   BackgroundWindow = XCreatePixmap( display, ForegroundWindow, CurrentFrameWide, CurrentFrameHigh, 
                                     XDefaultDepth(display,screen) );

   sprintf( windowversion,"%s %s %s", LangString( LANG_DEVICENAME ),
				      LangString( LANG_VERSION2 ),
				      LangString( LANG_VERSION3 ) );
   windowtext = windowversion; 

   XStringListToTextProperty( &windowtext, 1, &windowname );
   XSetWMProperties( display, ForegroundWindow, &windowname, NULL, argv,
			 argc, NULL, NULL, NULL );

   WMProtocols = XInternAtom( display, "WM_PROTOCOLS", FALSE );
   WMDeleteWindow = XInternAtom( display, "WM_DELETE_WINDOW", FALSE );
   XSetWMProtocols( display, ForegroundWindow, &WMDeleteWindow, 1);

   XSelectInput( display, ForegroundWindow, KeyPressMask | KeyReleaseMask | ExposureMask |
                          ResizeRedirectMask | SubstructureRedirectMask | StructureNotifyMask );

   XValuesForegroundGC.foreground = BlackPixel( display, 0 );
   XValuesForegroundGC.background = WhitePixel( display, 0 );
   XValuesForegroundGC.plane_mask = AllPlanes;
   ForegroundGC = XCreateGC( display, ForegroundWindow, 
                    GCPlaneMask | GCForeground | GCBackground, &XValuesForegroundGC );

   FontName = XFontName( display );
   if ( FontName != NULL )
    {
     fontname = XLoadFont( display, FontName );
     XSetFont( display, ForegroundGC, fontname );
    }
   else
    {
     printf("%s\n", LangString( LANG_NOFONT ) );
     exit( -1 );
    };

   MagellanSetWindow( display, ForegroundWindow );

   keysym = ~XK_Escape;
   strcpy( keyboardstring, "" );
 
   sleep( 1 ); 

   XMapWindow( display, ForegroundWindow );

   MathFrameTranslation( &MagellanTransformation, 0.0, 0.0, -10.0 );
   MathFrameRotation( &MagellanTransformation, 0.0, 0.0, 0.0 );

   while ( keysym != XK_Escape )
    {
     XNextEvent( display, &event );
     switch( event.type )
      {
       case ResizeRequest :
        if ( (CurrentFrameWide != event.xresizerequest.width) ||
             (CurrentFrameHigh != event.xresizerequest.height) )
         {
          XFreePixmap( display, BackgroundWindow );
   
          XWindowVideo.VideoMaxX = 
          CurrentFrameWide = event.xresizerequest.width;
          XWindowVideo.VideoMaxY =
          CurrentFrameHigh = event.xresizerequest.height;

          BackgroundWindow = XCreatePixmap( display, ForegroundWindow, CurrentFrameWide, CurrentFrameHigh, 
                                            XDefaultDepth(display,screen) );

          WindowAttribute.override_redirect = True;
          XChangeWindowAttributes( display, ForegroundWindow, CWOverrideRedirect, &WindowAttribute );

          XResizeWindow( display, ForegroundWindow, CurrentFrameWide, CurrentFrameHigh );

          WindowAttribute.override_redirect = False;
          XChangeWindowAttributes( display, ForegroundWindow, CWOverrideRedirect, &WindowAttribute );

          XRaiseWindow( display, ForegroundWindow );
  
          XFlush( display );
         };
        break;

       case Expose :
        XSetColor( display, ForegroundGC, &BLACK );
        XFillRectangle( display, ForegroundWindow, ForegroundGC, 0,0, CurrentFrameWide, CurrentFrameHigh );
        DisplayCube( display, ForegroundWindow, ForegroundGC, &MagellanTransformation,&XWindowVideo); 
        XFlushGC( display, ForegroundGC );
        break;
 
       case KeyPress :
	memset( string, 0x00, sizeof(string) );
        XLookupString((XKeyEvent *)&event,string,sizeof(string),&keysym,NULL);
        break;

       case ClientMessage :
	if ( event.xclient.message_type == WMProtocols )
         if ( event.xclient.data.l[0] == WMDeleteWindow )
          keysym = XK_Escape;
 
	if ( XDriverDebug )
	 XDebugClientMessage( display, &event, "Application" );
	 	 
        InternAtomNew = XInternAtom( display, "MotionEvent", TRUE );
        InternAtomOld = XInternAtom(display, "SpaceballMotionEventType", TRUE);

        if ( (event.xclient.message_type == InternAtomNew) ||
             (event.xclient.message_type == InternAtomOld) )
         {
          MathFrameTranslation( &FrameTransRot, 
                                -event.xclient.data.s[2]/MagellanTranslationCubeScaling*MagellanScaling, 
                                -event.xclient.data.s[3]/MagellanTranslationCubeScaling*MagellanScaling, 
                                -event.xclient.data.s[4]/MagellanTranslationCubeScaling*MagellanScaling );
          MathFrameRotation( &FrameTransRot,
                                 event.xclient.data.s[5]/MagellanRotationCubeScaling*MagellanScaling,
                                -event.xclient.data.s[6]/MagellanRotationCubeScaling*MagellanScaling,
                                 event.xclient.data.s[7]/MagellanRotationCubeScaling*MagellanScaling );
          MathFrameMultiplication( &FrameTransRot, &MagellanTransformation, &MagellanTransformation );
          if ( MagellanTransformation.MathTranslation[2] > NearPosition )
           MagellanTransformation.MathTranslation[2] = NearPosition;

          XSetColor( display, ForegroundGC, &BLACK );
          XFillRectangle( display, BackgroundWindow, ForegroundGC, 0,0, CurrentFrameWide, CurrentFrameHigh );
          Inside = DisplayCube( display, BackgroundWindow, ForegroundGC, &MagellanTransformation, &XWindowVideo ); 
          XCopyArea( display, BackgroundWindow, ForegroundWindow, ForegroundGC, 0,0, CurrentFrameWide, CurrentFrameHigh, 0,0 );
          XFlushGC( display, ForegroundGC );
         
          if ( !Inside )
           {
            MathFrameTranslation( &FrameTransRot, 
                                 event.xclient.data.s[2]/MagellanTranslationCubeScaling*MagellanScaling, 
                                 event.xclient.data.s[3]/MagellanTranslationCubeScaling*MagellanScaling, 
                                 event.xclient.data.s[4]/MagellanTranslationCubeScaling*MagellanScaling );
            MathFrameRotation( &FrameTransRot,
                                -event.xclient.data.s[5]/MagellanRotationCubeScaling*MagellanScaling,
                                 event.xclient.data.s[6]/MagellanRotationCubeScaling*MagellanScaling,
                                -event.xclient.data.s[7]/MagellanRotationCubeScaling*MagellanScaling );
            MathFrameMultiplication( &FrameTransRot, &MagellanTransformation, &MagellanTransformation );
           };
         }
        else
         {
          InternAtomNew = XInternAtom( display, "ButtonPressEvent", TRUE );
          InternAtomOld = XInternAtom(display,"SpaceballButtonPressEventType", TRUE );
          if ( (event.xclient.message_type == InternAtomNew) ||
                 (event.xclient.message_type == InternAtomOld)  )
           {
            switch ( event.xclient.data.s[2] )
             {
              case 5:
               if ( MagellanScaling > 1.0/32.0 ) MagellanScaling /= 2.0;
               break;

              case 6:
               if ( MagellanScaling < 32.0 ) MagellanScaling *= 2.0;
               break;

              case 7:
               MagellanScaling = 1.0;
               break;

              case 8:
               MathFrameTranslation( &MagellanTransformation, 0,0,-10 );
               MathFrameRotation( &MagellanTransformation, 0,0,0 );
               
               event.xexpose.type = Expose;
               event.xexpose.serial = NextRequest( display );
               event.xexpose.send_event = TRUE;
               event.xexpose.display = display;
               event.xexpose.window = ForegroundWindow;
               event.xexpose.width =
               event.xexpose.height =
               event.xexpose.count =
               event.xexpose.x =
               event.xexpose.y = 0;
               XSendEvent( display, ForegroundWindow, False, 0x0000, &event );

               break;
             };
	   }
	  else
	   {
	    InternAtomNew = XInternAtom( display, "ButtonReleaseEvent", TRUE );
            InternAtomOld = XInternAtom(display, "SpaceballButtonReleaseEventType", TRUE );
            if ( (event.xclient.message_type == InternAtomNew) ||
                 (event.xclient.message_type == InternAtomOld) )
             {
	     };
	   }; 
	 };
        break;	
      };
    };
   XFreePixmap( display, BackgroundWindow );
   XDestroyWindow( display, ForegroundWindow );
   XCloseDisplay( display );
   exit( 1 );
  };
}


/*|---------------|*/
/*| Magellan File |*/
/*|---------------|*/
int NonLinearFlag = NO;
int CoordinateSystemChange = NO;

int MagellanModeChange = TRUE;
int MagellanModeDefault = 0;

int MagellanSensitivityChange = TRUE;
int MagellanSensTranDefault = 0;
int MagellanSensRotDefault = 0;

int MagellanNullRadiusChange = TRUE;
int MagellanNullRadiusDefault = 0;

char MagellanFileName[64] = "";

char *MagellanFileMenu[] = { NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
			     NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL };
char **MagellanCreateFileMenu()
{
int index;

 memset( MagellanFileMenu, 0x00, sizeof(MagellanFileMenu) );
 MagellanFileMenu[0] = LangString( LANG_MAGELLANFILE );
 index = 1;

 MagellanFileMenu[index] = "/dev/magellan";
 if ( FileExist(MagellanFileMenu[index]) ) ++index;
 MagellanFileMenu[index] = "/dev/smouse";
 if ( FileExist(MagellanFileMenu[index]) ) ++index;

#ifdef SGI
 MagellanFileMenu[index] = "/dev/ttyd1";
 if ( FileExist(MagellanFileMenu[index]) ) ++index;
 MagellanFileMenu[index] = "/dev/ttyd2";
 if ( FileExist(MagellanFileMenu[index]) ) ++index;
 MagellanFileMenu[index] = "/dev/ttyd3";
 if ( FileExist(MagellanFileMenu[index]) ) ++index;
 MagellanFileMenu[index] = "/dev/ttyd4";
 if ( FileExist(MagellanFileMenu[index]) ) ++index;
 MagellanFileMenu[index] = "/dev/ttyd5";
 if ( FileExist(MagellanFileMenu[index]) ) ++index;
 MagellanFileMenu[index] = "/dev/ttyd6";
 if ( FileExist(MagellanFileMenu[index]) ) ++index;
 MagellanFileMenu[index] = "/dev/ttyd7";
 if ( FileExist(MagellanFileMenu[index]) ) ++index;
#endif

#ifdef HP
 MagellanFileMenu[index] = "/dev/tty00";
 if ( FileExist(MagellanFileMenu[index]) ) ++index;
 MagellanFileMenu[index] = "/dev/tty01";
 if ( FileExist(MagellanFileMenu[index]) ) ++index;
 MagellanFileMenu[index] = "/dev/tty02";
 if ( FileExist(MagellanFileMenu[index]) ) ++index;

 MagellanFileMenu[index] = "/dev/tty0p0";
 if ( FileExist(MagellanFileMenu[index]) ) ++index;
 MagellanFileMenu[index] = "/dev/tty1p0";
 if ( FileExist(MagellanFileMenu[index]) ) ++index;
 MagellanFileMenu[index] = "/dev/tty0p1";
 if ( FileExist(MagellanFileMenu[index]) ) ++index;
 MagellanFileMenu[index] = "/dev/tty1p1";
 if ( FileExist(MagellanFileMenu[index]) ) ++index;
#endif

#ifdef DEC
 MagellanFileMenu[index] = "/dev/tty00";
 if ( FileExist(MagellanFileMenu[index]) ) ++index;
 MagellanFileMenu[index] = "/dev/tty01";
 if ( FileExist(MagellanFileMenu[index]) ) ++index;
 MagellanFileMenu[index] = "/dev/tty02";
 if ( FileExist(MagellanFileMenu[index]) ) ++index;
#endif

#ifdef SUN
 MagellanFileMenu[index] = "/dev/ttya";
 if ( FileExist(MagellanFileMenu[index]) ) ++index;
 MagellanFileMenu[index] = "/dev/ttyb";
 if ( FileExist(MagellanFileMenu[index]) ) ++index;
 MagellanFileMenu[index] = "/dev/ttyc";
 if ( FileExist(MagellanFileMenu[index]) ) ++index;
#endif




#ifdef IBM
 MagellanFileMenu[index] = "/dev/tty0";
 if ( FileExist(MagellanFileMenu[index]) ) ++index;
 MagellanFileMenu[index] = "/dev/tty1";
 if ( FileExist(MagellanFileMenu[index]) ) ++index;
 MagellanFileMenu[index] = "/dev/tty2";
 if ( FileExist(MagellanFileMenu[index]) ) ++index;
 MagellanFileMenu[index] = "/dev/tty3";
 if ( FileExist(MagellanFileMenu[index]) ) ++index;
 MagellanFileMenu[index] = "/dev/tty4";
 if ( FileExist(MagellanFileMenu[index]) ) ++index;
#endif

 if ( index == 1 )
  {
   printf("%s\n", LangString( LANG_NOSERIALPORT ) );
#ifdef SGI
   printf(" System Manager | Admin Tools | Serial Ports | Available\n\n");
#endif

#ifdef HP
   printf("");
#endif

#ifdef DEC
   printf("");
#endif

#ifdef SUN
   printf(" admintool [Browse Serial Ports] ... \n\n");
#endif

#ifdef IBM
   printf(" smit tty ...\n\n");
#endif
   exit( -1 );
  };

 MagellanFileMenu[index] = NULL;
 return MagellanFileMenu;
}

int DialboxMode     = FALSE;
int DialboxModeActive = FALSE;
int DialboxModeDial = 1;

int TurboSpaceMouse = FALSE;

int MagellanOpen( MagellanFileName, MagellanOptions )
char *MagellanFileName;
int MagellanOptions;
{
int MagellanHandle, result;
struct termio MagellanTermio;

#ifdef HP
mflag MagellanFlag;
#endif

#ifdef IBM
struct rs_info MagellanInfo;
#endif


#ifdef SUN
 MagellanHandle = open( MagellanFileName, MagellanOptions | O_NDELAY );
#endif

#ifdef IBM
 MagellanHandle = open( MagellanFileName, MagellanOptions | O_NDELAY );
#endif

#ifdef DEC
 MagellanHandle = open( MagellanFileName, MagellanOptions );
#endif

#ifdef HP
 MagellanHandle = open( MagellanFileName, MagellanOptions );
#endif

#ifdef SGI
 MagellanHandle = open( MagellanFileName, MagellanOptions );
#endif

 if ( MagellanHandle == -1 )
  return -1;

#ifdef SUN
 fcntl( MagellanHandle, F_SETFL, MagellanOptions );
#endif

#ifdef IBM
 result = fcntl( MagellanHandle, F_SETFL, MagellanOptions );
#endif

#ifdef HP
 MagellanFlag = MRTS | MDTR | MDRS;
 ioctl( MagellanHandle, MCSETA, &MagellanFlag );
 ioctl( MagellanHandle, MCGETA, &MagellanFlag );
#endif

#ifdef IBM
 ioctl( MagellanHandle, RS_GETA, &MagellanInfo );
 MagellanInfo.rs_rtrig = 1; /* trigger at 4 bytes */
 MagellanInfo.rs_rtrig = 2; /* trigger at 8 bytes */
 MagellanInfo.rs_rtrig = 3; /* trigger at 14 bytes */
 ioctl( MagellanHandle, RS_SETA, &MagellanInfo );
#endif

 ioctl( MagellanHandle, TCGETA, &MagellanTermio );
 
 MagellanTermio.c_iflag = IGNBRK | IGNPAR;  
 MagellanTermio.c_oflag = 0; 
 if ( TurboSpaceMouse )
  MagellanTermio.c_cflag = B19200 | CREAD | CS8 | CSTOPB | HUPCL; 
 else
  MagellanTermio.c_cflag = B9600 | CREAD | CS8 | CSTOPB | HUPCL; 

#ifdef DEC 
 MagellanTermio.c_cflag |= CLOCAL;
#endif

#ifdef IBM
 MagellanTermio.c_iflag |= IXOFF; 
 MagellanTermio.c_cflag |= CLOCAL; 
#endif

#ifdef SUN
 MagellanTermio.c_cflag |= CLOCAL;
#endif

 MagellanTermio.c_lflag = 0;	
 MagellanTermio.c_cc[VEOL] = '\r'; 
 MagellanTermio.c_cc[VERASE] = '\000'; 
 MagellanTermio.c_cc[VKILL] = '\000';
 MagellanTermio.c_cc[VMIN ] = 1; 
 MagellanTermio.c_cc[VTIME] = 0;

 result = ioctl( MagellanHandle, TCSETA, &MagellanTermio );
 if ( XDriverDebug )
  printf("[%d] I=%08X O=%08X C=%08X L=%08X \n", result,
          MagellanTermio.c_iflag, MagellanTermio.c_oflag, 
          MagellanTermio.c_cflag, MagellanTermio.c_lflag );
 
 result = ioctl( MagellanHandle, TCGETA, &MagellanTermio );
 if ( XDriverDebug )
  printf("[%d] I=%08X O=%08X C=%08X L=%08X \n", result,
          MagellanTermio.c_iflag, MagellanTermio.c_oflag, 
          MagellanTermio.c_cflag, MagellanTermio.c_lflag );
 
 return MagellanHandle;
}

int MagellanClose( MagellanHandle )
int MagellanHandle;
{
 close( MagellanHandle );
 return TRUE;
}

void MagellanDebugBuffer( Message, Buffer )
char *Message;
char *Buffer;
{
int length, loop, print;
char Line[128];

 length = strlen( Buffer );
 if ( length == 0 )
  return;

 printf("\n%s\n", Message);
 for ( loop=0; loop<length; ++loop )
  {
   if ( (loop % 16) == 0 )
    {
     memset( Line, ' ', sizeof( Line ) );
     sprintf( Line, "%04X", loop );  Line[4] = ' ';
     Line[ 69 ] = '\000';
     print = FALSE;
    };
  
   sprintf( &Line[5+3*(loop%16)], "%02X", Buffer[loop] & 0x00FF ); Line[5+3*(loop%16)+2] = ' ';
   Line[5+45+3+(loop%16)] = isprint( Buffer[loop] & 0x00FF) ? Buffer[loop] & 0x00FF : '.'; 

   if ( (loop % 16) == 15 )
    {
     printf("%s\n", Line );
     print = TRUE;
    };
  };

 if ( print == FALSE )
  printf("%s\n", Line );
}

char MagellanInitString[] = "\rz\rz\r";
char MagellanExistString[] = "\r\rvQ\r";
char MagellanModeOffString[] = "\r\rm0\r";

struct _MagellanSearchFile_ {
 char *MagellanFileName;
 int MagellanHandle;
 int MagellanExist;
};
typedef struct _MagellanSearchFile_ MagellanSearchFile;

int MagellanSearchChoice( MagellanFileMenu )
char *MagellanFileMenu[];
{
MagellanSearchFile MagellanFiles[16];
char MagellanBuffer[ 128 ];
int found,count,loop;
int ExtendedSecond;

 found = FALSE;
 memset( MagellanFiles, 0x00, sizeof(MagellanFiles) );

 count = 0;
 while ( MagellanFileMenu[count+1] != NULL )
  ++count;

 for ( loop=0; loop<count; ++loop )
  {
   MagellanFiles[loop].MagellanFileName = MagellanFileMenu[loop+1];

   chmod( MagellanFiles[loop].MagellanFileName, 
		S_IWOTH | S_IROTH |
                S_IWGRP | S_IRGRP |
                S_IWUSR | S_IRUSR );
   MagellanProcessTTY( MagellanFiles[loop].MagellanFileName );

#ifdef SGI
   if ( MagellanDevInput(MagellanFiles[loop].MagellanFileName,"ls -al /dev/input") ||
        MagellanDevInput(MagellanFiles[loop].MagellanFileName,"ls -al /dev/input1")||
        MagellanDevInput(MagellanFiles[loop].MagellanFileName,"ls -al /dev/input2") )
    MagellanFiles[loop].MagellanHandle = -1;
   else
    MagellanFiles[loop].MagellanHandle = MagellanOpen( 
     MagellanFiles[loop].MagellanFileName, O_RDWR | O_NDELAY );
#else
   MagellanFiles[loop].MagellanHandle = MagellanOpen( 
    MagellanFiles[loop].MagellanFileName, O_RDWR | O_NDELAY );
#endif
  };

 printf("%s\n\n", LangString(LANG_PLEASEWAIT) );
 MagellanWait( 1000 );

 for ( loop=0; loop<count; ++loop )
  {
   if ( MagellanFiles[loop].MagellanHandle >= 0 )
    {
     MagellanTransmit( MagellanFiles[loop].MagellanHandle, MagellanModeOffString );
    };
  };

 MagellanWait( 100 );

 for ( loop=0; loop<count; ++loop )
  {
   if ( MagellanFiles[loop].MagellanHandle >= 0 )
    {
     MagellanTransmit( MagellanFiles[loop].MagellanHandle, MagellanInitString );
    };
  };

 MagellanWait( 100 );

 for ( loop=0; loop<count; ++loop )
  {
   if ( MagellanFiles[loop].MagellanHandle >= 0 )
    {
     MagellanTransmit( MagellanFiles[loop].MagellanHandle, MagellanExistString );
    };
  };

 MagellanWait( 200 );

 for ( loop=0; loop<count; ++loop )
  {
   ExtendedSecond = TRUE;
   do
    {
     memset( MagellanBuffer, 0x00, sizeof(MagellanBuffer) );

     if ( MagellanFiles[loop].MagellanHandle >= 0 )
      read( MagellanFiles[loop].MagellanHandle, MagellanBuffer, sizeof(MagellanBuffer)-1 );

     if ( strlen( MagellanBuffer ) >= sizeof( MagellanBuffer ) - 10 )  
      { /*| a lot of data's come in, wait a extended second |*/
       if ( ExtendedSecond )
        {
         MagellanWait( 1000 );
         MagellanTransmit( MagellanFiles[loop].MagellanHandle, MagellanExistString );
         MagellanWait( 100 );
        };
       ExtendedSecond = FALSE;
      };

     if ( XDriverDebug )
      {
       MagellanDebugBuffer( "Receive", MagellanBuffer );
      };

     if ( found == FALSE )
      if ( (strstr( MagellanBuffer, "MAGELLAN" ) != NULL) ||
           (strstr( MagellanBuffer, "LOGITECH" ) != NULL) ||
           (strstr( MagellanBuffer, "SPACE CONTROL" ) != NULL) ||
           (strstr( MagellanBuffer, "SPACE MOUSE" ) != NULL) )
       found = loop+1;
    } while( (int)strlen( MagellanBuffer ) > 0 );

   if ( MagellanFiles[loop].MagellanHandle >= 0 )
    MagellanClose( MagellanFiles[loop].MagellanHandle );
  };

 return found;
}

int MagellanExist( )
{
char *MagellanFileMenuTest[3];

 MagellanFileMenuTest[0] = "";
 MagellanFileMenuTest[1] = NULL;
 MagellanFileMenuTest[2] = NULL;

 MagellanFileMenuTest[1] = MagellanFileName;
 return MagellanSearchChoice( MagellanFileMenuTest ) == 1;
}

void MagellanWait( WaitTime )
clock_t WaitTime;
{
clock_t start,stop;

 if ( WaitTime >= 1000 )
  {
   sleep( 1 );
   MagellanWait( WaitTime - 1000 );
  }
  else
  {
   start = clock();
   do
    {
     stop = clock();
    }while( labs(stop-start) < WaitTime*CLOCKS_PER_SEC/1000 );
  };
}

/*|-------------|*/
/*| Config file |*/
/*|-------------|*/

int ConfigWrite( FileName )
char *FileName;
{
FILE *FileHandle;

 FileHandle = fopen( FileName, "wt" );
 if ( FileHandle == NULL )
  {
   printf("%s [%s]\n", LangString(LANG_CANTOPENFILE), FileName );
   exit( -1 );
  };

 fprintf( FileHandle, "%s\n", LanguageMenu[Language] );
 fprintf( FileHandle, "%s\n", ContinentMenu[Language][CustomerLocation] );
 fprintf( FileHandle, "%s\n", LangString( LANG_DEVICENAME ) );
 fprintf( FileHandle, "%s\n", MagellanFileName );
 fprintf( FileHandle, "%s\n", ApplicationMenu[Application] );

 fprintf( FileHandle, "%s\n", YesNoMenu[Language][MagellanModeChange] );
 fprintf( FileHandle, "%s\n", MagellanModeMenu[Language][MagellanModeDefault] );

 fprintf( FileHandle, "%s\n", YesNoMenu[Language][MagellanSensitivityChange] );
 fprintf( FileHandle, "%s\n", MagellanSensTranMenu[MagellanSensTranDefault] );
 fprintf( FileHandle, "%s\n", MagellanSensRotMenu[MagellanSensRotDefault] );

 fprintf( FileHandle, "%s\n", YesNoMenu[Language][MagellanNullRadiusChange] );
 fprintf( FileHandle, "%s\n", MagellanNullRadiusMenu[MagellanNullRadiusDefault]);

 fprintf( FileHandle, "%s\n", YesNoMenu[Language][NonLinearFlag] );

 fprintf( FileHandle, "%s\n", YesNoMenu[Language][CoordinateSystemChange] );

 fprintf( FileHandle, "%d %d %d  GREEN \n",
	  GREEN.red/256,     GREEN.green/256,     GREEN.blue/256 );
 fprintf( FileHandle, "%d %d %d  BLUE  \n",
	  BLUE.red/256,      BLUE.green/256,      BLUE.blue/256 );
 fprintf( FileHandle, "%d %d %d  STEELBLUE \n",
	  STEELBLUE.red/256, STEELBLUE.green/256, STEELBLUE.blue/256 );
 fprintf( FileHandle, "%d %d %d  LIGHTGRAY \n",
	  LIGHTGRAY.red/256, LIGHTGRAY.green/256, LIGHTGRAY.blue/256 );

 fprintf( FileHandle, "%d\n", MagellanStatusDisplayFlag );

 fclose( FileHandle );
 return TRUE;
}

int ConfigSearch( Entry, MenuEntries )
char *Entry;
char *MenuEntries[];
{
int index;

 index = 0;
 do
  {
   if ( MenuEntries[index] == NULL )
    return -1;
   if ( strcmp( Entry, MenuEntries[index] ) == 0 )
    return index;
   ++index;
  } while ( _TRUE_ ); 
 return TRUE;
}

char *ConfigReadLine( Buffer, BufferLength, Handle )
char *Buffer;
int BufferLength;
FILE *Handle;
{
 memset( Buffer, 0x00, BufferLength );
 fgets( Buffer, BufferLength, Handle ); 
 if ( strlen(Buffer) == 0 ) 
  strcpy( Buffer, "\n" );
 Buffer[ strlen(Buffer) - 1 ] = '\000';

 return Buffer;
}

int ConfigRead( FileName )
char *FileName;
{
FILE *FileHandle;
char Buffer[512];

 FileHandle = fopen( FileName, "rt" );
 if ( FileHandle == NULL )
  {
   printf("%s [%s]\n", LangString(LANG_CANTOPENFILE), FileName );
   exit( -1 );
  };

/* LANGUAGE */
 ConfigReadLine( Buffer, sizeof(Buffer), FileHandle );
 Language = ConfigSearch( Buffer, LanguageMenu );
 if ( Language == -1 )
  {
   Language = ENGLISH;
   Language = MenuChoice( LanguageMenu, LangString(LANG_LANGUAGETITLE)) - 1;
   if ( Language == -1 )
    exit( -1 );
  };

/* LOCATION */
 ConfigReadLine( Buffer, sizeof(Buffer), FileHandle );
 CustomerLocation = ConfigSearch( Buffer, ContinentMenu[Language] );
 if ( CustomerLocation == -1 )
  {
   CustomerLocation = MenuChoice( ContinentMenu[Language],
                                  LangString(LANG_CONTINENTTITLE) ) - 1;
   if ( CustomerLocation == -1 )
    exit(-1);
  };

/* DEVICE NAME */
 ConfigReadLine( Buffer, sizeof(Buffer), FileHandle );
 if ( (strcmp( Buffer, "MAGELLAN" ) != 0) &&
      (strcmp( Buffer, "SPACE MOUSE" ) != 0) )
  exit(-1);
 if ( (CustomerLocation == AMERICA) || (CustomerLocation == ASIA) )
  DeviceName = MAGELLAN;
 else
  DeviceName = SPACEMOUSE;


/* SERIAL DEVICE NAME */
 ConfigReadLine( Buffer, sizeof(Buffer), FileHandle );
 strcpy( MagellanFileName, Buffer );

/* APPLICATION NAME */
 ConfigReadLine( Buffer, sizeof(Buffer), FileHandle );
 Application = ConfigSearch( Buffer, ApplicationMenu );
 if ( Application == -1 )
  {
   Application = MenuChoice( ApplicationMenu, 
                             LangString(LANG_APPLICATIONTITLE) ) - 1;
   if ( Application == -1 )
    exit( -1 );
   ApplicationChoice( Application );
  };

/* MODE */
 ConfigReadLine( Buffer, sizeof(Buffer), FileHandle );
 MagellanModeChange = ConfigSearch( Buffer, YesNoMenu[ Language ] );
 if ( MagellanModeChange == -1 )
  {
   MagellanModeChange = MenuChoice( YesNoMenu[ Language ],
		  	            LangString( LANG_MODECHANGE ) ) - 1;
   if ( MagellanModeChange == -1 )
    exit( -1 );
  };

 ConfigReadLine( Buffer, sizeof(Buffer), FileHandle );
 MagellanModeDefault = ConfigSearch( Buffer, MagellanModeMenu[ Language ] );
 if ( MagellanModeDefault == -1 )
  {
   MagellanModeDefault = MenuChoice( MagellanModeMenu[ Language ],
				     LangString( LANG_MODEDEFAULT ) ) - 1;
   if ( MagellanModeDefault == -1 )
    exit( -1 );
  };
 sprintf( Buffer, "m%c\r", MagellanNibbleTable[
                             MagellanModeDefaultTable[MagellanModeDefault] ] );
 strcpy( MagellanMode, Buffer );


/* SENSITIVITY */
 ConfigReadLine( Buffer, sizeof(Buffer), FileHandle );
 MagellanSensitivityChange = ConfigSearch( Buffer, YesNoMenu[ Language ] );
 if ( MagellanSensitivityChange == -1 )
  {
   MagellanSensitivityChange = MenuChoice( YesNoMenu[ Language ],
				 LangString( LANG_SENSITIVITYCHANGE ) ) - 1;
   if ( MagellanSensitivityChange == -1 )
    exit( -1 );
  };

 ConfigReadLine( Buffer, sizeof(Buffer), FileHandle );
 MagellanSensTranDefault = ConfigSearch( Buffer, MagellanSensTranMenu );
 if ( MagellanSensTranDefault == -1 )
  {
   MagellanSensTranDefault = MenuChoice( MagellanSensTranMenu,
					 LangString( LANG_SENSTRANDEFAULT ) ) - 1;
   if ( MagellanSensTranDefault == -1 )
    exit( -1 );
  };

 ConfigReadLine( Buffer, sizeof(Buffer), FileHandle );
 MagellanSensRotDefault = ConfigSearch( Buffer, MagellanSensRotMenu );
 if ( MagellanSensRotDefault == -1 )
  {
   MagellanSensRotDefault = MenuChoice( MagellanSensRotMenu,
					LangString( LANG_SENSROTDEFAULT ) ) - 1;
   if ( MagellanSensRotDefault == -1 )
    exit( -1 );
  }; 
 sprintf( Buffer, "q%c%c\r", MagellanNibbleTable[ MagellanSensTranDefault ],
	                      MagellanNibbleTable[ MagellanSensRotDefault ] );
 strcpy( MagellanSensitivity, Buffer );


/* NULL RADIUS */
 ConfigReadLine( Buffer, sizeof(Buffer), FileHandle );
 MagellanNullRadiusChange = ConfigSearch( Buffer, YesNoMenu[ Language ] );
 if ( MagellanNullRadiusChange == -1 )
  {
   MagellanNullRadiusChange = MenuChoice( YesNoMenu[ Language ],
				 LangString( LANG_NULLRADIUSCHANGE ) ) - 1;
   if ( MagellanNullRadiusChange == -1 )
    exit( -1 );
  };

 ConfigReadLine( Buffer, sizeof(Buffer), FileHandle );
 MagellanNullRadiusDefault = ConfigSearch( Buffer, MagellanNullRadiusMenu );
 if ( MagellanNullRadiusDefault == -1 )
  {
   MagellanNullRadiusDefault = MenuChoice( MagellanNullRadiusMenu,
				     LangString( LANG_NULLRADIUSDEFAULT ) ) - 1;
   if ( MagellanNullRadiusDefault == -1 )
    exit( -1 );
  };
 if ( MagellanNullRadiusDefault < 8 )    /* not smaller then 8! */
  MagellanNullRadiusDefault = 8;
 sprintf( Buffer, "n%c\r", MagellanNibbleTable[ MagellanNullRadiusDefault ] );
 strcpy( MagellanNullRadius, Buffer );


/* NONLINEAR FUNCTION */
 ConfigReadLine( Buffer, sizeof(Buffer), FileHandle );
 NonLinearFlag = ConfigSearch( Buffer, YesNoMenu[ Language ] );
 if ( NonLinearFlag == -1 )
  {
   NonLinearFlag = MenuChoice( YesNoMenu[ Language ],
				LangString( LANG_NONLINEAR ) ) - 1;
   if ( NonLinearFlag == -1 )
    exit( -1 );
  };

/* COORDINATE SYSTEM CHANGE */
 ConfigReadLine( Buffer, sizeof(Buffer), FileHandle );
 CoordinateSystemChange = ConfigSearch( Buffer, YesNoMenu[ Language ] );
 if ( CoordinateSystemChange == -1 )
  {
   exit( -1 );
  };

/* COLORS */
 ConfigReadLine( Buffer, sizeof(Buffer), FileHandle );
 ReadColor( Buffer, &GREEN );

 ConfigReadLine( Buffer, sizeof(Buffer), FileHandle );
 ReadColor( Buffer, &BLUE );

 ConfigReadLine( Buffer, sizeof(Buffer), FileHandle );
 ReadColor( Buffer, &STEELBLUE );

 ConfigReadLine( Buffer, sizeof(Buffer), FileHandle );
 ReadColor( Buffer, &LIGHTGRAY );

/* STATUS WINDOW ENABLE */ 
 ConfigReadLine( Buffer, sizeof(Buffer), FileHandle );
 MagellanStatusDisplayFlag = atoi(Buffer);

 fclose( FileHandle );

 return TRUE;
}

int ConfigFileCreate( FileName, argv )
char *FileName;
char *argv[];
{
int MagellanFile, MagellanDefault;
char **MagellanFileMenu;
char *MagellanFileMenuTest[3];
#ifdef SUN
char SUNCommand[ 256 ];
#endif
char StatusDisplayQuestion[ 128 ];
char TERMStartupText[ 256 ];

 MagellanFileMenuTest[0] = "";
 MagellanFileMenuTest[1] = NULL;
 MagellanFileMenuTest[2] = NULL;

 Language = MenuChoice( LanguageMenu, LangString(LANG_LANGUAGETITLE)) - 1;
 if ( Language == -1 )
  exit( -1 );

 CustomerLocation = MenuChoice( ContinentMenu[Language],
  LangString(LANG_CONTINENTTITLE) ) - 1;
 if ( CustomerLocation == -1 )
  exit(-1);

 if ( (CustomerLocation == AMERICA) || (CustomerLocation == ASIA) )
  DeviceName = MAGELLAN;
 else
  DeviceName = SPACEMOUSE;

#ifdef IBM
 printf( LangString( LANG_IBMNOTE ), LangString( LANG_DEVICENAME ) );
#endif

 ShellFile( argv[0], "startup.sh",  ShellStartup );
 ShellFile( argv[0], "startup.csh", CShellStartup );
 ShellFile( argv[0], "startup.ksh", KShellStartup );

 if ( FileExist( UsrMagellanXDriver ) ) 
  sprintf( TERMStartupText, TERMStartup, LangString(LANG_DEVICENAME),
           UsrMagellanXDriver );
 else
  sprintf( TERMStartupText, TERMStartup, LangString(LANG_DEVICENAME), argv[0] );
 ShellFile( argv[0], "startup.xterm", TERMStartupText );

 MagellanFileMenu = MagellanCreateFileMenu();
 MagellanFile = MenuChoice( MagellanFileMenu, LangString(LANG_FILEMENUTITLE) ) - 1;
 switch( MagellanFile )
  {
   case -1 : exit( -1 );

   case  0 : 
    MagellanFile = MagellanSearchChoice( MagellanFileMenu );
    if ( MagellanFile == 0 )
     {
      printf("%s %s %s\n", LangString( LANG_DEVICENAME ), 
       LangString( LANG_MAGELLANNOTFOUND ), "..." );
      exit( -1 );
     };
    strcpy( MagellanFileName, MagellanFileMenu[MagellanFile] );
    printf("%s %s %s\n", LangString( LANG_DEVICENAME ), 
       LangString( LANG_MAGELLANFOUND ), MagellanFileName );
    break;

   default : 
    MagellanFileMenuTest[1] = MagellanFileMenu[MagellanFile];
    MagellanFile = MagellanSearchChoice( MagellanFileMenuTest );
    if ( MagellanFile == 0 )
     {
      printf("%s %s %s\n", LangString( LANG_DEVICENAME ), 
       LangString( LANG_MAGELLANNOTFOUND ), MagellanFileMenuTest[1] );
      exit( -1 );
     };
    strcpy( MagellanFileName, MagellanFileMenuTest[1] );
    printf("%s %s %s\n", LangString( LANG_DEVICENAME ), 
       LangString( LANG_MAGELLANFOUND ), MagellanFileName );
    break;
  };
 printf("\n");

 Application = MenuChoice( ApplicationMenu, 
  LangString(LANG_APPLICATIONTITLE) ) - 1;
 if ( Application == -1 )
  exit( -1 );
 ApplicationChoice( Application );

 MagellanDefault = MenuChoice( YesNoMenu[Language],
				LangString( LANG_SETTINGSorDEFAULT ) ) -1;
 if ( MagellanDefault == -1 )
  exit( -1 );

 if ( MagellanDefault == NO )
  {
   MagellanModeChange = MenuChoice( YesNoMenu[Language], 
			 LangString( LANG_MODECHANGE ) ) - 1;
   if ( MagellanModeChange == -1 )
    exit( -1 );

   MagellanModeDefault = MenuChoice( MagellanModeMenu[Language],
				   LangString( LANG_MODEDEFAULT ) ) - 1;
   if ( MagellanModeDefault == - 1)
    exit( -1 );

   MagellanSensitivityChange = MenuChoice( YesNoMenu[Language], 
			 LangString( LANG_SENSITIVITYCHANGE ) ) - 1;
   if ( MagellanSensitivityChange == -1 )
    exit( -1 );

   MagellanSensTranDefault = MenuChoice( MagellanSensTranMenu,
				       LangString( LANG_SENSTRANDEFAULT ) ) - 1;
   if ( MagellanSensTranDefault == -1 )
    exit( -1 );

   MagellanSensRotDefault = MenuChoice( MagellanSensRotMenu,
				      LangString( LANG_SENSROTDEFAULT ) ) - 1;
   if ( MagellanSensRotDefault == -1 )
    exit( -1 );


   MagellanNullRadiusChange = MenuChoice( YesNoMenu[Language], 
			 LangString( LANG_NULLRADIUSCHANGE ) ) - 1;
   if ( MagellanNullRadiusChange == -1 )
    exit( -1 );

   MagellanNullRadiusDefault = MenuChoice( MagellanNullRadiusMenu,
					 LangString( LANG_NULLRADIUSDEFAULT ) ) - 1;
   if ( MagellanNullRadiusDefault == -1 )
    exit( -1 );


   NonLinearFlag = MenuChoice( YesNoMenu[ Language ],
  				LangString( LANG_NONLINEAR ) ) - 1;
   if ( NonLinearFlag == -1 )
    exit( -1 );

   CoordinateSystemChange = NO;
   if ( CoordinateSystemChange == -1 )
    exit( -1 );

   sprintf( StatusDisplayQuestion, LangString( LANG_STATUSDISPLAY ),
	                           LangString( LANG_DEVICENAME ) );
   MagellanStatusDisplayFlag = MenuChoice( YesNoMenu[ Language ], StatusDisplayQuestion ) -1;
   if ( MagellanStatusDisplayFlag == -1 )
    exit( -1 );
  }
 else
  {
   switch( Application )
    {
     case OLDVERSION :
     case NEWVERSION :
      MagellanModeChange = YES;
      MagellanModeDefault = 0;
      MagellanSensitivityChange = YES;
      MagellanSensTranDefault = 0;
      MagellanSensRotDefault = 0;
      MagellanNullRadiusChange = YES;
      MagellanNullRadiusDefault = 8;
      NonLinearFlag = NO;
      CoordinateSystemChange = NO;
      MagellanStatusDisplayFlag = YES;
      break;

     case IDEAS:
     case SIMPACK:
     case PROENGINEER_17:
      MagellanModeChange = YES;
      MagellanModeDefault = 0;
      MagellanSensitivityChange = YES;
      MagellanSensTranDefault = 0;
      MagellanSensRotDefault = 0;
      MagellanNullRadiusChange = YES;
      MagellanNullRadiusDefault = 8;
      NonLinearFlag = NO;
      CoordinateSystemChange = NO;
      MagellanStatusDisplayFlag = NO;
      break;

     case DUALVERSION : 
     case PROENGINEER_16 :
     case CATIA_400 : 
     case CATIA_416 :
      MagellanModeChange = NO;
      MagellanModeDefault = 0;
      MagellanSensitivityChange = NO;
      MagellanSensTranDefault = 0;
      MagellanSensRotDefault = 0;
      MagellanNullRadiusChange = NO;
      MagellanNullRadiusDefault = 8;
      NonLinearFlag = NO;
      CoordinateSystemChange = NO;
      MagellanStatusDisplayFlag = NO;
      break;

     case PROENGINEER_15 :
     case CADDS5 :
     case UNIGRAPHICS :
     case UNIGRAPHICS_11 :
     case SOLIDDESIGNER : 
      MagellanModeChange = NO;
      MagellanModeDefault = 0;
      MagellanSensitivityChange = NO;
      MagellanSensTranDefault = 2;
      MagellanSensRotDefault = 0;
      MagellanNullRadiusChange = NO;
      MagellanNullRadiusDefault = 8;
      NonLinearFlag = YES;
      CoordinateSystemChange = NO;
      MagellanStatusDisplayFlag = NO;
      break;

     default : break; 
    };
  
   if ( !FileExist( KeyboardFilePtr ) )
    {
     switch( Application )
      {
       case SIMPACK :
       case IDEAS :
       case PROENGINEER_16 :
       case PROENGINEER_17 :
        KeyboardFileCreate( KeyboardFilePtr,
"1:ENABLE\n\
2:ENABLE\n\
3:ENABLE\n\
4:ENABLE\n\
5:ENABLE\n\
6:ENABLE\n\
7:ENABLE\n\
8:ENABLE\n\
*:ENABLE\n" );
	break;

      case CATIA_400 : 
       KeyboardFileCreate( KeyboardFilePtr,
"1:MAPPING,+XK_Alt_L,XK_Up,-XK_Alt_L\n\
2:ENABLE\n\
3:ENABLE\n\
4:ENABLE\n\
5:ENABLE\n\
6:MAPPING,XK_Up\n\
7:MAPPING,XK_Down\n\
8:ENABLE\n\
*:ENABLE\n" );
       break;

      case CATIA_416 : 
       KeyboardFileCreate( KeyboardFilePtr,
"1:MAPPING,+XK_Alt_L,XK_Up,-XK_Alt_L\n\
2:ENABLE\n\
3:ENABLE\n\
4:ENABLE\n\
5:ENABLE\n\
6:ENABLE\n\
7:ENABLE\n\
8:ENABLE\n\
*:ENABLE\n" );
       break;

      case DUALVERSION :
      case OLDVERSION :
      case NEWVERSION :
      case PROENGINEER_15 :
      case CADDS5 :
      case UNIGRAPHICS :
      case UNIGRAPHICS_11 :
      case SOLIDDESIGNER : 
       KeyboardFileCreate( KeyboardFilePtr,
"1:ENABLE\n\
2:ENABLE\n\
3:ENABLE\n\
4:ENABLE\n\
5:ENABLE\n\
6:ENABLE\n\
7:ENABLE\n\
8:ENABLE\n\
*:ENABLE\n" );
        break;
	
      };	
    }
   else
    {
     printf("%s\n [%s]\n", LangString( LANG_DONTOVERWRITE ), FileKeyboard( argv[0] ) );
    };
  };

 ConfigWrite( FileName );
#ifdef SUN
 sprintf( SUNCommand, "/usr/sbin/pmadm -d -p zsmon -s tty%c", MagellanFileName[ strlen(MagellanFileName) - 1 ] );
 system( SUNCommand );
#endif

 return ConfigRead( FileName );
}

short ReadColorValue( StringIn, StringOut )
char *StringIn;
char **StringOut;
{
char *ptr;

 *StringOut = NULL;
 if ( StringIn == NULL )
  return 0;

 for ( ptr=StringIn; !isdigit(*ptr); ++ptr )
  if ( *ptr == '\000' )
   return 0;

 StringIn = ptr;
 for ( ptr=StringIn; isdigit(*ptr); ++ptr )
  if ( *ptr == '\000' )
   return 0;

 *StringOut = ptr;

 return atoi( StringIn );
}

void ReadColor( String, Color )
char *String;
XColor *Color;
{
 Color->red   = ReadColorValue( String, &String ) * 256;
 Color->green = ReadColorValue( String, &String ) * 256;
 Color->blue  = ReadColorValue( String, &String ) * 256; 
}

int KeyboardFileCreate( FileName, FileContents )
char *FileName;
char *FileContents;
{
FILE *FileHandle;

 FileHandle = fopen( FileName, "wt" );
 if ( FileHandle == NULL )
  {
   printf("%s [%s]\n", LangString(LANG_CANTOPENFILE), FileName );
   exit( -1 );
  };

 fprintf( FileHandle, "%s\n", FileContents );

 fclose( FileHandle );
 return TRUE;
}

/*| ------------------------------- |*/
/*| Parse Magellan Driver Arguments |*/
/*| ------------------------------- |*/

void ParseArg( display, argv, argc, phase, configflag )
Display *display;
char *argv[];
int argc;
int phase;
int configflag;
{
int loop, found, texte, nonew;
char TERMStartupText[ 256 ];

 nonew = TRUE;
 for ( loop=1; loop<argc; ++loop )
  {
   found = FALSE;

   if ( argv[loop][0] == '-' )
    if ( argv[loop][1] == 'n' )
     if ( atoi(&argv[loop][2])  >= 8 )
      {
       if ( phase == 1 )
        sprintf( MagellanNullRadius, "n%c\r", 
  		 MagellanNibbleTable[ atoi(&argv[loop][2]) ] );
       found = TRUE;
      };

   if ( strcmp( argv[loop], "-new" ) == 0 )
    {
     if ( phase == 1 )
      {
       unlink( GlobalConfig );
       unlink( LocalConfig );
      }; 
     if ( phase == 2 )
      MagellanDemonstrationCube( display, argv, argc );
     found = TRUE;
     nonew = FALSE;
    }

   if ( strcmp( argv[loop], "-test" ) == 0 )
    {
     if ( phase == 2 )
      MagellanDemonstration( display, argv, argc );
     found = TRUE;
     nonew = FALSE;
    };

   if ( strcmp( argv[loop], "-graphics" ) == 0 )
    {
     if ( phase == 2 )
      MagellanDemonstrationCube( display, argv, argc );
     found = TRUE;
     nonew = FALSE;
    };

   if ( strcmp( argv[loop], "-dialmode" ) == 0 )
    {
     DialboxMode = TRUE;
     found = TRUE;
    };
  
   if ( strcmp( argv[loop], "-turbo" ) == 0 )
    {
     TurboSpaceMouse = TRUE;
     found = TRUE;
    };
  
   if ( strcmp( argv[loop], "-debug" ) == 0 )
    {
     XDriverDebug = TRUE;
     found = TRUE;
    };
  
   if ( strcmp( argv[loop], "-startup" ) == 0 )
    {
     if ( phase == 1 )
      {
       ShellFile( argv[0], "startup.sh",  ShellStartup );
       ShellFile( argv[0], "startup.csh", CShellStartup );
       ShellFile( argv[0], "startup.ksh", KShellStartup );
       sprintf( TERMStartupText, TERMStartup, LangString( LANG_DEVICENAME ), argv[0] );
       ShellFile( argv[0], "startup.xterm", TERMStartupText );
       exit(0);
      };
    };

#ifdef IBM   
   if ( strcmp( argv[loop], "-ibmtty" ) == 0 )
    {
     if ( phase == 1 )
      {
       IBMttyBufferSize( "/dev/tty0", IBMBUFFERSIZE );
       IBMttyBufferSize( "/dev/tty1", IBMBUFFERSIZE );
       IBMttyBufferSize( "/dev/tty2", IBMBUFFERSIZE );
      };
     exit(0);
    };
#endif
   
   if ( strcmp( argv[loop], "-texte" ) == 0 )
    {
     if ( phase == 1 )
      {
       PrintMenuTexte( LanguageMenu );
       
       PrintMenuTexte( ContinentMenuDeutsch );
       PrintMenuTexte( ContinentMenuEnglish );
       PrintMenuTexte( ContinentMenuFrance );
       PrintMenuTexte( ContinentMenuSpain );
       
       PrintMenuTexte( YesNoMenuDeutsch );
       PrintMenuTexte( YesNoMenuEnglish );
       PrintMenuTexte( YesNoMenuFrance );
       PrintMenuTexte( YesNoMenuSpain );

       PrintMenuTexte( MagellanModeMenuDeutsch );
       PrintMenuTexte( MagellanModeMenuEnglish );
       PrintMenuTexte( MagellanModeMenuFrance );
       PrintMenuTexte( MagellanModeMenuSpain );
       
       for ( texte = LANG_VERSION1; texte < LANG_AUTHOR; ++texte )
	for ( Language = GERMAN; Language <= SPAIN; ++Language )
	 {
	  if ( Language == GERMAN )
	   printf("\n");
	  printf("[%3d %s] = %s \n", texte, LanguageMenu[Language], 
		  LangString( texte ), "", "" );
	 };
       exit( 0 );
      };
     found = TRUE;
    };
  
   if ( argv[loop][0] == '-' )
    {
     switch( argv[loop][1] )
      {
       case 's' : 
        switch( argv[loop][2] )
         {
          case 'x' : 
           MagellanExternalScalingTranslationX = atof( &argv[loop][3] ); 
           break;
          case 'y' : 
           MagellanExternalScalingTranslationY = atof( &argv[loop][3] ); 
           break;
          case 'z' : 
           MagellanExternalScalingTranslationZ = atof( &argv[loop][3] ); 
           break;
          case 'a' : 
           MagellanExternalScalingRotationA = atof( &argv[loop][3] ); 
           break;
          case 'b' : 
           MagellanExternalScalingRotationB = atof( &argv[loop][3] ); 
           break;
          case 'c' : 
           MagellanExternalScalingRotationC = atof( &argv[loop][3] ); 
           break;

          case 't' : 
           MagellanExternalScalingTranslation = atof( &argv[loop][3] ); 
           break;

          case 'r' :
           MagellanExternalScalingRotation = atof( &argv[loop][3] );
           break;

          default :
           MagellanExternalScalingTranslation =
           MagellanExternalScalingRotation = atof( &argv[loop][2] );
           break;
         };
       if ( phase == 2 )
        {
         if ( MagellanExternalScalingPrint == FALSE )
          {
           printf( LangString( LANG_EXTSCALING ),
            MagellanExternalScalingTranslation, 
	    MagellanExternalScalingTranslationX,
	    MagellanExternalScalingTranslationY,
	    MagellanExternalScalingTranslationZ,
	    MagellanExternalScalingRotation,
	    MagellanExternalScalingRotationA,
	    MagellanExternalScalingRotationB,
	    MagellanExternalScalingRotationC );
           MagellanExternalScalingPrint = TRUE;
          };
        };
       found = TRUE;
      };
    };
 
   if ( found == FALSE )
    {
     printf("\n\n%s\n%s\n", argv[0], LangString( LANG_USAGE ) );
    };
  };

 if ( configflag && nonew && (phase==2) )
  MagellanDemonstrationCube( display, argv, argc );
}



pid_t MagellanChildProcess;

void MagellanDemonstration( display, argv, argc )
Display *display;
char *argv[];
int argc;
{
Window demowindow;
int screen,width,height;
XEvent event;
KeySym keysym;
GC windowgc;
XGCValues xgcvalues;
char *windowtext, windowversion[128], string[128], keyboardstring[ 48 ];
XTextProperty windowname;
char *FontName;
Font fontname;
Atom InternAtomNew, InternAtomOld, WMDeleteWindow, WMProtocols;

 MagellanChildProcess = fork();
 if ( MagellanChildProcess == 0 )
  {
   XSetErrorHandler( MagellanErrorHandler );  

   display = XOpenDisplay( NULL );
   screen = DefaultScreen( display );
   width = DisplayWidth( display, screen );
   height = DisplayHeight( display, screen );

   demowindow = XCreateSimpleWindow( display, RootWindow(display,screen), 0,0,
 		                     width*3/5,height/6, 20,
		                     BlackPixel(display,screen),
				     WhitePixel(display,screen) );

   sprintf( windowversion,"********** %s %s %s **********", 
				      LangString( LANG_DEVICENAME ),
				      LangString( LANG_VERSION2 ),
				      LangString( LANG_VERSION3 ) );
   windowtext = windowversion; 

   XStringListToTextProperty( &windowtext, 1, &windowname );

   XSetWMProperties( display, demowindow, &windowname, NULL, argv,
			 argc, NULL, NULL, NULL );

   WMProtocols = XInternAtom( display, "WM_PROTOCOLS", FALSE );
   WMDeleteWindow = XInternAtom( display, "WM_DELETE_WINDOW", FALSE );
   XSetWMProtocols( display, demowindow, &WMDeleteWindow, 1);

   XSelectInput( display, demowindow, KeyPressMask | KeyReleaseMask |
		  ButtonPressMask | ButtonReleaseMask );

   xgcvalues.foreground = BlackPixel( display, 0 );
   xgcvalues.background = WhitePixel( display, 0 );
   windowgc = XCreateGC( display, demowindow, 
			 GCForeground | GCBackground, &xgcvalues );

   FontName = XFontName( display );
   if ( FontName != NULL )
    {
     fontname = XLoadFont( display, FontName );
     XSetFont( display, windowgc, fontname );
    }
   else
    {
     printf("%s\n", LangString( LANG_NOFONT ) );
     exit( -1 );
    };

   XMapWindow( display, demowindow );

   MagellanSetWindow( display, demowindow );

   keysym = ~XK_Escape;
   strcpy( keyboardstring, "" );
   
   while ( keysym != XK_Escape )
    {
     XNextEvent( display, &event );
     switch( event.type )
      {
       case MotionNotify :
	printf("MotionNotify\n");
        printf(" Type=%d Serial=%ld Event=%d Display=%08X Window=%08X \n",
		 event.xmotion.type, event.xmotion.serial, event.xmotion.send_event,
		 event.xmotion.display, event.xmotion.window );
        printf(" Root=%08X SubWindow=%08X Time=%ld \n",
		 event.xmotion.root, event.xmotion.subwindow, event.xmotion.time );
        printf(" x=%d y=%d x_root=%d y_root=%d state=%d is_hint=%d screen=%d\n\n",
		 event.xmotion.x, event.xmotion.y, 
		 event.xmotion.x_root, event.xmotion.y_root,
		 event.xmotion.state, event.xmotion.is_hint,
		 event.xmotion.same_screen );
	break;

       case ButtonPress :
       case ButtonRelease :
	printf("%s\n", event.type == ButtonPress ? "ButtonPress" : "ButtonRelease");
        printf(" Type=%d Serial=%ld Event=%d Display=%08X Window=%08X \n",
		 event.xbutton.type, event.xbutton.serial, event.xbutton.send_event,
		 event.xbutton.display, event.xbutton.window );
        printf(" Root=%08X SubWindow=%08X Time=%ld \n",
		 event.xbutton.root, event.xbutton.subwindow, event.xbutton.time );
        printf(" x=%d y=%d x_root=%d y_root=%d state=%d button=%d screen=%d\n\n",
		 event.xbutton.x, event.xbutton.y, 
		 event.xbutton.x_root, event.xbutton.y_root,
		 event.xbutton.state, event.xbutton.button,
		 event.xbutton.same_screen );
	break;

       case KeyPress :
	memset( string, 0x00, sizeof(string) );
        XLookupString((XKeyEvent *)&event,string,sizeof(string),&keysym,NULL);
	if ( (strlen(string)==0) || (string[0]<' ') )
 	 strcpy(string, XKeysymToString(keysym));
	if ( keysym != XK_Escape )
	 {
	  if ( (strlen(keyboardstring)+strlen(string)) >=
		sizeof(keyboardstring) )
           {
	    strcpy( keyboardstring,string );
	    XClearWindow( display, demowindow );
           }
          else
	   strcat( keyboardstring,string );

          XDrawString( display, demowindow, windowgc, 10,height/10/2*3,
	  	       keyboardstring, (int)strlen(keyboardstring) );
	 };
        break;

       case ClientMessage :
	if ( event.xclient.message_type == WMProtocols )
         if ( event.xclient.data.l[0] == WMDeleteWindow )
          keysym = XK_Escape;
 
	if ( XDriverDebug )
	 XDebugClientMessage( display, &event, "Application" );
	 	 
        strcpy( keyboardstring, "" );
        InternAtomNew = XInternAtom( display, "MotionEvent", TRUE );
        InternAtomOld = XInternAtom(display, "SpaceballMotionEventType", TRUE);

        if ( (event.xclient.message_type == InternAtomNew) ||
             (event.xclient.message_type == InternAtomOld) )
         {
          XClearWindow( display, demowindow );
          sprintf( string, "x=%+5d y=%+5d z=%+5d a=%+5d b=%+5d c=%+5d ",
	              event.xclient.data.s[2],
		      event.xclient.data.s[3],
		      event.xclient.data.s[4],
		      event.xclient.data.s[5],
		      event.xclient.data.s[6],
	              event.xclient.data.s[7] );

          XDrawString( display, demowindow, windowgc, 10,height/10/2,
			string, (int)strlen(string) );

          sprintf( string, "%s", event.xclient.message_type == InternAtomNew ?
		    "MotionEvent Version 2.0/3.0":"MotionEvent Version 1.0" );
		    
          XDrawString( display, demowindow, windowgc, 10,height/10/2*2,
			string, (int)strlen(string) );
         }
        else
         {
          InternAtomNew = XInternAtom( display, "ButtonPressEvent", TRUE );
          InternAtomOld = XInternAtom(display,"SpaceballButtonPressEventType",
				       TRUE );
          if ( (event.xclient.message_type == InternAtomNew) ||
                 (event.xclient.message_type == InternAtomOld)  )
           {
	    XClearWindow( display, demowindow );
            sprintf( string, "%20s [%c]", LangString( LANG_BUTTONPRESS ),
                       event.xclient.data.s[2] ==11 ? 'X' :
		       event.xclient.data.s[2] == 9 ? '*' :
		       event.xclient.data.s[2] - 1 + '1' );
            XDrawString( display, demowindow, windowgc, 10,height/10/2,
	  		  string, (int)strlen(string) );

            sprintf( string, "%s", event.xclient.message_type == InternAtomNew ?
		    "ButtonPressEvent Version 2.0/3.0" :
		    "ButtonPressEvent Version 1.0" );
  		    
            XDrawString( display, demowindow, windowgc, 10,height/10/2*2,
				string, (int)strlen(string) );
	   }
	  else
	   {
	    InternAtomNew = XInternAtom( display, "ButtonReleaseEvent", TRUE );
            InternAtomOld = XInternAtom(display,
				     "SpaceballButtonReleaseEventType", TRUE );
            if ( (event.xclient.message_type == InternAtomNew) ||
                 (event.xclient.message_type == InternAtomOld) )
             {
              XClearWindow( display, demowindow );
              sprintf( string, "%20s  %c ", LangString( LANG_BUTTONRELEASE ),
                       event.xclient.data.s[2] ==11 ? 'X' :
		       event.xclient.data.s[2] == 9 ? '*' :
		       event.xclient.data.s[2] - 1 + '1' );
              XDrawString( display, demowindow, windowgc, 10,height/10/2,
	  		  string, (int)strlen(string) );

              sprintf( string, "%s", event.xclient.message_type == InternAtomNew ?
		    "ButtonReleaseEvent Version 2.0/3.0" :
		    "ButtonReleaseEvent Version 1.0" );
  		    
               XDrawString( display, demowindow, windowgc, 10,height/10/2*2,
				string, (int)strlen(string) );
	     };
	   }; 
	 };
        break;	
      };
    };

   XDestroyWindow( display, demowindow );
   XCloseDisplay( display );
   exit( 1 );
  };
}

char StringHexBuffer[ 16 ];
char *StringHex( value, length )
long value;
int length;
{
 sprintf( StringHexBuffer, "%08X", value );
 if ( (int)strlen(StringHexBuffer) > (int)length )
  strcpy( StringHexBuffer, &StringHexBuffer[ strlen(StringHexBuffer) - length ] );
 return StringHexBuffer;
}

void XDebugClientMessage( display, event, message )
Display *display;
XEvent *event;
char *message;
{
int loop;
char *AtomName;

 if ( XDriverDebug )
  {
   printf("ClientMessage: %s \n", message );
   printf(" Type=%d Serial=%d Event=%d Display=%08X Window=%08X\n",
	     event->xclient.type, event->xclient.serial, event->xclient.send_event,
	     event->xclient.display, event->xclient.window );
   AtomName = XGetAtomName( display, event->xclient.message_type );
   printf(" Message=%d=%s Format=%d\n",
	     event->xclient.message_type, AtomName,
	     event->xclient.format );
   XFree( AtomName );

   switch( event->xclient.format )
    {
     case 8:
      for (loop=0; loop<20; ++loop )
       printf("%s ", StringHex(event->xclient.data.b[loop],2) );
      break;
	 
     case 16:
      for (loop=0; loop<10; ++loop )
       printf("%s ", StringHex(event->xclient.data.s[loop],4) );
      break;
	 
     case 32:
      for (loop=0; loop<5; ++loop )
        printf("%s ", StringHex(event->xclient.data.l[loop],8) );
      break;
    };
   printf("\n*********************** %s ***********************\n\n", message );
  }; 
}

int MagellanWindowWidth = 800;		/* 400 */
int MagellanWindowHeight = 100;		/* 200 */

char *XFontNameStatus( display )
Display *display;
{
char **XListFontNames;
int fontcount;

 XListFontNames = XListFonts(display,"*courier-bold-r*--12*",32767,&fontcount);
 if ( fontcount > 0 )
  return XListFontNames[0];

 XListFontNames = XListFonts( display, "*courier*--12*", 32767, &fontcount );
 if ( fontcount > 0 )
  return XListFontNames[0];

 XListFontNames = XListFonts( display, "*--12*", 32767, &fontcount );
 if ( fontcount > 0 )
  return XListFontNames[0];
 
 XListFontNames = XListFonts( display, "*", 32767, &fontcount );
 if ( fontcount > 0 )
  return XListFontNames[0];
 
 return NULL;
}


void XSetColor( display, gc, color )
Display *display;
GC gc;
XColor *color;
{
int index;

 index = XAllocColor( display, DefaultColormap(display,0), color );
 if ( index )
  XSetForeground( display, gc, color->pixel );
}

void XSetBackColor( display, gc, color )
Display *display;
GC gc;
XColor *color;
{
int index;

 index = XAllocColor( display, DefaultColormap(display,0), color );
 if ( index )
  XSetBackground( display, gc, color->pixel );
}

#define MagellanON  0
#define MagellanOFF 1

void XDisplayButton( display,win,gc,state,fc,bc,x,y,width,height,fn,text )
Display *display;
Window win;
GC gc;
int state;
XColor *fc;
XColor *bc;
int x,y;
int width,height;
XFontStruct *fn;
char *text;
{
int Direction, Ascent, Descent;
XCharStruct SizeInfo;

 if ( state == MagellanOFF )
  {
   XSetColor( display, gc, bc );
   XFillRectangle( display, win, gc, x,y, width,height );

   XSetColor( display, gc, &BLACK );
   XDrawRectangle( display, win, gc, x,y, width,height );
   XDrawLine( display, win, gc, x+1,y+height-1,x+width-1,y+height-1 );
   XDrawLine( display, win, gc, x+width-1,y+1, x+width-1,y+height-1 );
   XDrawLine( display, win, gc, x+2,y+height-2,x+width-1,y+height-2 );
   XDrawLine( display, win, gc, x+width-2,y+2, x+width-2,y+height-1 );

   XSetColor( display, gc, &WHITE );
   XDrawLine( display, win, gc, x+1,y+1, x+1,y+height-1 );
   XDrawLine( display, win, gc, x+1,y+1, x+width-2,y+1 );
   XDrawLine( display, win, gc, x+2,y+1, x+2,y+height-2 );
   XDrawLine( display, win, gc, x+1,y+2, x+width-2,y+2 );

   XSetColor( display, gc, fc );
   XTextExtents( fn, text, (int)strlen(text), &Direction, &Ascent, 
		 &Descent, &SizeInfo );
   XDrawString( display, win, gc, x+(width-SizeInfo.width)/2,
		y+SizeInfo.ascent/2+height/2, text, (int)strlen(text) );   
  }
 else
  {
   XSetColor( display, gc, bc );
   XFillRectangle( display, win, gc, x,y, width,height );

   XSetColor( display, gc, &BLACK );
   XDrawRectangle( display, win, gc, x,y, width,height );
   XDrawRectangle( display, win, gc, x+1,y+1, width-2,height-2 );

   XSetColor( display, gc, fc );
   XTextExtents( fn, text, (int)strlen(text), &Direction, &Ascent, 
		 &Descent, &SizeInfo );
   XDrawString( display, win, gc, x+(width-SizeInfo.width)/2+2,
		y+SizeInfo.ascent/2+height/2, text, (int)strlen(text) );   
  };
}


void XDisplayLevel( display,win,gc,state,tc,fc,bc,x,y,width,height,fn,text )
Display *display;
Window win;
GC gc;
double state;
XColor *tc;
XColor *fc;
XColor *bc;
int x,y;
int width,height;
XFontStruct *fn;
char *text;
{
int Direction, Ascent, Descent;
XCharStruct SizeInfo;

 XSetColor( display, gc, bc );
 XFillRectangle( display, win, gc, x,y, width,height );

 XSetColor( display, gc, tc );
 XFillRectangle( display, win, gc, x,y, (int)(width*state),height );

 XSetColor( display, gc, &BLACK );
 XDrawRectangle( display, win, gc, x,y, width,height );
 XDrawRectangle( display, win, gc, x+1,y+1, width-2,height-2 );

 XSetColor( display, gc, fc );
 XTextExtents( fn, text, (int)strlen(text), &Direction, &Ascent, 
		 &Descent, &SizeInfo );
 XDrawString( display, win, gc, x+(width-SizeInfo.width)/2+2,
		y+SizeInfo.ascent/2+height/2, text, (int)strlen(text) );   
}


MagellanStatusData MagellanStatus = { 0, 0, 0, 0, 0 };
MagellanStatusData MagellanCurrentStatus = { -1, -1, -1, -1, -1 };

#define SpaceLength		1
#define KeyboardButtonLength	4
#define ModeButtonLength	20
#define MagellanEmpty		3

#define MagellanWrongSensitivity 12259

int MagellanSensitivityStep( sensitivity )
double sensitivity;
{
double High,Low,Value;
int loop;

 for ( loop=-5; loop<=5; ++loop )
  {
   Value = (1 << (loop+5)) / 32.0;
   High = Value + Value/2.0;
   Low = Value - Value/2.0;
   if ( (sensitivity<=High) &&
	(sensitivity>=Low) )
    return loop;
  };
 return MagellanWrongSensitivity;
}

void MagellanStatusDisplay( display, win, gc, FontInfo, data, update )
Display *display;
Window win;
GC gc;
XFontStruct *FontInfo;
MagellanStatusData *data;
int update;
{
int MagellanSpace, MagellanLength, loop, MagellanHeight, Maske;
char Buffer[ 132 ];

 if ( update )
  {
   XSetColor( display, gc, &LIGHTGRAY );
   XFillRectangle( display, win, gc, 0,0, MagellanWindowWidth,MagellanWindowHeight );
  };

 MagellanSpace = MagellanWindowWidth / 
                 (KeyboardButtonLength*9+ModeButtonLength*3+SpaceLength*(9+3+1));
 MagellanLength = MagellanSpace * ModeButtonLength;
 MagellanHeight = (MagellanWindowHeight - 4*MagellanEmpty) / 3;

 sprintf( Buffer, "%s (K*+K1)",  (data->Mode & 0x02) ?
                   LangString( LANG_TRANSLATIONON ) :
                   LangString( LANG_TRANSLATIONOFF ) );
 if ( ((data->Mode ^ MagellanCurrentStatus.Mode) & 0x02) || update  )
  XDisplayButton( display, win, gc, (data->Mode & 0x02) ? MagellanON : MagellanOFF, &BLUE, &STEELBLUE,
	          MagellanSpace,MagellanEmpty, 
		  MagellanLength,MagellanHeight, FontInfo, Buffer );
						 
 sprintf( Buffer, "%s (K*+K2)",     (data->Mode & 0x01) ?
                   LangString( LANG_ROTATIONON ) :
                   LangString( LANG_ROTATIONOFF ) );
 if ( ((data->Mode ^ MagellanCurrentStatus.Mode) & 0x01) || update )
  XDisplayButton( display, win, gc, (data->Mode & 0x01) ? MagellanON : MagellanOFF, &BLUE, &STEELBLUE,
	         2*MagellanSpace+MagellanLength,MagellanEmpty, 
		 MagellanLength,MagellanHeight,  FontInfo, Buffer );

 sprintf( Buffer, "%s (K*+K3)",  (data->Mode & 0x04) ?
                   LangString( LANG_DOMINANTON ) :
                   LangString( LANG_DOMINANTOFF ) );
 if ( ((data->Mode ^ MagellanCurrentStatus.Mode) & 0x04) || update )
  XDisplayButton( display, win, gc, (data->Mode & 0x04) ? MagellanON : MagellanOFF, &BLUE, &STEELBLUE,
	          3*MagellanSpace+2*MagellanLength,MagellanEmpty, 
		  MagellanLength,MagellanHeight, FontInfo, Buffer );

 MagellanLength = (MagellanWindowWidth - 5*MagellanSpace)/3;
 if ( (data->SensTra != MagellanCurrentStatus.SensTra) || update )
  {
   sprintf( Buffer, "%s = %d (K*+K5)", LangString( LANG_SENSITIVITYTRANS ), data->SensTra );
   XDisplayLevel( display, win, gc, data->SensTra / 15.0, &GREEN, &BLUE, &STEELBLUE,
                  MagellanSpace, 2*MagellanEmpty+MagellanHeight,
 		  MagellanLength,MagellanHeight, FontInfo, Buffer );
  };

 if ( (data->SensRot != MagellanCurrentStatus.SensRot) || update )
  {
   sprintf( Buffer, "%s = %d (K*+K6)", LangString( LANG_SENSITIVITYROT ), data->SensRot );
   XDisplayLevel( display, win, gc, data->SensRot / 15.0, &GREEN, &BLUE, &STEELBLUE,
                  2*MagellanSpace+MagellanLength, 2*MagellanEmpty+MagellanHeight,
	  	  MagellanLength,MagellanHeight, FontInfo, Buffer );
  };

 if ( (data->NullRadius != MagellanCurrentStatus.NullRadius) || update )
  {
   sprintf( Buffer, "%s = %d (K*+K7)", LangString( LANG_NULLRADIUS ), data->NullRadius );
   XDisplayLevel( display, win, gc, data->NullRadius / 15.0, &GREEN, &BLUE, &STEELBLUE,
                  3*MagellanSpace+2*MagellanLength, 2*MagellanEmpty+MagellanHeight,
	          MagellanLength,MagellanHeight, FontInfo, Buffer );
  }; 

 if ( (data->ApplicationSensitivity.Float != MagellanCurrentStatus.ApplicationSensitivity.Float) || update )
  if ( MagellanSensitivityStep( data->ApplicationSensitivity.Float ) == MagellanWrongSensitivity )
   data->ApplicationSensitivity.Float = MagellanCurrentStatus.ApplicationSensitivity.Float;
  else
   {
    data->ApplicationSensitivity.Float = 
     (data->ApplicationSensitivity.Float > 32.0) ? 32.0 :
     (data->ApplicationSensitivity.Float < 1.0/32.0) ? 1.0/32.0 :
      data->ApplicationSensitivity.Float;

    sprintf( Buffer, "%s = %7.4f", LangString( LANG_APPLICATIONSENSITIVITY ), data->ApplicationSensitivity.Float );
    XDisplayLevel( display, win, gc, (MagellanSensitivityStep(data->ApplicationSensitivity.Float)+5.0)/10.0, &GREEN, &BLUE, &STEELBLUE,
                   MagellanSpace, 3*MagellanEmpty+2*MagellanHeight,
	           3*MagellanLength+2*MagellanSpace,MagellanHeight, FontInfo, Buffer );
   }; 

 MagellanLength = MagellanSpace * KeyboardButtonLength;
 for ( loop=0; loop<9; ++loop )
  {
   sprintf( Buffer, "%c", loop==8 ? '*' : '1'+loop );
   Maske = 0x0001 << loop;
   if ( ((data->Keyboard ^ MagellanCurrentStatus.Keyboard) & Maske) || update )
    XDisplayButton( display, win, gc, data->Keyboard & Maske ? MagellanON : MagellanOFF, 
		    &BLUE, &STEELBLUE,
                    MagellanWindowWidth-(9-loop+1)*MagellanSpace-(9-loop)*MagellanLength,
                     MagellanEmpty, 
		    MagellanLength,MagellanHeight,
		    FontInfo, Buffer );
  };
 memcpy( &MagellanCurrentStatus, data, sizeof(MagellanCurrentStatus) );
}




pid_t MagellanChildProcessStatus;
Window MagellanStatusWindow = InputFocus;


void MagellanSetStatus( display, window, Data, MagellanCommandEvent, MagellanWindow )
Display *display;
Window window;
MagellanStatusData *Data;
Atom MagellanCommandEvent;
Window MagellanWindow;
{
XEvent event;

 memset( &event, 0x00, sizeof(event) );
 event.type = ClientMessage;
 event.xclient.serial = NextRequest(display);
 event.xclient.format = 16;
 event.xclient.send_event = FALSE;
 event.xclient.display = display;
 event.xclient.window = window;
 event.xclient.message_type = MagellanCommandEvent;

 event.xclient.data.s[0] = (short) XHigh32( MagellanWindow );
 event.xclient.data.s[1] = (short) XLow32( MagellanWindow );
 event.xclient.data.s[2] = CommandMessageStatusData;

 memcpy( &(event.xclient.data.s[3]), Data, sizeof(MagellanStatusData) );

 XSendEvent( display, window, FALSE, 0x0000, &event );
 XFlush( display ); 
}

void MagellanStatusPanel( display, window, argc, argv, data )
Display *display;
Window window;
int argc;
char *argv[];
MagellanStatusData *data;
{
int screen;
XEvent event;
KeySym keysym;
GC windowgc;
XGCValues xgcvalues;
char *windowtext, windowversion[128], string[128];
XTextProperty windowname;
char *FontName;
Font fontname;
XFontStruct *FontInfo;
Atom MagellanCommandEvent, WMDeleteWindow, WMProtocols;
MagellanStatusData CurrentStatus;

 if ( MagellanStatusDisplayFlag == NO )
  return;

 MagellanChildProcessStatus = fork();
 if ( MagellanChildProcessStatus == 0 )
  {
   XSetErrorHandler( MagellanErrorHandler );  

   display = XOpenDisplay( NULL );
   screen = DefaultScreen( display );
   MagellanWindowWidth = DisplayWidth( display, screen );
   MagellanWindowHeight = DisplayHeight( display, screen )*0.05;
   MagellanWindowHeight = DisplayHeight( display, screen )*0.075;
   if ( MagellanWindowHeight < 48 )
    MagellanWindowHeight = 48;

   MagellanStatusWindow = XCreateSimpleWindow( display, RootWindow(display,screen), 0,0,
 		                     MagellanWindowWidth,MagellanWindowHeight, 20,
		                     BlackPixel(display,screen),
				     WhitePixel(display,screen) );

   sprintf( windowversion,"********** %s %s %s **********", 
				       LangString( LANG_DEVICENAME ),
				       LangString( LANG_VERSION2 ),
				       LangString( LANG_VERSION3 ) );
   windowtext = windowversion; 

   XStringListToTextProperty( &windowtext, 1, &windowname );

   XSetWMProperties( display, MagellanStatusWindow, &windowname, NULL, argv,
		 argc, NULL, NULL, NULL );

   WMProtocols = XInternAtom( display, "WM_PROTOCOLS", FALSE );
   WMDeleteWindow = XInternAtom( display, "WM_DELETE_WINDOW", FALSE );
   XSetWMProtocols( display, MagellanStatusWindow, &WMDeleteWindow, 1);

   XSelectInput( display, MagellanStatusWindow, KeyPressMask | KeyReleaseMask | ExposureMask );

   xgcvalues.foreground = BlackPixel( display, 0 );
   xgcvalues.background = WhitePixel( display, 0 );
   windowgc = XCreateGC( display, MagellanStatusWindow, 
			 GCForeground | GCBackground, &xgcvalues );

   FontName = XFontNameStatus( display );
   if ( FontName != NULL )
    {
     fontname = XLoadFont( display, FontName );
     XSetFont( display, windowgc, fontname );
     FontInfo = XQueryFont( display, fontname );
    }
   else
    {
     printf("%s\n", LangString( LANG_NOFONT ) );
     exit( -1 );
    };

   XMapWindow( display, MagellanStatusWindow );
 
   MagellanCommandEvent = XInternAtom( display, "CommandEvent", TRUE );
   memset( &event, 0x00, sizeof(event) );
   event.type = ClientMessage;
   event.xclient.serial = NextRequest(display);
   event.xclient.format = 16;
   event.xclient.send_event = FALSE;
   event.xclient.display = display;
   event.xclient.window = window;
   event.xclient.message_type = MagellanCommandEvent;
   event.xclient.data.s[0] = (short) XHigh32( MagellanStatusWindow );
   event.xclient.data.s[1] = (short) XLow32( MagellanStatusWindow );
   event.xclient.data.s[2] = CommandMessageStatusWindow;

   XSendEvent( display, window, FALSE, 0x0000, &event );
   XFlush( display );
   
   keysym = ~XK_Escape;
   
   memcpy( &MagellanCurrentStatus, data, sizeof( MagellanStatusData ) );
  
   while ( keysym != XK_Escape )
    {
     XNextEvent( display, &event );
     switch( event.type )
      {
       case Expose :
	while ( XCheckMaskEvent( display, ExposureMask, &event ) )
	 ;
	MagellanStatusDisplay( display, MagellanStatusWindow, windowgc, FontInfo, &MagellanCurrentStatus, TRUE );
        break;
	
       case KeyPress :
	memset( string, 0x00, sizeof(string) );
        XLookupString((XKeyEvent *)&event,string,sizeof(string),&keysym,NULL);
        break;

       case ClientMessage :
	if ( event.xclient.message_type == MagellanCommandEvent )
 	 if ( event.xclient.data.s[2] == CommandMessageStatusData )
	  {
	   memcpy( &CurrentStatus, &(event.xclient.data.s[3]), sizeof(MagellanStatusData) );
	   MagellanStatusDisplay( display, MagellanStatusWindow, windowgc, FontInfo, 
                                   &CurrentStatus, FALSE );
	  };
	
	if ( event.xclient.message_type == WMProtocols )
         if ( event.xclient.data.l[0] == WMDeleteWindow )
          keysym = XK_Escape;
 
        break;
      };
    };

   memset( &event, 0x00, sizeof(event) );
   event.type = ClientMessage;
   event.xclient.serial = NextRequest(display);
   event.xclient.format = 16;
   event.xclient.send_event = FALSE;
   event.xclient.display = display;
   event.xclient.window = window;
   event.xclient.message_type = MagellanCommandEvent;
   event.xclient.data.s[0] = (short) XHigh32( InputFocus );
   event.xclient.data.s[1] = (short) XLow32( InputFocus );
   event.xclient.data.s[2] = CommandMessageStatusWindow;

   XSendEvent( display, window, FALSE, 0x0000, &event );
   XFlush( display );

   XDestroyWindow( display, MagellanStatusWindow );   
   XCloseDisplay( display );
   exit( 1 );
  };
}


/*|-----------------------------|*/
/*| Magellan Device Definitions |*/
/*|-----------------------------|*/

int MagellanHandle = -1; 	/*| File handle |*/
char MagellanLineBuffer[1024]; 	/*| Receive Buffer |*/
int  MagellanLineBufferLength = 0;

char *MagellanModeOff="m0\r";	/*| Translation and Rotation Mode OFF |*/

char *MagellanMode="m3\r";	/*| Translation and Rotation Mode |*/
char *MagellanDataRate="pAA\r";	/*| Date Rate |*/
char *MagellanSensitivity="q00\r"; 	/*| Linear |*/
char *MagellanNullRadius="nM\r";/*| Null Radius |*/
char *MagellanBeeper	="b9\r";/*| Short Beep |*/
char *MagellanZero="z\r";	/*| Zeroing |*/
char *MagellanDataQuestion="dQ\r";/*| Data Request |*/
char *MagellanModeCompress="c3A\r"; /*| Translation and Rotation Mode and Compress Data |*/

char MagellanVersionString[64];
char *MagellanVersionText="vQ\r";/*| Version string |*/

Atom MagellanMotionEvent;		/*| Driver Client Message types |*/
Atom MagellanButtonPressEvent;
Atom MagellanButtonReleaseEvent;
Atom MagellanCommandEvent;

Atom MagellanMotionEventVersion1;       /*| Driver Client Messages types Version 1.0 |*/
Atom MagellanButtonPressEventVersion1;
Atom MagellanButtonReleaseEventVersion1;


unsigned int Keyboard = 0x0000;

XTextProperty MagellanWindowName = { (unsigned char *) "Magellan Window", XA_WM_NAME, 8,
				     (unsigned long) sizeof("Magellan Window") };

 
Window XFocusWindow, XUseWindow;
Window XFocusWindowDisplay = (Window)(~InputFocus);

char WindowString[ 32 ];

char * XWindowString( window )
Window window;
{
 if ( window == InputFocus )
  return "InputFocus";
 sprintf( WindowString, "0x%X", window );
 return WindowString;
}


int MagellanErrorHandler( display, Error )
Display *display;
XErrorEvent *Error;
{
char Buffer[ 128 ];

 switch( Error->error_code )
  {
   case BadWindow : XUseWindow = XFocusWindow = InputFocus;
                    if ( XFocusWindow != XFocusWindowDisplay )
                     printf("%s = %s\n", LangString( LANG_SENDWINDOW ), 
	                               XWindowString( XFocusWindow ) );
                    XFocusWindowDisplay = XFocusWindow;
                    break;

   default : XGetErrorText(display,Error->error_code,Buffer,sizeof(Buffer));
             fprintf( stderr, "Magellan: Error = %s. Exit ... \n", Buffer );
             break;
  };
 return 0;
}


/*| ---------------------------- |*/
/*| Magellan Driver Process Kill |*/
/*| ---------------------------- |*/

#define MagellanProcessCommand		"ps -e"
#define MagellanProcessCommandExtended	"ps -edf"

void MagellanProcessID( Program )
char *Program;
{
char MagellanBuffer[132], ProgramName[132];
int CurrentID, SecondID, found;
FILE *psPtr;

 strcpy( ProgramName, Program );
 ProgramName[8] = '\000';

 found = FALSE;
 CurrentID = getpid();

 psPtr = popen( MagellanProcessCommand, "rt" );
 if ( psPtr != NULL )
  {
   while ( fgets( MagellanBuffer, sizeof(MagellanBuffer), psPtr ) != NULL )
    {
     if ( MagellanBuffer[ strlen(MagellanBuffer) - 1 ] == '\n' )
      MagellanBuffer[ strlen(MagellanBuffer) - 1 ] = '\000';

     if ( strstr( MagellanBuffer, ProgramName ) != NULL )
      {
       SecondID = atoi( MagellanBuffer );
       if ( CurrentID != SecondID )
	{
	 if ( strchr( MagellanBuffer, '?' ) != NULL )
	  {
	   kill( SecondID, SIGKILL );
           printf( LangString(LANG_KILLPROCESS), SecondID );
           printf("\n");
	  }
	 else
	  { 
           printf( LangString(LANG_KILLPROCESS), SecondID );
           printf("\n");
	   found = TRUE;
	  }; 
	};
      };
    };
   pclose( psPtr );
  };
 if ( found )
  {
   printf("%s\n", LangString(LANG_ANOTHERPROCESS) );
   exit( -1 );
  };
}


int MagellanProcessTTY( SerialDevice )
char *SerialDevice;
{
char MagellanBuffer[132];
int found;
FILE *psPtr;

 found = FALSE;

 psPtr = popen( MagellanProcessCommandExtended, "rt" );
 if ( psPtr != NULL )
  {
   while ( fgets( MagellanBuffer, sizeof(MagellanBuffer), psPtr ) != NULL )
    {
     if ( MagellanBuffer[ strlen(MagellanBuffer) - 1 ] == '\n' )
      MagellanBuffer[ strlen(MagellanBuffer) - 1 ] = '\000';

     if ( strstr( MagellanBuffer, &SerialDevice[5] ) != NULL )
      {
       found = TRUE;
       strcpy( MagellanBuffer, &MagellanBuffer[32] );
       printf("%s\n[%s] [%s]\n\n", LangString( LANG_WARNINGSERIALDEVICE ),
                                 SerialDevice, MagellanBuffer );
      };

    };
   pclose( psPtr );
  };
 return found;
}

int MagellanDevInput( SerialDevice, DevInputCommand )
char *SerialDevice;
char *DevInputCommand;
{
char MagellanBuffer[132], SerialDeviceLink[132];
int found;
FILE *psPtr;
char *directory;

 found = FALSE;

 directory = strchr( DevInputCommand, '/' );
 if ( directory == NULL )
  return FALSE;
 directory = strchr( ++directory, '/' );
 if ( directory == NULL )
  return FALSE;
 ++directory;
 
 psPtr = popen( "ls -al /dev", "rt" );
 if ( psPtr != NULL )
  {
   memset( MagellanBuffer, 0x00, sizeof(MagellanBuffer) );
   while ( fgets( MagellanBuffer, sizeof(MagellanBuffer), psPtr ) != NULL )
    {
     if ( MagellanBuffer[ strlen(MagellanBuffer) - 1 ] == '\n' )
      MagellanBuffer[ strlen(MagellanBuffer) - 1 ] = '\000';

     if ( strstr( MagellanBuffer, directory ) != NULL )
      found = TRUE;
    };
  };
 pclose( psPtr );
 if ( found == FALSE )
  return FALSE;

 
 found = FALSE;

 psPtr = popen( DevInputCommand, "rt" );
 if ( psPtr != NULL )
  {
   memset( MagellanBuffer, 0x00, sizeof(MagellanBuffer) );
   while ( fgets( MagellanBuffer, sizeof(MagellanBuffer), psPtr ) != NULL )
    {
     if ( MagellanBuffer[ strlen(MagellanBuffer) - 1 ] == '\n' )
      MagellanBuffer[ strlen(MagellanBuffer) - 1 ] = '\000';

     memset( SerialDeviceLink, 0x00, sizeof(SerialDeviceLink) );

     if ( MagellanBuffer[35] == ' ' )
      if ( MagellanBuffer[36] == '0' )
       if ( MagellanBuffer[37] == ',' )
        {
         sprintf( SerialDeviceLink, "/dev/ttyd%d", atoi(&MagellanBuffer[38]) );
         found = strcmp( SerialDeviceLink, SerialDevice ) == 0;
        };
     
     found |= strstr( MagellanBuffer, SerialDevice ) != NULL;

     if ( found )
      {
       printf("%s\n[%s]*[%s]\n\n", LangString( LANG_WARNINGSERIALDEVICE ),
                                 SerialDevice, MagellanBuffer );
       return TRUE;
      };

     memset( MagellanBuffer, 0x00, sizeof(MagellanBuffer) );
    };
   pclose( psPtr );
  };
 return found;
}


/*| ------------------------------------ |*/
/*| Magellan Serial Device Communication |*/
/*| ------------------------------------ |*/

struct _MagellanData { 
 int x; 
 int y; 
 int z; 
 int a;
 int b; 
 int c;
}; 
typedef struct _MagellanData MagellanData; 
 
 
char MagellanNibbleTable[] = "0AB3D56GH9:K<MN?"; 
short MagellanNibbleTable6[] = {
 128, 65, 66, 131, 68, 133, 134, 71, 72, 137, 138, 75, 140, 77, 78, 143,
 80, 145, 146, 83, 148, 85, 86, 151, 152, 89, 90, 155, 220, 157, 158, 95,
 224, 161, 162, 99, 164, 101, 102, 167, 168, 105, 106, 171, 108, 173, 174, 111, 
 176, 113, 114, 179, 116, 181, 182, 119, 120, 185, 186, 123, 188, 125, 62, 191 }; 
int  MagellanNibbleError = FALSE; 

int MagellanNibble( nibbledata )
int nibbledata;
{ 
int value; 

 value = nibbledata & 0x000F; 
 if ( MagellanNibbleTable[ value ] == nibbledata ) 
  return value; 

 MagellanNibbleError = TRUE; 
 printf("4%s [%02X] [%02X] = %d \n", LangString( LANG_NIBBLEERROR ),
	     nibbledata, MagellanNibbleTable[ value ], value );
 return value; 
}

int MagellanNibble6( nibbledata )
int nibbledata;
{ 
int value; 
 
 value = nibbledata & 0x003F; 
 if ( MagellanNibbleTable6[ value ] == (nibbledata & 0x00FF) ) 
  return value; 

 MagellanNibbleError = TRUE; 
 printf("6%s [%02X] [%02X] = %d \n", LangString( LANG_NIBBLEERROR ),
	     nibbledata & 0x00FF, MagellanNibbleTable[ value ], value );
 return value; 
}
 
int MagellanRead( MagellanHandle, MagellanBuffer, MagellanLength )
int MagellanHandle;
char *MagellanBuffer;
int MagellanLength;
{ 
char MagellanLocalBuffer[512];
char *MagellanReturn;
int length;

 do 
  { 
   MagellanReturn = strchr( MagellanLineBuffer, '\r' );
   if ( MagellanReturn == NULL )
    {
     length = read( MagellanHandle, MagellanLocalBuffer, sizeof( MagellanLocalBuffer )-1 );  
     switch( length )
      {
       case -1 : if ( XDriverDebug ) printf("read return -1 ... \n"); break;
       case  0 : if ( XDriverDebug ) printf("read return  0 ... \n"); break;
       default : 
        MagellanLocalBuffer[ length ] = '\000';
        if ( length + MagellanLineBufferLength > sizeof( MagellanLineBuffer ) )
         {
          printf( "%s\n", LangString( LANG_RECEIVEOVERFLOW ) ); 
          strcpy( MagellanLineBuffer, MagellanLocalBuffer );
          MagellanLineBufferLength = length;
         }
        else
         {
          strcat( MagellanLineBuffer, MagellanLocalBuffer );
          MagellanLineBufferLength += length;
         };
        break;
      };
    
/*|---- alarm( 4 ); signal( SIGALRM, MagellanTimerSignal ); ----|*/

     if ( XDriverDebug )
      {
       MagellanDebugBuffer( "Receive", MagellanLineBuffer );
      };
    
     continue; 
    } 
   else 
    { 
     do 
      {
       *MagellanReturn = '\000';
       length = strlen( MagellanLineBuffer );
       MagellanLineBufferLength += -length - 1;

       if ( length > MagellanLength )
        { 
         memcpy( MagellanBuffer, MagellanLineBuffer, MagellanLength );
         MagellanBuffer[ MagellanLength - 1 ] = '\000';
         length = MagellanLength - 1;

         printf( "%s\n", LangString( LANG_RECEIVEOVERFLOW ) ); 
         MagellanDebugBuffer( "Overflow", MagellanLineBuffer );
         return length;
        } 
       else 
        { 
         strcpy( MagellanBuffer, MagellanLineBuffer );
         strcpy( MagellanLineBuffer, ++MagellanReturn );
       
         if ( MagellanBuffer[0] == 'd' )		/*| 3D data package received |*/
          if ( MagellanLineBuffer[0] == 'd' )	/*| 3D data package next in buffer |*/
           if ( MagellanLineBufferLength >= 16 )  
            {
             MagellanReturn = strchr( MagellanLineBuffer, '\r' );
             if ( MagellanReturn != NULL )
              {
               continue;
              };
            }; 
         return length;
        };
      } while ( _TRUE_ );
    };
  } while ( _TRUE_ ); 
 return 0;
}
 
 
char *MagellanVersion( MagellanHandle )
int MagellanHandle;
{ 
 MagellanTransmit( MagellanHandle, MagellanVersionText );
 do 
  { 
   memset( MagellanVersionString, 0x00, sizeof( MagellanVersionString ) );
   MagellanRead( MagellanHandle, MagellanVersionString, 
			 sizeof( MagellanVersionString ) );
  } while ( MagellanVersionString[0] != 'v' );
 return MagellanVersionString;
} 

int MagellanTransmit( MagellanHandle, String )
int MagellanHandle;
char *String;
{
 write( MagellanHandle, String, (int) strlen( String ) );
 if ( XDriverDebug )
  MagellanDebugBuffer("Transmit", String );
 return TRUE;
}

int MagellanTransmitReceive( MagellanHandle, StringIn, StringCompare )
int MagellanHandle;
char * StringIn;
char * StringCompare;
{ 
char MagellanBuffer[128];

 MagellanTransmit( MagellanHandle, StringIn );
 if ( StringIn[0] == '\r' ) 
  return TRUE; 
 do 
  {
   memset( MagellanBuffer, 0x00, sizeof( MagellanBuffer ) );
   MagellanRead( MagellanHandle, MagellanBuffer, sizeof( MagellanBuffer ) );
   strcat( MagellanBuffer, "\r" );
  } while ( StringIn[0] != MagellanBuffer[0] );

 switch( MagellanBuffer[0] )
  {
   case 'k' : MagellanStatus.Keyboard =
                  MagellanNibble( MagellanBuffer[1] ) * 1 +
                  MagellanNibble( MagellanBuffer[2] ) * 16 +
                  MagellanNibble( MagellanBuffer[3] ) * 256;
               break;

   case 'm' : MagellanStatus.Mode = MagellanNibble( MagellanBuffer[1] );
               break;

   case 'q' : MagellanStatus.SensTra = MagellanNibble( MagellanBuffer[1] );
	       MagellanStatus.SensRot = MagellanNibble( MagellanBuffer[2] );
      	       break;

   case 'n' : MagellanStatus.NullRadius = MagellanNibble( MagellanBuffer[1] );
	       break;
  };
 return strcmp( MagellanBuffer, StringCompare ) == 0;
} 

int MagellanInitialize( MagellanHandle )
int MagellanHandle;
{
 MagellanWait( 1000 );

 MagellanTransmit( MagellanHandle, MagellanExistString );

 MagellanWait( 200 );

 while(!MagellanTransmitReceive( MagellanHandle, 
	       MagellanDataRate, MagellanDataRate ) )
  ;
 
 while(!MagellanTransmitReceive( MagellanHandle,
		MagellanSensitivity, MagellanSensitivity ) )
  ; 
 
 while(!MagellanTransmitReceive( MagellanHandle,
	     MagellanNullRadius, MagellanNullRadius ) )
  ; 
 
 while(!MagellanTransmitReceive( MagellanHandle,
		   MagellanZero, MagellanZero ) )
  ; 
 
 while(!MagellanTransmitReceive( MagellanHandle,
  		           MagellanBeeper, "b\r" ) )
  ; 
 
 while(!MagellanTransmitReceive( MagellanHandle,
		   MagellanMode, MagellanMode ) )
  ; 

#ifdef IBM
 MagellanTransmit( MagellanHandle, MagellanModeCompress );
 MagellanWait( 200 );
#endif /*| IBM |*/
 
 MagellanVersion( MagellanHandle );
 
 printf( "%s\n\n", &MagellanVersionString[1] );

 return TRUE;
}

int MagellanKeyboardEvent( display, MagellanBuffer, MagellanWindow )
Display *display;
char *MagellanBuffer;
Window MagellanWindow;
{
int KeyboardLocal, KeyboardMask, loop;
XEvent XMagellanEvent;
int ReturnWindow, ButtonState;

 if ( strlen( MagellanBuffer ) != 4 )
  return FALSE;

 KeyboardLocal = MagellanNibble( MagellanBuffer[1] ) +
 	         MagellanNibble( MagellanBuffer[2] )*16 +
	         MagellanNibble( MagellanBuffer[3] )*256;

 for ( loop=1; loop<=9; ++loop )
  {
   KeyboardMask = 0x0001 << (loop-1);
   if ( (KeyboardLocal & KeyboardMask) != (Keyboard & KeyboardMask) )
    break;
  };
     
 if ( loop <= 9 )
  {
   if ( DialboxMode )
    {
     if ( Keyboard & KeyboardMask )
      switch( loop )
       {
        case 8 : 
         if ( DialboxModeActive ) 
          DialboxModeActive = FALSE;
         else
          DialboxModeActive = TRUE;
         break;

	case 9:
	case 4:
         break;
 
        default : 
         if ( DialboxModeActive ) 
          DialboxModeDial = loop;
         break;
       };
    };

   ReturnWindow = 0;
   if ( XUseWindow == InputFocus )
    XGetInputFocus( display, &XFocusWindow, &ReturnWindow );
 
   if ( FileKeyboardButton[ loop-1 ] != NULL )
    {
     ButtonState=ButtonParser( (Display *)NULL, (Window) NULL, 
			       FileKeyboardButton[loop-1], FALSE );
     if ( ButtonState == 0 )
      return FALSE;
    }
   else
    ButtonState = ENABLE;

   Keyboard = KeyboardLocal;

   if ( ButtonState & ENABLE )
    {
     if ( !DialboxModeActive || (DialboxModeActive && ((loop==4)||(loop==9))) )
      {
       if ( Keyboard & KeyboardMask ) 
        XMagellanEvent.xclient.message_type = MagellanButtonPressEvent;
       else
        XMagellanEvent.xclient.message_type = MagellanButtonReleaseEvent;

       XMagellanEvent.type = ClientMessage;
       XMagellanEvent.xclient.serial = NextRequest(display);
       XMagellanEvent.xclient.format = 16;
       XMagellanEvent.xclient.send_event = TRUE;
       XMagellanEvent.xclient.display = display;
       XMagellanEvent.xclient.window = XFocusWindow;

       XMagellanEvent.xclient.data.s[0] = (short) XHigh32( MagellanWindow );
       XMagellanEvent.xclient.data.s[1] = (short) XLow32( MagellanWindow );

       if ( Application == UNIGRAPHICS_11 )
        XMagellanEvent.xclient.data.s[2] = loop == 8 ? 11 : loop;
       else
        XMagellanEvent.xclient.data.s[2] = loop;

       XSendEvent(display, XFocusWindow, FALSE, 0x0000, &XMagellanEvent);

       if ( Application == DUALVERSION )
        {
         if ( Keyboard & KeyboardMask )
          XMagellanEvent.xclient.message_type=MagellanButtonPressEventVersion1;
         else
          XMagellanEvent.xclient.message_type=MagellanButtonReleaseEventVersion1;
         XMagellanEvent.xclient.serial = NextRequest(display);
         XSendEvent(display, XFocusWindow, FALSE, 0x0000, &XMagellanEvent );
        };
       XFlush( display );
      };
    };

   if ( !DialboxModeActive || (DialboxModeActive && ((loop==4)||(loop==9))) )  
    if ( FileKeyboardButton[loop-1] != NULL )
     if ( Keyboard & KeyboardMask )
      if ( ButtonState )
       ButtonParser(display,XFocusWindow,FileKeyboardButton[loop-1],TRUE);

  };
 return TRUE;
} 

int IsWindowProEngineer( Name )
unsigned char *Name;
{
 if ( strstr( (char *)Name, "Pro/ENGINEER" ) != NULL ) return TRUE;
 if ( strstr( (char *)Name, "**********" ) != NULL ) return TRUE;
 return FALSE;
}

void MoveFinishProEngineer( display, window )
Display *display;
Window window;
{
XButtonEvent ButtonEvent;
XMotionEvent MotionEvent;

 MotionEvent.type = MotionNotify;
 MotionEvent.serial = NextRequest(display);
 MotionEvent.display = display;
 MotionEvent.window = window;
 XQueryPointer( display, window, &MotionEvent.root, &MotionEvent.subwindow, 
		&MotionEvent.x_root, &MotionEvent.y_root, 
		&MotionEvent.x,      &MotionEvent.y, 
		&MotionEvent.state );
 MotionEvent.time = time(NULL);
 MotionEvent.x = 0;
 MotionEvent.y = 0;
 MotionEvent.is_hint = NotifyNormal;
 MotionEvent.same_screen = TRUE;
 XSendEvent( display, window, FALSE, 0x0000, (XEvent *)&MotionEvent );
 XFlush( display );

 ButtonEvent.serial = NextRequest(display);
 ButtonEvent.display = display;
 ButtonEvent.window = window;
 ButtonEvent.time = time(NULL);
 XQueryPointer( display, window, &ButtonEvent.root, &ButtonEvent.subwindow, 
		&ButtonEvent.x_root, &ButtonEvent.y_root, 
		&ButtonEvent.x,      &ButtonEvent.y, 
		&ButtonEvent.state );

 ButtonEvent.button = Button2;
 ButtonEvent.same_screen = TRUE;

 ButtonEvent.type = ButtonPress;
 ButtonEvent.state &= ~Button2Mask;
 XSendEvent( display, window, FALSE, 0x0000, (XEvent *)&ButtonEvent );
 XFlush( display );

 ButtonEvent.type = ButtonRelease;
 ButtonEvent.serial = NextRequest(display);
 ButtonEvent.state |= Button2Mask;
 ButtonEvent.time += 1;
 XSendEvent( display, window, FALSE, 0x0000, (XEvent *)&ButtonEvent );
 XFlush( display );
}

int MagellanCompressDataNonLinear( x, y, z, quality )
int *x;
int *y;
int *z;
int quality;
{
int absolute;
int factor;

 absolute = abs(*x) + abs(*y) + abs(*z);
 absolute = absolute / 2;
 if ( absolute >= 256 )
  absolute = 255;

 factor = absolute * quality*16;
 factor = factor / 256;
 if ( factor > 255-8 )
  factor = 255-8;
 factor = factor + 8;

 *x = (*x * factor)/8;
 *y = (*y * factor)/8;
 *z = (*z * factor)/8;

/*| printf("%d|%d|%d  absolute=%d  factor=%d  quality=%d\n", *x,*y,*z, absolute,factor,quality ); |*/
 return factor;
}

enum _MagellanKoordiantes_ { X,Y,Z, A,B,C };
long Magellan3DData[ C - X + 1 ] = { 0,0,0, 0,0,0 };

double MagellanExternalScalingTranslation = 1.0;
double MagellanExternalScalingRotation = 1.0;
double MagellanExternalScalingTranslationX = 1.0;
double MagellanExternalScalingTranslationY = 1.0;
double MagellanExternalScalingTranslationZ = 1.0;
double MagellanExternalScalingRotationA = 1.0;
double MagellanExternalScalingRotationB = 1.0;
double MagellanExternalScalingRotationC = 1.0;
int MagellanExternalScalingPrint = FALSE;

int MagellanMemDataAllZero = TRUE;
int MagellanMemDataSendEvents = FALSE;
Window UsedWindowProEngineer = InputFocus;

int MagellanDataEvent( display, MagellanBuffer, MagellanWindow )
Display *display;
char *MagellanBuffer;
Window MagellanWindow;
{
int ReturnWindow, Switch, FindWindowProEngineer, DialboxValue;
XEvent XMagellanEvent;
MagellanData MagellanMemData;
XTextProperty WindowProperty;
int Length, MagellanChecksum1, MagellanChecksum2;

 Length = strlen( MagellanBuffer );
 switch( Length )
  {
   case 15:
    MagellanNibbleError = FALSE;

    MagellanMemData.x = MagellanNibble6( MagellanBuffer[1] ) * 64 +
                        MagellanNibble6( MagellanBuffer[2] ) - 2048;

    MagellanMemData.y = MagellanNibble6( MagellanBuffer[3] ) * 64 +
                        MagellanNibble6( MagellanBuffer[4] ) - 2048;
 
    MagellanMemData.z = MagellanNibble6( MagellanBuffer[5] ) * 64 +
                        MagellanNibble6( MagellanBuffer[6] ) - 2048;
 
    MagellanMemData.a = MagellanNibble6( MagellanBuffer[7] ) * 64 +
                        MagellanNibble6( MagellanBuffer[8] ) - 2048;
 
    MagellanMemData.b = MagellanNibble6( MagellanBuffer[9] ) * 64 +
                        MagellanNibble6( MagellanBuffer[10] ) - 2048;
 
    MagellanMemData.c = MagellanNibble6( MagellanBuffer[11] ) * 64 +
                        MagellanNibble6( MagellanBuffer[12] ) - 2048;

    MagellanChecksum1 = MagellanNibble6( MagellanBuffer[13] ) * 64 +
                        MagellanNibble6( MagellanBuffer[14] );
    MagellanChecksum2 = (MagellanBuffer[ 1] & 0x00FF) + 
			(MagellanBuffer[ 2] & 0x00FF) +
                        (MagellanBuffer[ 3] & 0x00FF) + 
			(MagellanBuffer[ 4] & 0x00FF) +
                        (MagellanBuffer[ 5] & 0x00FF) + 
			(MagellanBuffer[ 6] & 0x00FF) +
                        (MagellanBuffer[ 7] & 0x00FF) + 
			(MagellanBuffer[ 8] & 0x00FF) +
                        (MagellanBuffer[ 9] & 0x00FF) + 
			(MagellanBuffer[10] & 0x00FF) +
                        (MagellanBuffer[11] & 0x00FF) + 
			(MagellanBuffer[12] & 0x00FF);

    if ( MagellanChecksum1 != MagellanChecksum2 )
     {
      printf("Magellan: Warning checksum error ... %d==%d \n",
	      MagellanChecksum1, MagellanChecksum2 );
      return FALSE;
     };

    MagellanCompressDataNonLinear( &MagellanMemData.x, &MagellanMemData.y, &MagellanMemData.z,
                                   MagellanStatus.SensTra );
    MagellanCompressDataNonLinear( &MagellanMemData.a, &MagellanMemData.b, &MagellanMemData.c,
                                   MagellanStatus.SensRot );
    break;

   case 25:
    MagellanNibbleError = FALSE;

    MagellanMemData.x = MagellanNibble( MagellanBuffer[1] ) * 4096 +
   		        MagellanNibble( MagellanBuffer[2] ) * 256 +
 		        MagellanNibble( MagellanBuffer[3] ) * 16 +
 		        MagellanNibble( MagellanBuffer[4] ) - 32768;

    MagellanMemData.y = MagellanNibble( MagellanBuffer[5] ) * 4096 +
 		        MagellanNibble( MagellanBuffer[6] ) * 256 +
 		        MagellanNibble( MagellanBuffer[7] ) * 16 +
 		        MagellanNibble( MagellanBuffer[8] ) - 32768;
  
    MagellanMemData.z = MagellanNibble( MagellanBuffer[9] ) * 4096 +
 		        MagellanNibble( MagellanBuffer[10] ) * 256 +
 		        MagellanNibble( MagellanBuffer[11] ) * 16 +
   	                MagellanNibble( MagellanBuffer[12] ) - 32768;
  
    MagellanMemData.a = MagellanNibble( MagellanBuffer[13] ) * 4096 +
 		        MagellanNibble( MagellanBuffer[14] ) * 256 +
 		        MagellanNibble( MagellanBuffer[15] ) * 16 +
 		        MagellanNibble( MagellanBuffer[16] ) - 32768;
  
    MagellanMemData.b = MagellanNibble( MagellanBuffer[17] ) * 4096 +
 		        MagellanNibble( MagellanBuffer[18] ) * 256 +
 		        MagellanNibble( MagellanBuffer[19] ) * 16 +
		        MagellanNibble( MagellanBuffer[20] ) - 32768;
 
    MagellanMemData.c = MagellanNibble( MagellanBuffer[21] ) * 4096 +
 		        MagellanNibble( MagellanBuffer[22] ) * 256 +
 		        MagellanNibble( MagellanBuffer[23] ) * 16 +
 		        MagellanNibble( MagellanBuffer[24] ) - 32768;
    break;

   default: return FALSE; 
  };

 MagellanMemData.c = -MagellanMemData.c;
 MagellanMemData.z = -MagellanMemData.z;

 if ( CoordinateSystemChange == YES )
  {
   Switch = MagellanMemData.z;
   MagellanMemData.z = MagellanMemData.y;
   MagellanMemData.y = Switch;
  };

 if ( MagellanNibbleError )
  memset( &MagellanMemData, 0x00, sizeof( MagellanMemData ) );

 if ( DialboxMode && DialboxModeActive )
  {
   DialboxValue = MagellanMemData.b;
   MagellanMemData.x =
   MagellanMemData.y =
   MagellanMemData.z =
   MagellanMemData.a =
   MagellanMemData.b =
   MagellanMemData.c = 0;
   switch( DialboxModeDial )
    {
     case 1 : MagellanMemData.x =-DialboxValue; break;
     case 2 : MagellanMemData.y = DialboxValue; break;
     case 3 : MagellanMemData.z =-DialboxValue; break;
     case 5 : MagellanMemData.a = DialboxValue; break;
     case 6 : MagellanMemData.b = DialboxValue; break;
     case 7 : MagellanMemData.c = DialboxValue; break;
    };
  };
  
 if ( NonLinearFlag == YES )
  {
   NonLinearTranslation(&MagellanMemData.x,&MagellanMemData.y,&MagellanMemData.z);
   NonLinearRotation(&MagellanMemData.a,&MagellanMemData.b,&MagellanMemData.c);
  };

 MagellanMemData.x=(int)(MagellanMemData.x*MagellanExternalScalingTranslationX);
 MagellanMemData.y=(int)(MagellanMemData.y*MagellanExternalScalingTranslationY);
 MagellanMemData.z=(int)(MagellanMemData.z*MagellanExternalScalingTranslationZ);

 MagellanMemData.a=(int)(MagellanMemData.a*MagellanExternalScalingRotationA);
 MagellanMemData.b=(int)(MagellanMemData.b*MagellanExternalScalingRotationB);
 MagellanMemData.c=(int)(MagellanMemData.c*MagellanExternalScalingRotationC);

 ReturnWindow = 0;
 if ( XUseWindow == InputFocus )
  XGetInputFocus( display, &XFocusWindow, &ReturnWindow );
 
 XMagellanEvent.type = ClientMessage;
 XMagellanEvent.xclient.serial = NextRequest( display );
 XMagellanEvent.xclient.format = 16;
 XMagellanEvent.xclient.send_event = FALSE;
 XMagellanEvent.xclient.display = display;
 XMagellanEvent.xclient.window = XFocusWindow;
 XMagellanEvent.xclient.message_type = MagellanMotionEvent;

 XMagellanEvent.xclient.data.s[0] = (short) XHigh32( MagellanWindow );
 XMagellanEvent.xclient.data.s[1] = (short) XLow32( MagellanWindow );
 XMagellanEvent.xclient.data.s[2] = MagellanMemData.x;
 XMagellanEvent.xclient.data.s[3] = MagellanMemData.y;
 XMagellanEvent.xclient.data.s[4] = MagellanMemData.z;
 XMagellanEvent.xclient.data.s[5] = MagellanMemData.a;
 XMagellanEvent.xclient.data.s[6] = MagellanMemData.b;
 XMagellanEvent.xclient.data.s[7] = MagellanMemData.c;
 if ( ApplicationChoice( Application ) == OLDVERSION )
  XMagellanEvent.xclient.data.s[8] = 1000;
 else
  XMagellanEvent.xclient.data.s[8] = 60;

 if ( Application == PROENGINEER_16_SAVE )
  {
   FindWindowProEngineer = FALSE;
   XGetWMName( display, XFocusWindow, &WindowProperty );
   if ( WindowProperty.nitems > 0 )
    {
     WindowProperty.value[ WindowProperty.nitems ] = '\000';
     if ( IsWindowProEngineer( WindowProperty.value ) )
      {
       XSendEvent( display, XFocusWindow, FALSE, 0x0000, &XMagellanEvent );
       FindWindowProEngineer = TRUE;
       if ( MagellanMemDataSendEvents == FALSE )
	{
	 printf("%s \"%s\"\n", LangString( LANG_SENDWINDOW ), WindowProperty.value );
        };
       MagellanMemDataSendEvents = TRUE;
      };
    };

   if ( ((FindWindowProEngineer == FALSE) && MagellanMemDataSendEvents) ||
	((FindWindowProEngineer == TRUE ) &&
	 (UsedWindowProEngineer != XFocusWindow) &&
	 (UsedWindowProEngineer != InputFocus)) )
    {
     MoveFinishProEngineer( display, UsedWindowProEngineer );
     MagellanMemDataSendEvents = TRUE;
    };
   UsedWindowProEngineer = XFocusWindow;
  }
 else
  {
   XSendEvent( display, XFocusWindow, FALSE, 0x0000, &XMagellanEvent );
  };

 if ( Application == DUALVERSION )
  {
   XMagellanEvent.xclient.serial = NextRequest( display );
   XMagellanEvent.xclient.message_type = MagellanMotionEventVersion1;
   XMagellanEvent.xclient.data.s[8] = 1000;
   XSendEvent( display, XFocusWindow, FALSE, 0x0000, &XMagellanEvent ); 
  };

 if ( Application == PROENGINEER_16_SAVE )
  {
   if ( (MagellanMemData.x == 0) && (MagellanMemData.y == 0) &&
	(MagellanMemData.z == 0) && (MagellanMemData.a == 0) &&
	(MagellanMemData.b == 0) && (MagellanMemData.c == 0) &&
	MagellanMemDataSendEvents )
    {
     MoveFinishProEngineer( display, XFocusWindow );
     MagellanMemDataAllZero = TRUE;
     MagellanMemDataSendEvents = FALSE;
    }
   else
    MagellanMemDataAllZero = FALSE;
  };

 XFlush( display );

 return TRUE;
} 

void NonLinearTranslation( v1,v2,v3 )
int *v1;
int *v2;
int *v3;
{
int factor, e1,e2,e3;

 e1 = (*v1) > 0 ? 1 : (*v1) < 0 ? -1 : 0;
 e2 = (*v2) > 0 ? 1 : (*v2) < 0 ? -1 : 0;
 e3 = (*v3) > 0 ? 1 : (*v3) < 0 ? -1 : 0;

 factor = (*v1)*(*v1) + (*v2)*(*v2) + (*v3)*(*v3);
 factor = factor / 2048;
 factor = factor > 120 ? 120 : factor;

 (*v1) = ((*v1) + (*v1)*factor/8)/16 + e1;
 (*v2) = ((*v2) + (*v2)*factor/8)/16 + e2;
 (*v3) = ((*v3) + (*v3)*factor/8)/16 + e3;
}

void NonLinearRotation( v1,v2,v3 )
int *v1;
int *v2;
int *v3;
{
int factor, e1,e2,e3;

 e1 = (*v1) > 0 ? 1 : (*v1) < 0 ? -1 : 0;
 e2 = (*v2) > 0 ? 1 : (*v2) < 0 ? -1 : 0;
 e3 = (*v3) > 0 ? 1 : (*v3) < 0 ? -1 : 0;

 factor = (*v1)*(*v1) + (*v2)*(*v2) + (*v3)*(*v3);
 factor = factor / 512;
 factor = factor > 360 ? 360 : factor;

 (*v1) = ((*v1) + (*v1)*factor/8)/96 + e1;
 (*v2) = ((*v2) + (*v2)*factor/8)/96 + e2;
 (*v3) = ((*v3) + (*v3)*factor/8)/96 + e3;
}

char * strupr( string )
char * string;
{
char *strreturn;

 strreturn = string;
 while ( (*string) != 0 )
  {
   if ( (*string>='a') && (*string<='z') )
    (*string) = (*string) - 'a' + 'A';
   ++string;
  };
 return strreturn;
}


/*| ------------------------- |*/
/*| X Windows Keyboard Events |*/
/*| ------------------------- |*/

struct _XKeyboardTable_ {
 char   KeysymStringLength;
 KeySym Keysym;
 char * KeysymString;
};
typedef struct _XKeyboardTable_ XKeyboardTable;

XKeyboardTable XKeyTable[] = {
{  4, 0x0030, "0" },
{  4, 0x0031, "1" },
{  4, 0x0032, "2" },
{  4, 0x0033, "3" },
{  4, 0x0034, "4" },
{  4, 0x0035, "5" },
{  4, 0x0036, "6" },
{  4, 0x0037, "7" },
{  4, 0x0038, "8" },
{  4, 0x0039, "9" },
{  4, 0x0041, "A" },
{  4, 0x0042, "B" },
{  4, 0x0043, "C" },
{  4, 0x0044, "D" },
{  4, 0x0045, "E" },
{  4, 0x0046, "F" },
{  4, 0x0047, "G" },
{  4, 0x0048, "H" },
{  4, 0x0049, "I" },
{  4, 0x004A, "J" },
{  4, 0x004B, "K" },
{  4, 0x004C, "L" },
{  4, 0x004D, "M" },
{  4, 0x004E, "N" },
{  4, 0x004F, "O" },
{  4, 0x0050, "P" },
{  4, 0x0051, "Q" },
{  4, 0x0052, "R" },
{  4, 0x0053, "S" },
{  4, 0x0054, "T" },
{  4, 0x0055, "U" },
{  4, 0x0056, "V" },
{  4, 0x0057, "W" },
{  4, 0x0058, "X" },
{  4, 0x0059, "Y" },
{  4, 0x005A, "Z" },
{  4, 0x0061, "a" },
{  4, 0x0062, "b" },
{  4, 0x0063, "c" },
{  4, 0x0064, "d" },
{  4, 0x0065, "e" },
{  4, 0x0066, "f" },
{  4, 0x0067, "g" },
{  4, 0x0068, "h" },
{  4, 0x0069, "i" },
{  4, 0x006A, "j" },
{  4, 0x006B, "k" },
{  4, 0x006C, "l" },
{  4, 0x006D, "m" },
{  4, 0x006E, "n" },
{  4, 0x006F, "o" },
{  4, 0x0070, "p" },
{  4, 0x0071, "q" },
{  4, 0x0072, "r" },
{  4, 0x0073, "s" },
{  4, 0x0074, "t" },
{  4, 0x0075, "u" },
{  4, 0x0076, "v" },
{  4, 0x0077, "w" },
{  4, 0x0078, "x" },
{  4, 0x0079, "y" },
{  4, 0x007A, "z" },
{  5, 0x0040, "at" },
{  5, 0x00B5, "mu" },
{  5, 0x00C6, "AE" },
{  5, 0x00E6, "ae" },
{  5, 0xFF52, "Up" },
{  5, 0xFFBE, "F1" },
{  5, 0xFFBF, "F2" },
{  5, 0xFFC0, "F3" },
{  5, 0xFFC1, "F4" },
{  5, 0xFFC2, "F5" },
{  5, 0xFFC3, "F6" },
{  5, 0xFFC4, "F7" },
{  5, 0xFFC5, "F8" },
{  5, 0xFFC6, "F9" },
{  5, 0xFFC8, "L1" },
{  5, 0xFFC9, "L2" },
{  5, 0xFFCA, "L3" },
{  5, 0xFFCB, "L4" },
{  5, 0xFFCC, "L5" },
{  5, 0xFFCD, "L6" },
{  5, 0xFFCE, "L7" },
{  5, 0xFFCF, "L8" },
{  5, 0xFFD0, "L9" },
{  5, 0xFFD2, "R1" },
{  5, 0xFFD3, "R2" },
{  5, 0xFFD4, "R3" },
{  5, 0xFFD5, "R4" },
{  5, 0xFFD6, "R5" },
{  5, 0xFFD7, "R6" },
{  5, 0xFFD8, "R7" },
{  5, 0xFFD9, "R8" },
{  5, 0xFFDA, "R9" },
{  6, 0x007C, "bar" },
{  6, 0x00A5, "yen" },
{  6, 0x00D0, "ETH" },
{  6, 0x00D0, "Eth" },
{  6, 0x00F0, "eth" },
{  6, 0xFF09, "Tab" },
{  6, 0xFF57, "End" },
{  6, 0xFFC7, "F10" },
{  6, 0xFFC8, "F11" },
{  6, 0xFFC9, "F12" },
{  6, 0xFFCA, "F13" },
{  6, 0xFFCB, "F14" },
{  6, 0xFFCC, "F15" },
{  6, 0xFFCD, "F16" },
{  6, 0xFFCE, "F17" },
{  6, 0xFFCF, "F18" },
{  6, 0xFFD0, "F19" },
{  6, 0xFFD1, "F20" },
{  6, 0xFFD1, "L10" },
{  6, 0xFFD2, "F21" },
{  6, 0xFFD3, "F22" },
{  6, 0xFFD4, "F23" },
{  6, 0xFFD5, "F24" },
{  6, 0xFFD6, "F25" },
{  6, 0xFFD7, "F26" },
{  6, 0xFFD8, "F27" },
{  6, 0xFFD9, "F28" },
{  6, 0xFFDA, "F29" },
{  6, 0xFFDB, "F30" },
{  6, 0xFFDB, "R10" },
{  6, 0xFFDC, "F31" },
{  6, 0xFFDC, "R11" },
{  6, 0xFFDD, "F32" },
{  6, 0xFFDD, "R12" },
{  6, 0xFFDE, "F33" },
{  6, 0xFFDE, "R13" },
{  6, 0xFFDF, "F34" },
{  6, 0xFFDF, "R14" },
{  6, 0xFFE0, "F35" },
{  6, 0xFFE0, "R15" },
{  7, 0x002B, "plus" },
{  7, 0x003C, "less" },
{  7, 0x00A2, "cent" },
{  7, 0xFF50, "Home" },
{  7, 0xFF51, "Left" },
{  7, 0xFF54, "Down" },
{  7, 0xFF56, "Next" },
{  7, 0xFF65, "Undo" },
{  7, 0xFF66, "Redo" },
{  7, 0xFF67, "Menu" },
{  7, 0xFF68, "Find" },
{  7, 0xFF6A, "Help" },
{  7, 0xFFB0, "KP_0" },
{  7, 0xFFB1, "KP_1" },
{  7, 0xFFB2, "KP_2" },
{  7, 0xFFB3, "KP_3" },
{  7, 0xFFB4, "KP_4" },
{  7, 0xFFB5, "KP_5" },
{  7, 0xFFB6, "KP_6" },
{  7, 0xFFB7, "KP_7" },
{  7, 0xFFB8, "KP_8" },
{  7, 0xFFB9, "KP_9" },
{  8, 0x0020, "space" },
{  8, 0x002C, "comma" },
{  8, 0x002D, "minus" },
{  8, 0x002F, "slash" },
{  8, 0x003A, "colon" },
{  8, 0x003D, "equal" },
{  8, 0x0060, "grave" },
{  8, 0x00B4, "acute" },
{  8, 0x00C5, "Aring" },
{  8, 0x00DE, "THORN" },
{  8, 0x00DE, "Thorn" },
{  8, 0x00E5, "aring" },
{  8, 0x00FE, "thorn" },
{  8, 0xFF0B, "Clear" },
{  8, 0xFF13, "Pause" },
{  8, 0xFF21, "Kanji" },
{  8, 0xFF53, "Right" },
{  8, 0xFF55, "Prior" },
{  8, 0xFF58, "Begin" },
{  8, 0xFF61, "Print" },
{  8, 0xFF6B, "Break" },
{  8, 0xFF91, "KP_F1" },
{  8, 0xFF92, "KP_F2" },
{  8, 0xFF93, "KP_F3" },
{  8, 0xFF94, "KP_F4" },
{  8, 0xFF97, "KP_Up" },
{  8, 0xFFE9, "Alt_L" },
{  8, 0xFFEA, "Alt_R" },
{  9, 0x0021, "exclam" },
{  9, 0x0024, "dollar" },
{  9, 0x002E, "period" },
{  9, 0x00AD, "hyphen" },
{  9, 0x00AF, "macron" },
{  9, 0x00B0, "degree" },
{  9, 0x00C0, "Agrave" },
{  9, 0x00C1, "Aacute" },
{  9, 0x00C3, "Atilde" },
{  9, 0x00C8, "Egrave" },
{  9, 0x00C9, "Eacute" },
{  9, 0x00CC, "Igrave" },
{  9, 0x00CD, "Iacute" },
{  9, 0x00D1, "Ntilde" },
{  9, 0x00D2, "Ograve" },
{  9, 0x00D3, "Oacute" },
{  9, 0x00D5, "Otilde" },
{  9, 0x00D9, "Ugrave" },
{  9, 0x00DA, "Uacute" },
{  9, 0x00DD, "Yacute" },
{  9, 0x00DF, "ssharp" },
{  9, 0x00E0, "agrave" },
{  9, 0x00E1, "aacute" },
{  9, 0x00E3, "atilde" },
{  9, 0x00E8, "egrave" },
{  9, 0x00E9, "eacute" },
{  9, 0x00EC, "igrave" },
{  9, 0x00ED, "iacute" },
{  9, 0x00F1, "ntilde" },
{  9, 0x00F2, "ograve" },
{  9, 0x00F3, "oacute" },
{  9, 0x00F5, "otilde" },
{  9, 0x00F8, "oslash" },
{  9, 0x00F9, "ugrave" },
{  9, 0x00FA, "uacute" },
{  9, 0x00FD, "yacute" },
{  9, 0xFF0D, "Return" },
{  9, 0xFF1B, "Escape" },
{  9, 0xFF23, "Henkan" },
{  9, 0xFF24, "Romaji" },
{  9, 0xFF2C, "Massyo" },
{  9, 0xFF31, "Hangul" },
{  9, 0xFF60, "Select" },
{  9, 0xFF63, "Insert" },
{  9, 0xFF69, "Cancel" },
{  9, 0xFF89, "KP_Tab" },
{  9, 0xFF9C, "KP_End" },
{  9, 0xFFAB, "KP_Add" },
{  9, 0xFFE7, "Meta_L" },
{  9, 0xFFE8, "Meta_R" },
{  9, 0xFFFF, "Delete" },
{ 10, 0x0025, "percent" },
{ 10, 0x003E, "greater" },
{ 10, 0x00A7, "section" },
{ 10, 0x00AC, "notsign" },
{ 10, 0x00B8, "cedilla" },
{ 10, 0x00BD, "onehalf" },
{ 10, 0xFF15, "Sys_Req" },
{ 10, 0xFF28, "Zenkaku" },
{ 10, 0xFF29, "Hankaku" },
{ 10, 0xFF2B, "Touroku" },
{ 10, 0xFF55, "Page_Up" },
{ 10, 0xFF62, "Execute" },
{ 10, 0xFF95, "KP_Home" },
{ 10, 0xFF96, "KP_Left" },
{ 10, 0xFF99, "KP_Down" },
{ 10, 0xFF9B, "KP_Next" },
{ 10, 0xFFE1, "Shift_L" },
{ 10, 0xFFE2, "Shift_R" },
{ 10, 0xFFEB, "Super_L" },
{ 10, 0xFFEC, "Super_R" },
{ 10, 0xFFED, "Hyper_L" },
{ 10, 0xFFEE, "Hyper_R" },
{ 11, 0x0022, "quotedbl" },
{ 11, 0x002A, "asterisk" },
{ 11, 0x003F, "question" },
{ 11, 0x00A3, "sterling" },
{ 11, 0x00A4, "currency" },
{ 11, 0x00C7, "Ccedilla" },
{ 11, 0x00D7, "multiply" },
{ 11, 0x00D8, "Ooblique" },
{ 11, 0x00E7, "ccedilla" },
{ 11, 0x00F7, "division" },
{ 11, 0xFF0A, "Linefeed" },
{ 11, 0xFF22, "Muhenkan" },
{ 11, 0xFF25, "Hiragana" },
{ 11, 0xFF26, "Katakana" },
{ 11, 0xFF7F, "Num_Lock" },
{ 11, 0xFF80, "KP_Space" },
{ 11, 0xFF8D, "KP_Enter" },
{ 11, 0xFF98, "KP_Right" },
{ 11, 0xFF9A, "KP_Prior" },
{ 11, 0xFF9D, "KP_Begin" },
{ 11, 0xFFBD, "KP_Equal" },
{ 12, 0x0026, "ampersand" },
{ 12, 0x0028, "parenleft" },
{ 12, 0x003B, "semicolon" },
{ 12, 0x005C, "backslash" },
{ 12, 0x0060, "quoteleft" },
{ 12, 0x007B, "braceleft" },
{ 12, 0x00A6, "brokenbar" },
{ 12, 0x00A8, "diaeresis" },
{ 12, 0x00A9, "copyright" },
{ 12, 0x00B1, "plusminus" },
{ 12, 0x00B6, "paragraph" },
{ 12, 0x00BA, "masculine" },
{ 12, 0xFF08, "BackSpace" },
{ 12, 0xFF20, "Multi_key" },
{ 12, 0xFF2D, "Kana_Lock" },
{ 12, 0xFF56, "Page_Down" },
{ 12, 0xFF9E, "KP_Insert" },
{ 12, 0xFF9F, "KP_Delete" },
{ 12, 0xFFAF, "KP_Divide" },
{ 12, 0xFFE3, "Control_L" },
{ 12, 0xFFE4, "Control_R" },
{ 12, 0xFFE5, "Caps_Lock" },
{ 13, 0x0023, "numbersign" },
{ 13, 0x0027, "apostrophe" },
{ 13, 0x0027, "quoteright" },
{ 13, 0x0029, "parenright" },
{ 13, 0x005F, "underscore" },
{ 13, 0x007D, "braceright" },
{ 13, 0x007E, "asciitilde" },
{ 13, 0x00A1, "exclamdown" },
{ 13, 0x00AE, "registered" },
{ 13, 0x00BC, "onequarter" },
{ 13, 0x00C4, "Adiaeresis" },
{ 13, 0x00CB, "Ediaeresis" },
{ 13, 0x00CF, "Idiaeresis" },
{ 13, 0x00D6, "Odiaeresis" },
{ 13, 0x00DC, "Udiaeresis" },
{ 13, 0x00E4, "adiaeresis" },
{ 13, 0x00EB, "ediaeresis" },
{ 13, 0x00EF, "idiaeresis" },
{ 13, 0x00F6, "odiaeresis" },
{ 13, 0x00FC, "udiaeresis" },
{ 13, 0x00FF, "ydiaeresis" },
{ 13, 0xFF2E, "Kana_Shift" },
{ 13, 0xFF2F, "Eisu_Shift" },
{ 13, 0xFF33, "Hangul_End" },
{ 13, 0xFF9A, "KP_Page_Up" },
{ 13, 0xFFAE, "KP_Decimal" },
{ 13, 0xFFE6, "Shift_Lock" },
{ 14, 0x005B, "bracketleft" },
{ 14, 0x005E, "asciicircum" },
{ 14, 0x00AA, "ordfeminine" },
{ 14, 0x00B2, "twosuperior" },
{ 14, 0x00B9, "onesuperior" },
{ 14, 0x00C2, "Acircumflex" },
{ 14, 0x00CA, "Ecircumflex" },
{ 14, 0x00CE, "Icircumflex" },
{ 14, 0x00D4, "Ocircumflex" },
{ 14, 0x00DB, "Ucircumflex" },
{ 14, 0x00E2, "acircumflex" },
{ 14, 0x00EA, "ecircumflex" },
{ 14, 0x00EE, "icircumflex" },
{ 14, 0x00F4, "ocircumflex" },
{ 14, 0x00FB, "ucircumflex" },
{ 14, 0xFF14, "Scroll_Lock" },
{ 14, 0xFF23, "Henkan_Mode" },
{ 14, 0xFF30, "Eisu_toggle" },
{ 14, 0xFF35, "Hangul_Jamo" },
{ 14, 0xFF7E, "Mode_switch" },
{ 14, 0xFF7E, "kana_switch" },
{ 14, 0xFFAA, "KP_Multiply" },
{ 14, 0xFFAD, "KP_Subtract" },
{ 15, 0x005D, "bracketright" },
{ 15, 0x00A0, "nobreakspace" },
{ 15, 0x00BF, "questiondown" },
{ 15, 0xFF32, "Hangul_Start" },
{ 15, 0xFF34, "Hangul_Hanja" },
{ 15, 0xFF39, "Hangul_Banja" },
{ 15, 0xFF7E, "Greek_switch" },
{ 15, 0xFF9B, "KP_Page_Down" },
{ 15, 0xFFAC, "KP_Separator" },
{ 16, 0x00AB, "guillemotleft" },
{ 16, 0x00B3, "threesuperior" },
{ 16, 0x00BE, "threequarters" },
{ 16, 0xFF36, "Hangul_Romaja" },
{ 16, 0xFF38, "Hangul_Jeonja" },
{ 16, 0xFF7E, "Arabic_switch" },
{ 16, 0xFF7E, "Hangul_switch" },
{ 16, 0xFF7E, "Hebrew_switch" },
{ 16, 0xFF7E, "script_switch" },
{ 17, 0x00B7, "periodcentered" },
{ 17, 0x00BB, "guillemotright" },
{ 17, 0xFF3F, "Hangul_Special" },
{ 18, 0xFF2A, "Zenkaku_Hankaku" },
{ 18, 0xFF3A, "Hangul_PreHanja" },
{ 18, 0xFF7E, "ISO_Group_Shift" },
{ 19, 0xFF37, "Hangul_Codeinput" },
{ 19, 0xFF3B, "Hangul_PostHanja" },
{ 20, 0xFF27, "Hiragana_Katakana" },
{ 25, 0xFF3C, "Hangul_SingleCandidate" },
{ 27, 0xFF3D, "Hangul_MultipleCandidate" },
{ 27, 0xFF3E, "Hangul_PreviousCandidate" },
{0,0x0000,NULL} 

};

KeySym XStringToKeysymTable( string )
char *string;
{
int loop, length;
char KeyString[ 64 ];

 if ( (string[0]!='X') || (string[1]!='K') || (string[2]!='_') )
  {
   sprintf( KeyString, "XK_%s", string );
   string = KeyString;
  };

 length = (int) strlen( string );
 loop = 0;

 while ( XKeyTable[ loop ].KeysymString != NULL )
  {
   if ( length == XKeyTable[ loop ].KeysymStringLength )
    {
     if ( strcmp( &string[3], XKeyTable[ loop ].KeysymString ) == 0 )
      return XKeyTable[ loop ].Keysym;
    }
   else
    if ( length < XKeyTable[ loop ].KeysymStringLength )
     return NoSymbol;
   ++loop;
  };

 return NoSymbol;
}

int KeyboardState = 0;
int KeyboardModifier[] = { 0x0000, ShiftMask, ControlMask, Mod1Mask,
                           ControlMask|Mod1Mask, -1 };

int WindowKeyboard( display, window, keytype, key )
Display *display;
Window window;
int keytype;
KeySym key;
{
XEvent KeyboardEvent;
Window rootwindow, childwindow;
int rootx, rooty, winx, winy, ReturnWindow, KeyboardLocalState;
unsigned int mask, loop;
char Buffer[ 8 ];
KeySym keysym;

 ReturnWindow = 0;
 if ( window == InputFocus )
  XGetInputFocus( display, &window, &ReturnWindow );
 
 XQueryPointer(display, window, &rootwindow, &childwindow, &rootx, &rooty,
	                                                &winx, &winy, &mask );

 KeyboardEvent.xkey.type = keytype;
 KeyboardEvent.xkey.serial = NextRequest( display );
 KeyboardEvent.xkey.send_event = FALSE;
 KeyboardEvent.xkey.display = display;
 KeyboardEvent.xkey.window = window;
 KeyboardEvent.xkey.root = rootwindow;
 KeyboardEvent.xkey.subwindow = childwindow;
 KeyboardEvent.xkey.time = time(NULL);
 KeyboardEvent.xkey.x = winx;
 KeyboardEvent.xkey.y = winy;
 KeyboardEvent.xkey.x_root = rootx;
 KeyboardEvent.xkey.y_root = rooty;
 KeyboardEvent.xkey.keycode = XKeysymToKeycode(display,key);
 KeyboardEvent.xkey.same_screen = TRUE;
 KeyboardEvent.xkey.state = KeyboardState;

 KeyboardLocalState = 0;
 for ( loop=0; KeyboardModifier[loop]!=-1; ++loop )
  {
   memset( Buffer, 0x00, sizeof(Buffer) );

   KeyboardLocalState = KeyboardModifier[loop];
   KeyboardEvent.xkey.state = KeyboardState | KeyboardLocalState;
   XLookupString((XKeyEvent*)&KeyboardEvent,Buffer,sizeof(Buffer),&keysym,NULL);

   if ( XDriverDebug )
    printf("STATE=0x%02X  key=0x%02X buffer=0x%02X state=0x%04X \n",
            KeyboardEvent.xkey.state, key, *Buffer, KeyboardLocalState );

   if ( key == *Buffer )
    break;

   KeyboardLocalState = 0;
  };
 KeyboardEvent.xkey.state = KeyboardState | KeyboardLocalState;

 XSendEvent( display, window, FALSE, 0x0000, &KeyboardEvent );
 XFlush( display );

 switch( key )
  {
   case XK_Shift_L : /* Left shift */
   case XK_Shift_R : /* Right shift */
   case XK_Shift_Lock : /* Shift lock */
    if ( keytype == KeyPress )
     KeyboardState |= ShiftMask;
    else
     KeyboardState &= ~ShiftMask;
   break;
  
   case XK_Control_L : /* Left control */
   case XK_Control_R : /* Right control */
    if ( keytype == KeyPress )
     KeyboardState |= ControlMask;
    else
     KeyboardState &= ~ControlMask;
    break;

   case XK_Alt_L : /* Left alt */
   case XK_Alt_R : /* Right alt */
    if ( keytype == KeyPress )
     KeyboardState |= Mod1Mask;
    else
     KeyboardState &= ~Mod1Mask;
    break;

   case XK_Caps_Lock : /* Caps lock */
    if ( keytype == KeyPress )
     KeyboardState |= LockMask;
    else
     KeyboardState &= ~LockMask;
    break;

   case XK_Meta_L : /* Left meta */
   case XK_Meta_R : /* Right meta */
    if ( keytype == KeyPress )
     KeyboardState |= Mod2Mask;
    else
     KeyboardState &= ~Mod2Mask;
    break;

   case XK_Super_L : /* Left super */
   case XK_Super_R : /* Right super */
    if ( keytype == KeyPress )
     KeyboardState |= Mod3Mask;
    else
     KeyboardState &= ~Mod3Mask;
    break;

   case XK_Hyper_L : /* Left hyper */
   case XK_Hyper_R : /* Right hyper */
    if ( keytype == KeyPress )
     KeyboardState |= Mod4Mask;
    else
     KeyboardState &= ~Mod4Mask;
    break;
  };

 return TRUE;
}

int StringWindowKeyboard( display, window, string )
Display *display;
Window window;
char *string;
{
 while ( *string != 0x00 )
  {
   WindowKeyboard( display, window, KeyPress, *string );
   WindowKeyboard( display, window, KeyRelease, *string++ );
  };
 return TRUE;
}

char *StringRemoveSpace( string )
char *string;
{
char *stringret;

 do
  {
   if ( *string == '\x00' )
    return string;

   if ( isspace( *string ) )
    ++string;
   else
    break;
  } while(TRUE);

 stringret = string;

 string = stringret + strlen( string )-1;
 do
  {
   if ( string < stringret )
    return stringret;

   if ( isspace( *string ) )
    *string-- = '\x00';
   else
    break;
  } while( TRUE );

 return stringret;
}

int SyntaxParser( string, parameter )
char *string;
char *parameter;
{
KeySym key;


 string = StringRemoveSpace( string );

 strcpy( parameter, "" );

 if ( strcmp( (char *)string,"BEEP" ) == 0 ) return BEEP;
 if ( strcmp( (char *)string,"DISABLE" ) == 0 ) return DISABLE;
 if ( strcmp( (char *)string,"ENABLE" ) == 0 ) return ENABLE;
 if ( strcmp( (char *)string,"MAPPING" ) == 0 ) return MAPPING;

 if ( string[0] == '+' )
  {
   key = XStringToKeysymTable( &string[1] );
   if ( key == NoSymbol )
    {
     printf("%s [Keysym] %s\n", LangString(LANG_ILLEGALSYMBOL), string );
     return SYNTAXUNKNOWN;
    };
   strcpy( parameter, &string[1] );
   return SINGLEKEYPRESS;
  };

 if ( string[0] == '-' )
  {
   key = XStringToKeysymTable( &string[1] );
   if ( key == NoSymbol )
    {
     printf("%s [Keysym] %s\n", LangString(LANG_ILLEGALSYMBOL), string );
     return SYNTAXUNKNOWN;
    };
   strcpy( parameter, &string[1] );
   return SINGLEKEYRELEASE;
  };

 if ( string[0] == '\"' )
  if ( string[ strlen(string) - 1 ] == '\"' )
   {
    strcpy( parameter, &string[1] );
    parameter[ strlen(parameter) - 1 ] = '\000';

    return STRING;
   };

 key = XStringToKeysymTable( string );
 if ( key == NoSymbol )
  {
   printf("%s [Keysym] %s\n", LangString(LANG_ILLEGALSYMBOL), string );
   return SYNTAXUNKNOWN;
  };
 strcpy( parameter, &string[0] );
 return SINGLEKEY;
}

int ButtonParser( display, window, parserstring, action )
Display *display;
Window window;
char *parserstring;
int action;
{
char *ptr, parameter[256], string[256];
int beep,enable,disable,mapping,button,token;
KeySym keysym;

 strcpy( string, parserstring );

 beep=enable=disable=mapping=FALSE;

 ptr = strtok( string, ":," );
 switch( *ptr )
  {
   case '1':
   case '2':
   case '3':
   case '4':
   case '5':
   case '6':
   case '7':
   case '8': button = (*ptr) - '0';
	     break;
  
   case '9':
   case '*': button = 9;
	     break;

   default : return FALSE;
  };

 do
  {
   ptr = strtok( NULL, ":," );
   if ( ptr != NULL )
    {
     token = SyntaxParser( ptr, parameter );
     switch( token )
      {
       case SYNTAXUNKNOWN :
        printf("%s %d\n%s\n\n", LangString( LANG_ERRORLINE ), button, parserstring );
	break;
	
       case BEEP : 
	if ( action == TRUE )
	 MagellanTransmitReceive( MagellanHandle, MagellanBeeper, "b\r" );
	beep = BEEP;
        break;

       case DISABLE : disable = DISABLE; break;

       case ENABLE :  enable = ENABLE; break;

       case MAPPING : mapping = MAPPING; break;

       case SINGLEKEYPRESS : 
	if ( (mapping == MAPPING) && (action == TRUE) )
	 {
	  keysym = XStringToKeysymTable( parameter );
          WindowKeyboard( display, window, KeyPress, keysym ); 
         };
        break;
  
       case SINGLEKEYRELEASE : 
	if ( (mapping == MAPPING) && (action == TRUE) )
	 {
	  keysym = XStringToKeysymTable( parameter );
          WindowKeyboard( display, window, KeyRelease, keysym );
         };
        break;
  
       case SINGLEKEY : 
	if ( (mapping == MAPPING) && (action == TRUE) )
	 {
	  keysym = XStringToKeysymTable( parameter );
          WindowKeyboard( display, window, KeyPress, keysym ); 
          WindowKeyboard( display, window, KeyRelease, keysym );
         };
        break;
  
       case STRING :
	if ( (mapping == MAPPING) && (action == TRUE) )
	 {
          StringWindowKeyboard( display, window, parameter );
         }; 
         break;
      };
    } 
   else
    break;

  } while ( !disable );

 return enable | mapping | beep; 
}


int MagellanSetWindow( display, window )
Display *display;
Window window;
{
Window MagellanWindow;
Atom ActualType,AtomCommandEvent;
int ActualFormat;
unsigned long NItems, BytesReturn;
unsigned char *PropReturn;
XEvent event;

 AtomCommandEvent = XInternAtom( display,"CommandEvent", TRUE );
 if ( AtomCommandEvent == None )
  return FALSE;

 XGetWindowProperty( display, RootWindow(display,DefaultScreen(display)),
                     AtomCommandEvent, 0,1, FALSE,
                     AnyPropertyType, &ActualType, &ActualFormat, &NItems,
		     &BytesReturn, &PropReturn );

 MagellanWindow = (Window) NULL;
 if ( PropReturn != NULL )
  MagellanWindow = *(Window *) PropReturn;

 memset( &event, 0x00, sizeof(event) );
 event.type = ClientMessage;
 event.xclient.serial = NextRequest( display );
 event.xclient.format = 16;
 event.xclient.send_event = FALSE;
 event.xclient.display = display;
 event.xclient.window = MagellanWindow;
 event.xclient.message_type = AtomCommandEvent;

 event.xclient.data.s[0] = (short) XHigh32( window );
 event.xclient.data.s[1] = (short) XLow32( window );
 event.xclient.data.s[2] = CommandMessageApplicationWindow;

 XSendEvent( display, MagellanWindow, FALSE, 0x0000, &event );
 XFlush( display );

 return MagellanWindow != (Window) NULL;
}

char *XFontName( display )
Display *display;
{
char **XListFontNames;
int fontcount;

 XListFontNames = XListFonts(display,"*courier-bold-r*--20*",32767,&fontcount);
 if ( fontcount > 0 )
  return XListFontNames[0];

 XListFontNames = XListFonts( display, "*courier*--20*", 32767, &fontcount );
 if ( fontcount > 0 )
  return XListFontNames[0];

 XListFontNames = XListFonts( display, "*--20*", 32767, &fontcount );
 if ( fontcount > 0 )
  return XListFontNames[0];
 
 XListFontNames = XListFonts( display, "*", 32767, &fontcount );
 if ( fontcount > 0 )
  return XListFontNames[0];
 
 return NULL;
}

void MagellanTimerSignal( sig )
int sig;
{
}

Atom EnableAtom;
char MagellanInterfaceString[256];
pid_t MagellanChildProcessInterfaceEnable;

int MagellanEnableString( display, window, Text )
Display *display;
Window window;
char *Text;
{
char Command[20];
Window FocusWindow;
int RevertWindow, loop;
XEvent Event;

 if ( (int)strlen(Text) > 18 )
  {
   memset( Command, 0x00, sizeof(Command) );
   strncpy( Command, Text, 18 );
   MagellanEnableString( display, window, Command );
   return MagellanEnableString( display, window, &Text[18] );
  }
 else
  {
   FocusWindow = InputFocus;
   RevertWindow = RevertToNone;
   XGetInputFocus( display, &FocusWindow, &RevertWindow );   

   memset( &Event, 0x00, sizeof(Event) );
   Event.xclient.type = ClientMessage;
   Event.xclient.serial = NextRequest(display);
   Event.xclient.send_event = True;
   Event.xclient.display = display;
   Event.xclient.window = FocusWindow;
   Event.xclient.message_type = EnableAtom;
   Event.xclient.format = 8;
   strcpy( Event.xclient.data.b, Text );

   XSendEvent( display, FocusWindow, False, 0, &Event );
   XFlush( display );
  };
 return TRUE;
}

void MagellanInterfaceEnable()
{
Display *display;
int screen;
Window EnableWindow;
XEvent Event;
char String[256], Command[256], *CommandEnd;

 MagellanChildProcessInterfaceEnable = fork();
 if ( MagellanChildProcessInterfaceEnable == 0 )
  {
   XSetErrorHandler( MagellanErrorHandler );  

   display = XOpenDisplay( NULL );
   screen = DefaultScreen( display );

   memset( MagellanInterfaceString, 0x00, sizeof(MagellanInterfaceString) );
   EnableWindow = XCreateSimpleWindow( display, RootWindow(display,screen),
                                       0,0, 1,1,1, 0,0 );
   XStoreName( display, EnableWindow, "sballd_XCM" );
   EnableAtom = XInternAtom(display,"SpaceWarePassThruCommandEventType",FALSE);
   
   while( _TRUE_ )
    {
     XNextEvent( display, &Event );
     if ( Event.xany.type == ClientMessage )
      {
       if ( Event.xclient.message_type == EnableAtom )
        {
         strcat( MagellanInterfaceString, Event.xclient.data.b ); 
         while ( (CommandEnd = strchr(MagellanInterfaceString, '\r')) != NULL )
          {
           *CommandEnd = '\000';
           strcpy( Command, MagellanInterfaceString );
           ++CommandEnd;
           strcpy( MagellanInterfaceString, CommandEnd );

           if ( XDriverDebug )
            printf("[%s]\n", Command );

           if ( strcmp( Command, "hv" ) == 0 )
            MagellanEnableString( display, EnableWindow, 
                          "vFirmware version 2.13 created on 07-Apr-1993\r" );

           if ( strstr( Command, "~~" ) != NULL )
            MagellanEnableString( display, EnableWindow, "~~Xdaemon V7.1\r" );
      
           if ( Command[0] == '$' )
            {
             switch( Command[1] )
              {
               case 'C' : 
                break;

               case 'D' : 
                Command[6] = '\000';
                if ( strcmp( &Command[2], "8005" ) == 0 )
                 sprintf( String, "$<%s> %02X %02X %02X\r", &Command[2],
                                         'd', 'o', 'g' );
                if ( strcmp( &Command[2], "94B0" ) == 0 )
                 sprintf( String, "$<%s> %02X %02X %02X\r", &Command[2],
                                      0x10, 0x44, 0xA8 );
                MagellanEnableString( display, EnableWindow, String );
                break;
              };
            };      

          };
        };
      };
    };
   XCloseDisplay( display );
  };
}


char *MagellanHostComputer()
{
char *HostString;

 HostString = NULL;

#ifdef SGI
 HostString = "SGI";
#endif

#ifdef HP
 HostString = "HP";
#endif

#ifdef SUN
 HostString = "SUN";
#endif

#ifdef DEC
 HostString = "DEC";
#endif

#ifdef IBM
 HostString = "IBM";
#endif
 
 return HostString;
}


int main (argc, argv) 
int argc;
char * argv[];
{ 
char MagellanBuffer[ 128 ];
Display *display = NULL;
XEvent CommandEvent;
Window MagellanRootWindow, MagellanWindow;
int ReturnWindow;
XSetWindowAttributes MagellanAttribute;
char *MotionString, *ButtonPressString, *ButtonReleaseString, *CommandString;

 printf("\n%s%-11s %s     %s\n%s\n\n", LangString(LANG_VERSION1),
    LangString(LANG_DEVICENAME), LangString(LANG_VERSION2), 
    LangString(LANG_VERSION3), LangString(LANG_COPYRIGHT) );

 if ( MagellanHostComputer() == NULL )
  {
   printf("--- Internal Error ---- %s %s \n\r", 
           LangString( LANG_VERSION2 ), LangString( LANG_VERSION3 ) );
   return -1;
  };

 memset( GlobalConfig, 0x00, sizeof(GlobalConfig) );
 memset( GlobalKeyboard, 0x00, sizeof(GlobalKeyboard) );
 memset( LocalConfig, 0x00, sizeof(LocalConfig) );
 memset( LocalKeyboard, 0x00, sizeof(LocalKeyboard) );
 if ( getenv( MAGELLANCONFIG ) != NULL )
  {
   strcpy( LocalConfig, getenv( MAGELLANCONFIG ) );
   ConfigFilePtr = LocalConfig;
  }
 else
  {
   strcpy( GlobalConfig, FileConfig( argv[0] ) );
   ConfigFilePtr = GlobalConfig;
  };
 ConfigFileExist = FileExistRead( ConfigFilePtr );

 if ( getenv( MAGELLANKEYBOARD ) != NULL )
  {
   strcpy( LocalKeyboard, getenv( MAGELLANKEYBOARD ) );
   KeyboardFilePtr = LocalKeyboard;
  }
 else
  {
   strcpy( GlobalKeyboard, FileKeyboard( argv[0] ) );
   KeyboardFilePtr = GlobalKeyboard;
  };
 KeyboardFileExist = FileExistRead( KeyboardFilePtr );

 ParseArg( NULL, argv, argc, 1, ConfigFileExist==FALSE );
 ConfigFileExist = FileExistRead( ConfigFilePtr );

 if ( ConfigFileExist )
  {
   ConfigRead( ConfigFilePtr );
   printf("%s: %s \n", LangString(LANG_USECONFIG), ConfigFilePtr );
  }
 else
  {
   ConfigFileCreate( ConfigFilePtr, argv );
  };

 if ( ApplicationChoice( Application ) == OLDVERSION )
  {
   MotionString = "SpaceballMotionEventType";
   ButtonPressString = "SpaceballButtonPressEventType";
   ButtonReleaseString = "SpaceballButtonReleaseEventType";
   CommandString = "CommandEvent"; 
  }
 else
  {
   MotionString = "MotionEvent";
   ButtonPressString = "ButtonPressEvent";
   ButtonReleaseString = "ButtonReleaseEvent";
   CommandString = "CommandEvent";
  };

 KeyboardFileExist = FileExistRead( KeyboardFilePtr );
 if ( KeyboardFileExist )
  {
   FileKeyboardButtonStrings( KeyboardFilePtr );
   printf("%s: %s \n", LangString(LANG_USECONFIG), KeyboardFilePtr );
  }
 else
  {
   memset( FileKeyboardButton, 0x00, sizeof( FileKeyboardButton ) );
  };

 MagellanProcessID( ProgramName(argv[0]) );

 if ( !FileExist( MagellanFileName ) )
  {
   printf("%s [%s]\n", LangString( LANG_CANTOPENFILE ), MagellanFileName );
   exit( -1 );
  };

 XSetErrorHandler( MagellanErrorHandler );	

 display = XOpenDisplay( NULL ); 
 if ( display == NULL )
  {
   printf("DISPLAY %s\n", LangString( LANG_DISPLAYERROR ) );
   exit(-1);
  }

 MagellanMotionEvent = XInternAtom( display,MotionString, FALSE );
 MagellanButtonPressEvent = XInternAtom( display,ButtonPressString, FALSE );
 MagellanButtonReleaseEvent = XInternAtom( display,ButtonReleaseString, FALSE);
 MagellanCommandEvent = XInternAtom( display,CommandString, FALSE );
 if ( ApplicationChoice( Application ) == OLDVERSION )
  XInternAtom( display, "SpaceballPassThruCommandEventType", FALSE );

 MagellanMotionEventVersion1 = XInternAtom( display, "SpaceballMotionEventType", FALSE );
 MagellanButtonPressEventVersion1 = XInternAtom( display, "SpaceballButtonPressEventType", FALSE );
 MagellanButtonReleaseEventVersion1 = XInternAtom( display, "SpaceballButtonReleaseEventType", FALSE );
 
 MagellanRootWindow = RootWindow( display, DefaultScreen(display) );
 MagellanWindow = XCreateWindow( display, MagellanRootWindow, 1,1, 1,1, 0,0,
                                 InputOnly, NULL,0, &MagellanAttribute );

 XChangeProperty( display, MagellanRootWindow, MagellanCommandEvent,
                  MagellanCommandEvent, 32, PropModeReplace,
                  (unsigned char *) &MagellanWindow, 1 );
 XSetWMName( display, MagellanWindow, &MagellanWindowName );

 MagellanSetWindow( display, InputFocus );

 if ( !MagellanExist() )
  {
   printf("%s %s [%s]\n", LangString( LANG_DEVICENAME ), 
                         LangString( LANG_MAGELLANNOTFOUND ),
	                 MagellanFileName );
   exit(-1);
  };

 MagellanHandle = MagellanOpen( MagellanFileName, O_RDWR );
 if ( MagellanHandle == -1 )
  {
   printf("%s %s %s\n", LangString( LANG_DEVICENAME ), 
                        LangString( LANG_MAGELLANNOTFOUND ), "..." );
   exit(-1);
  };

 MagellanInitialize( MagellanHandle );


 printf("%s = %s  %s = 0x%X\n",LangString( LANG_DISPLAY ), XDisplayName(NULL),
			   LangString( LANG_DRIVERWINDOW ), MagellanWindow );

 ReturnWindow = 0;
 XFocusWindow = InputFocus;
 XUseWindow = InputFocus;
   
 ParseArg( display, argv, argc, 2, ConfigFileExist==FALSE );

 MagellanStatus.ApplicationSensitivity.Float = 1.0;
 MagellanStatusPanel( display, MagellanWindow, argc, argv, &MagellanStatus );

 if ( Application == UNIGRAPHICS_11 )
  MagellanInterfaceEnable();  

 memset( MagellanLineBuffer, 0x00, sizeof(MagellanLineBuffer) );
 MagellanLineBufferLength = 0;

 MagellanExternalScalingTranslationX *= MagellanExternalScalingTranslation;
 MagellanExternalScalingTranslationY *= MagellanExternalScalingTranslation;
 MagellanExternalScalingTranslationZ *= MagellanExternalScalingTranslation;
 MagellanExternalScalingRotationA    *= MagellanExternalScalingRotation;
 MagellanExternalScalingRotationB    *= MagellanExternalScalingRotation;
 MagellanExternalScalingRotationC    *= MagellanExternalScalingRotation;

 while ( _TRUE_ ) 
  {
   MagellanRead ( MagellanHandle, MagellanBuffer, sizeof( MagellanBuffer ) );   

   while( XPending( display ) )
    {
     XNextEvent( display, &CommandEvent );

     if ( CommandEvent.type == ClientMessage )
      {
       if ( CommandEvent.xclient.message_type == MagellanCommandEvent )
        {
         switch( CommandEvent.xclient.data.s[2] )
          {
           case NoCommandMessage : break;

	   case CommandMessageApplicationWindowAlternate : 
           case CommandMessageApplicationWindow :
            XFocusWindow = XUseWindow = (CommandEvent.xclient.data.s[0]<<16) |
                                        (CommandEvent.xclient.data.s[1]);
            if ( XFocusWindow != XFocusWindowDisplay )
             printf("%s = %s\n", LangString( LANG_SENDWINDOW ), 
	                       XWindowString( XFocusWindow ) );
            XFocusWindowDisplay = XFocusWindow;
            break;

	   case CommandMessageApplicationSensitivity :
           case CommandMessageApplicationSensitivityAlternate :
	    MagellanStatus.ApplicationSensitivity.Short[0] = CommandEvent.xclient.data.s[0];
	    MagellanStatus.ApplicationSensitivity.Short[1] = CommandEvent.xclient.data.s[1];
	    MagellanSetStatus( display, MagellanStatusWindow, &MagellanStatus,
			       MagellanCommandEvent, MagellanWindow );
	    break;
	    
 	   case CommandMessageStatusWindow :
            MagellanStatusWindow = (CommandEvent.xclient.data.s[0]<<16) |
	                           (CommandEvent.xclient.data.s[1]);    
	    break;

	   
           default : break;
          };
        };
       if ( XDriverDebug )
	XDebugClientMessage( display, &CommandEvent, "Driver" );
      }; 
    };

   switch( MagellanBuffer[0] )
    {
     case 'k' : MagellanKeyboardEvent( display, MagellanBuffer, MagellanWindow );
                MagellanStatus.Keyboard = Keyboard;
		if ( MagellanStatusWindow != InputFocus )
 		 MagellanSetStatus( display, MagellanStatusWindow, &MagellanStatus,
				    MagellanCommandEvent, MagellanWindow );
		break;

     case 'd' : MagellanDataEvent( display, MagellanBuffer, MagellanWindow );
		break;

     case 'c' : if ( MagellanModeChange == NO )
		 if ( MagellanBuffer[1] != MagellanModeCompress[1] )
                  while(!MagellanTransmit(MagellanHandle, MagellanModeCompress))
                   ;
		MagellanStatus.Mode = MagellanBuffer[1] & 0x0F;
                MagellanStatus.Compress = MagellanBuffer[2] & 0x0F;
		if ( MagellanStatusWindow != InputFocus )
		 MagellanSetStatus( display, MagellanStatusWindow, &MagellanStatus,
				    MagellanCommandEvent, MagellanWindow );
                break;

     case 'm' : if ( MagellanModeChange == NO )
		 if ( MagellanBuffer[1] != MagellanMode[1] )
                  while(!MagellanTransmit(MagellanHandle, MagellanMode))
                   ;
		MagellanStatus.Mode = MagellanBuffer[1] & 0x0F;
		if ( MagellanStatusWindow != InputFocus )
		 MagellanSetStatus( display, MagellanStatusWindow, &MagellanStatus,
				    MagellanCommandEvent, MagellanWindow );
                break;

     case 'q' : if ( MagellanSensitivityChange == NO )
		 if ( (MagellanBuffer[1] != MagellanSensitivity[1]) ||
		      (MagellanBuffer[2] != MagellanSensitivity[2]) )
                  while(!MagellanTransmit( MagellanHandle, MagellanSensitivity) )
                   ;
		MagellanStatus.SensTra = MagellanBuffer[1] & 0x0F;
		MagellanStatus.SensRot = MagellanBuffer[2] & 0x0F;
		if ( MagellanStatusWindow != InputFocus )
		 MagellanSetStatus( display, MagellanStatusWindow, &MagellanStatus,
				    MagellanCommandEvent, MagellanWindow );
      		break;

     case 'n' : if ( MagellanNullRadiusChange == NO )
		 if ( MagellanBuffer[1] != MagellanNullRadius[1] )
                  while(!MagellanTransmit( MagellanHandle, MagellanNullRadius ) )
                   ;
		MagellanStatus.NullRadius = MagellanBuffer[1] & 0x0F;
		if ( MagellanStatusWindow != InputFocus )
  		MagellanSetStatus( display, MagellanStatusWindow, &MagellanStatus,
				   MagellanCommandEvent, MagellanWindow );
		break;
    };
  }; 
 
 MagellanClose( MagellanHandle );
 return TRUE; 
} 
